#include <mega32.h>
#include <stdio.h>
#include <stdlib.h>
#include <delay.h>
#include <alcd.h>
#include <string.h>
#include "Menu.h"
#include "Alarm.h"
#include "DS1307.h"
#include "Keyboard.h"


const char Week_Days[7][20]={"Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"};
const char DEC_Format[]="%02d";
const char Hex_Format[]="%02x";

const char STR_0_ON[] ="   ON";
const char STR_1_ON[] ="  >ON";
const char STR_0_OFF[]="   OFF";
const char STR_1_OFF[]="  >OFF";

const char STR_SPACE[]    =" ";
const char STR_TWO_DOT[]  =":";
const char STR_ONE_SHIFT[]=">";
const char STR_20[]       ="20";
const char STR_SLASH[]    ="/";

extern const char  Alarm_1;
extern const char  Alarm_2;
extern const char  Alarm_3;
extern const char  Alarm_4;
extern const char  Alarm_5;
extern const char  Alarm_6;
extern const char  Alarm_7;
extern const char  Alarm_8;
extern const char  Alarm_9;
extern const char  Alarm_10;


void Menu_Set_Time(void)
{
  unsigned char S=0,M=0,H=0;  
  unsigned char *Pointer=&H; 
  char str_S[4],str_M[4],str_H[4],Time[12];  
  char Pressed_Key,T=1,Locate=0;  
  Time[0]='\0';    
  LCD_WR_STRF(0,0,"Set Time");  
  sprintf(str_S,DEC_Format,S);
  sprintf(str_M,DEC_Format,M);
  sprintf(str_H,DEC_Format,H);  
  strcatf(Time,STR_ONE_SHIFT);
  strcat(Time,str_H); 
  strcatf(Time,STR_TWO_DOT);
  strcat(Time,str_M); 
  strcatf(Time,STR_TWO_DOT);
  strcat(Time,str_S);   
  LCD_WR_STR(0,1,Time);
  while(T)
  {
    delay_ms(250);
    Pressed_Key = Keyboard_Get_Key();  
    switch(Pressed_Key)
    {
      case Key_UP:
      {   
        (*Pointer)++; 
        if(Locate==0)
        {
          if((*Pointer)>23)
            (*Pointer)=23;
        }
        if(Locate==1)
        {
          if((*Pointer)>59)
           (*Pointer)=59;
        }
        if(Locate==2)
        {
          if((*Pointer)>59) 
           (*Pointer)=59;
        }
        sprintf(str_S,DEC_Format,S);
        sprintf(str_M,DEC_Format,M);
        sprintf(str_H,DEC_Format,H);  
        Time[0]='\0';
        if(Locate==0)
        {
          strcatf(Time,STR_ONE_SHIFT);
          strcat(Time,str_H); 
          strcatf(Time,STR_TWO_DOT);
          strcat(Time,str_M); 
          strcatf(Time,STR_TWO_DOT);
          strcat(Time,str_S);   
          LCD_WR_STR(0,1,Time);     
          break;
        }
        if(Locate==1)
        { 
          strcatf(Time,STR_SPACE);
          strcat(Time,str_H); 
          strcatf(Time,STR_ONE_SHIFT);
          strcat(Time,str_M); 
          strcatf(Time,STR_TWO_DOT);
          strcat(Time,str_S);   
          LCD_WR_STR(0,1,Time); 
          break; 
        } 
        if(Locate==2)
        {
          strcatf(Time,STR_SPACE);
          strcat(Time,str_H); 
          strcatf(Time,STR_TWO_DOT);
          strcat(Time,str_M); 
          strcatf(Time,STR_ONE_SHIFT);
          strcat(Time,str_S);   
          LCD_WR_STR(0,1,Time);  
          break;
        }
        break;
      }
      case Key_Down:
      { 
        (*Pointer)--; 
        if(Locate==0)
        {
          if((*Pointer)>23)
            (*Pointer)=0;
        }
        if(Locate==1)
        {
          if((*Pointer)>59)
           (*Pointer)=0;
        }
        if(Locate==2)
        {
          if((*Pointer)>59) 
           (*Pointer)=0;
        } 
        sprintf(str_S,DEC_Format,S);
        sprintf(str_M,DEC_Format,M);
        sprintf(str_H,DEC_Format,H);  
        Time[0]='\0';
        if(Locate==0)
        {
          strcatf(Time,STR_ONE_SHIFT);
          strcat(Time,str_H); 
          strcatf(Time,STR_TWO_DOT);
          strcat(Time,str_M); 
          strcatf(Time,STR_TWO_DOT);
          strcat(Time,str_S);   
          LCD_WR_STR(0,1,Time);     
          break;
        }
        if(Locate==1)
        {
          strcatf(Time,STR_SPACE);
          strcat(Time,str_H); 
          strcatf(Time,STR_ONE_SHIFT);
          strcat(Time,str_M); 
          strcatf(Time,STR_TWO_DOT);
          strcat(Time,str_S);   
          LCD_WR_STR(0,1,Time); 
          break; 
        } 
        if(Locate==2)
        {
          strcatf(Time,STR_SPACE);
          strcat(Time,str_H); 
          strcatf(Time,STR_TWO_DOT);
          strcat(Time,str_M); 
          strcatf(Time,STR_ONE_SHIFT);
          strcat(Time,str_S);   
          LCD_WR_STR(0,1,Time);  
          break;
        }
        break;
      }
      case Key_Right:
      {  
        sprintf(str_S,DEC_Format,S);
        sprintf(str_M,DEC_Format,M);
        sprintf(str_H,DEC_Format,H); 
        Time[0]='\0'; 
        Locate++; 
        if(Locate>2)
          Locate=2;
        if(Locate==0)
        {
          strcatf(Time,STR_ONE_SHIFT);
          strcat(Time,str_H); 
          strcatf(Time,STR_TWO_DOT);
          strcat(Time,str_M); 
          strcatf(Time,STR_TWO_DOT);
          strcat(Time,str_S);   
          LCD_WR_STR(0,1,Time);       
          Pointer=&H; 
          break;
        }
        if(Locate==1)
        {
          strcatf(Time,STR_SPACE);
          strcat(Time,str_H); 
          strcatf(Time,STR_ONE_SHIFT);
          strcat(Time,str_M); 
          strcatf(Time,STR_TWO_DOT);
          strcat(Time,str_S);   
          LCD_WR_STR(0,1,Time);   
          Pointer=&M; 
          break;
        } 
        if(Locate==2)
        {
          strcatf(Time,STR_SPACE);
          strcat(Time,str_H); 
          strcatf(Time,STR_TWO_DOT);
          strcat(Time,str_M); 
          strcatf(Time,STR_ONE_SHIFT);
          strcat(Time,str_S);   
          LCD_WR_STR(0,1,Time);      
          Pointer=&S;   
          break; 
        }
        break;
      }
      case Key_Left:
      { 
        sprintf(str_S,DEC_Format,S);
        sprintf(str_M,DEC_Format,M);
        sprintf(str_H,DEC_Format,H);  
        Time[0]='\0'; 
        Locate--; 
        if(Locate>2)
          Locate=0;  
        if(Locate==0)
        {
          strcatf(Time,STR_ONE_SHIFT);
          strcat(Time,str_H); 
          strcatf(Time,STR_TWO_DOT);
          strcat(Time,str_M); 
          strcatf(Time,STR_TWO_DOT);
          strcat(Time,str_S);    
          LCD_WR_STR(0,1,Time);      
          Pointer=&H;   
          break;
        }
        if(Locate==1)
        {
          strcatf(Time,STR_SPACE);
          strcat(Time,str_H); 
          strcatf(Time,STR_ONE_SHIFT);
          strcat(Time,str_M); 
          strcatf(Time,STR_TWO_DOT);
          strcat(Time,str_S);    
          LCD_WR_STR(0,1,Time);    
          Pointer=&M;  
          break;
        } 
        if(Locate==2)
        {
          strcatf(Time,STR_SPACE);
          strcat(Time,str_H); 
          strcatf(Time,STR_TWO_DOT);
          strcat(Time,str_M); 
          strcatf(Time,STR_ONE_SHIFT);
          strcat(Time,str_S);   
          LCD_WR_STR(0,1,Time);    
          Pointer=&S;   
          break; 
        } 
        break;
      }
      case Key_Menu:
      { 
        break;
      }
      case Key_OK:
      {  
        RTC_DS1307_Set_Time(H,M,S);
        LCD_WR_STRF(0,1,"Save Time OK");
        delay_ms(1000); 
        LCD_WR_STRF(0,1,"");  
        T=0;
        break;
      }
      case Key_Return:
      { 
        T=0;
        break;
      }
      default:
      {  
        break;
      } 
    } 
  }
}

void Menu_Set_Date(void)
{
  unsigned char Y=0,M=0,D=0;  
  unsigned char *Pointer=&Y; 
  char str_Y[6],str_M[4],str_D[4],Date[14];  
  char Pressed_Key,T=1,Locate=0;  
  Date[0]='\0';    
  LCD_WR_STRF(0,0,"Set Date"); 
  sprintf(str_D,DEC_Format,D);
  sprintf(str_M,DEC_Format,M);
  sprintf(str_Y,DEC_Format,Y); 
  strcatf(Date,STR_ONE_SHIFT);
  strcatf(Date,STR_20);
  strcat(Date,str_Y); 
  strcatf(Date,STR_SLASH);
  strcat(Date,str_M); 
  strcatf(Date,STR_SLASH);
  strcat(Date,str_D);   
  LCD_WR_STR(0,1,Date);
  while(T)
  {
    delay_ms(250);
    Pressed_Key = Keyboard_Get_Key();  
    switch(Pressed_Key)
    {
      case Key_UP:
      {   
        (*Pointer)++; 
        if(Locate==0)
        {
          if((*Pointer)>99)
            (*Pointer)=99;
        }
        if(Locate==1)
        {
          if((*Pointer)>12)
           (*Pointer)=12;
        }
        if(Locate==2)
        {
          if((*Pointer)>31) 
           (*Pointer)=31;
        }
        sprintf(str_D,DEC_Format,D);
        sprintf(str_M,DEC_Format,M);
        sprintf(str_Y,DEC_Format,Y);  
        Date[0]='\0';
        if(Locate==0)
        {
          strcatf(Date,STR_ONE_SHIFT);
          strcatf(Date,STR_20);
          strcat(Date,str_Y); 
          strcatf(Date,STR_SLASH);
          strcat(Date,str_M); 
          strcatf(Date,STR_SLASH);
          strcat(Date,str_D);   
          LCD_WR_STR(0,1,Date);     
          break;
        }
        if(Locate==1)
        {
          strcatf(Date,STR_SPACE);
          strcatf(Date,STR_20);
          strcat(Date,str_Y); 
          strcatf(Date,STR_ONE_SHIFT);
          strcat(Date,str_M); 
          strcatf(Date,STR_SLASH);
          strcat(Date,str_D);   
          LCD_WR_STR(0,1,Date); 
          break; 
        } 
        if(Locate==2)
        {
          strcatf(Date,STR_SPACE);
          strcatf(Date,STR_20);
          strcat(Date,str_Y); 
          strcatf(Date,STR_SLASH);
          strcat(Date,str_M); 
          strcatf(Date,STR_ONE_SHIFT);
          strcat(Date,str_D);   
          LCD_WR_STR(0,1,Date);  
          break;
        }
        break;
      }
      case Key_Down:
      { 
        (*Pointer)--; 
        if(Locate==0)
        {
          if((*Pointer)>99)
            (*Pointer)=0;
        }
        if(Locate==1)
        {
          if((*Pointer)>12)
           (*Pointer)=0;
        }
        if(Locate==2)
        {
          if((*Pointer)>31) 
           (*Pointer)=0;
        } 
        sprintf(str_D,DEC_Format,D);
        sprintf(str_M,DEC_Format,M);
        sprintf(str_Y,DEC_Format,Y);  
        Date[0]='\0';
        if(Locate==0)
        {
          strcatf(Date,STR_ONE_SHIFT);
          strcatf(Date,STR_20);
          strcat(Date,str_Y); 
          strcatf(Date,STR_SLASH);
          strcat(Date,str_M); 
          strcatf(Date,STR_SLASH);
          strcat(Date,str_D);   
          LCD_WR_STR(0,1,Date);    
          break;
        }
        if(Locate==1)
        {
          strcatf(Date,STR_SPACE);
          strcatf(Date,STR_20);
          strcat(Date,str_Y); 
          strcatf(Date,STR_ONE_SHIFT);
          strcat(Date,str_M); 
          strcatf(Date,STR_SLASH);
          strcat(Date,str_D);   
          LCD_WR_STR(0,1,Date); 
          break; 
        } 
        if(Locate==2)
        {
          strcatf(Date,STR_SPACE);
          strcatf(Date,STR_20);
          strcat(Date,str_Y); 
          strcatf(Date,STR_SLASH);
          strcat(Date,str_M); 
          strcatf(Date,STR_ONE_SHIFT);
          strcat(Date,str_D);   
          LCD_WR_STR(0,1,Date);  
          break;
        }
        break;
      }
      case Key_Right:
      {  
        sprintf(str_D,DEC_Format,D);
        sprintf(str_M,DEC_Format,M);
        sprintf(str_Y,DEC_Format,Y); 
        Date[0]='\0'; 
        Locate++; 
        if(Locate>2)
          Locate=2;
        if(Locate==0)
        {
          strcatf(Date,STR_ONE_SHIFT);
          strcatf(Date,STR_20);
          strcat(Date,str_Y); 
          strcatf(Date,STR_SLASH);
          strcat(Date,str_M); 
          strcatf(Date,STR_SLASH);
          strcat(Date,str_D);   
          LCD_WR_STR(0,1,Date);       
          Pointer=&Y; 
          break;
        }
        if(Locate==1)
        {
          strcatf(Date,STR_SPACE);
          strcatf(Date,STR_20);
          strcat(Date,str_Y); 
          strcatf(Date,STR_ONE_SHIFT);
          strcat(Date,str_M); 
          strcatf(Date,STR_SLASH);
          strcat(Date,str_D);   
          LCD_WR_STR(0,1,Date);    
          Pointer=&M; 
          break;
        } 
        if(Locate==2)
        {
          strcatf(Date,STR_SPACE);
          strcatf(Date,STR_20);
          strcat(Date,str_Y); 
          strcatf(Date,STR_SLASH);
          strcat(Date,str_M); 
          strcatf(Date,STR_ONE_SHIFT);
          strcat(Date,str_D);   
          LCD_WR_STR(0,1,Date);       
          Pointer=&D;   
          break; 
        }
        break;
      }
      case Key_Left:
      { 
        sprintf(str_D,DEC_Format,D);
        sprintf(str_M,DEC_Format,M);
        sprintf(str_Y,DEC_Format,Y);  
        Date[0]='\0'; 
        Locate--; 
        if(Locate>2)
          Locate=0;  
        if(Locate==0)
        {
          strcatf(Date,STR_ONE_SHIFT);
          strcatf(Date,STR_20);
          strcat(Date,str_Y); 
          strcatf(Date,STR_SLASH);
          strcat(Date,str_M); 
          strcatf(Date,STR_SLASH);
          strcat(Date,str_D);   
          LCD_WR_STR(0,1,Date);      
          Pointer=&Y;   
          break;
        }
        if(Locate==1)
        {
          strcatf(Date,STR_SPACE);
          strcatf(Date,STR_20);
          strcat(Date,str_Y); 
          strcatf(Date,STR_ONE_SHIFT);
          strcat(Date,str_M); 
          strcatf(Date,STR_SLASH);
          strcat(Date,str_D);   
          LCD_WR_STR(0,1,Date);    
          Pointer=&M;  
          break;
        } 
        if(Locate==2)
        {
          strcatf(Date,STR_SPACE);
          strcatf(Date,STR_20);
          strcat(Date,str_Y); 
          strcatf(Date,STR_SLASH);
          strcat(Date,str_M); 
          strcatf(Date,STR_ONE_SHIFT);
          strcat(Date,str_D);   
          LCD_WR_STR(0,1,Date);    
          Pointer=&D;   
          break; 
        } 
        break;
      }
      case Key_Menu:
      { 
        break;
      }
      case Key_OK:
      {  
        RTC_DS1307_Set_Date(Y,M,D);
        LCD_WR_STRF(0,1,"Save Date OK");
        delay_ms(1000); 
        LCD_WR_STRF(0,1,"");  
        T=0;
        break;
      }
      case Key_Return:
      { 
        T=0;
        break;
      }
      default:
      {  
        break;
      } 
    } 
  }
}

void Menu_Set_DOW(void)
{
  unsigned char DOW=0;   
  char Pressed_Key,T=1;     
  LCD_WR_STRF(0,0,"Set Day");  
  LCD_WR_STRF(0,1,Week_Days[DOW]);
  while(T)
  {
    delay_ms(250);
    Pressed_Key = Keyboard_Get_Key();  
    switch(Pressed_Key)
    {
      case Key_UP:
      {   
        DOW++; 
        if(DOW>=7)
        {
          DOW=6;
        }
        LCD_WR_STRF(0,1,Week_Days[DOW]);
        break;
      }
      case Key_Down:
      { 
        DOW--; 
        if(DOW>=7)
        {
          DOW=0;
        } 
        LCD_WR_STRF(0,1,Week_Days[DOW]);
        break;
      }
      case Key_Right:
      {  
        break;
      }
      case Key_Left:
      { 
        break;
      }
      case Key_Menu:
      { 
        break;
      }
      case Key_OK:
      {  
        RTC_DS1307_Set_DOW(DOW+1);
        LCD_WR_STRF(0,1,"Save Day OK");
        delay_ms(1000); 
        T=0;
        break;
      }
      case Key_Return:
      { 
        T=0;
        break;
      }
      default:
      {  
        break;
      } 
    } 
  }
}

void Menu_Set_Alarm(void)
{
  Alarm A;
  unsigned char S=0,M=0,H=0,E_D=0,Alarm_ID=8;  
  unsigned char *Pointer=&H; 
  char str_S[4],str_M[4],str_H[4],Alarm_Time[20];  
  char Pressed_Key,T=1,Locate=0;  
  Alarm_Time[0]='\0';    
  LCD_WR_STRF(0,0,"Set Alarm 1");  
  Alarm_Read(&A,Alarm_ID); 
  E_D = A.Enable_Disable;
  H   = A.Hour;
  M   = A.Minute;
  S   = A.Second;  
  sprintf(str_S,DEC_Format,S);
  sprintf(str_M,DEC_Format,M);
  sprintf(str_H,DEC_Format,H); 
  Alarm_Time[0]='\0';  
  strcatf(Alarm_Time,STR_ONE_SHIFT);
  strcat(Alarm_Time,str_H); 
  strcatf(Alarm_Time,STR_TWO_DOT);
  strcat(Alarm_Time,str_M); 
  strcatf(Alarm_Time,STR_TWO_DOT);
  strcat(Alarm_Time,str_S);
  if(E_D==0)
    strcatf(Alarm_Time,STR_0_OFF);
  if(E_D==1)
    strcatf(Alarm_Time,STR_0_ON);  
                   
  LCD_WR_STR(0,1,Alarm_Time);
  while(T)
  {
    delay_ms(250);
    Pressed_Key = Keyboard_Get_Key();  
    switch(Pressed_Key)
    {
      case Key_UP:
      {   
        (*Pointer)++; 
        if(Locate==0)
        {
          if((*Pointer)>23)
            (*Pointer)=23;
        }
        if(Locate==1)
        {
          if((*Pointer)>59)
           (*Pointer)=59;
        }
        if(Locate==2)
        {
          if((*Pointer)>59) 
           (*Pointer)=59;
        } 
        if(Locate==3)
        {
          if((*Pointer)>1) 
           (*Pointer)=1;
        }
        sprintf(str_S,DEC_Format,S);
        sprintf(str_M,DEC_Format,M);
        sprintf(str_H,DEC_Format,H);  
        Alarm_Time[0]='\0';
        if(Locate==0)
        {
          strcatf(Alarm_Time,STR_ONE_SHIFT);
          strcat(Alarm_Time,str_H); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_M); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_S);  
          if(E_D==0)
            strcatf(Alarm_Time,STR_0_OFF);
          if(E_D==1)
            strcatf(Alarm_Time,STR_0_ON);
             
          LCD_WR_STR(0,1,Alarm_Time);     
          break;
        }
        if(Locate==1)
        { 
          strcatf(Alarm_Time,STR_SPACE);
          strcat(Alarm_Time,str_H); 
          strcatf(Alarm_Time,STR_ONE_SHIFT);
          strcat(Alarm_Time,str_M); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_S);  
          if(E_D==0)
            strcatf(Alarm_Time,STR_0_OFF);
          if(E_D==1)
            strcatf(Alarm_Time,STR_0_ON);
             
          LCD_WR_STR(0,1,Alarm_Time); 
          break; 
        } 
        if(Locate==2)
        {
          strcatf(Alarm_Time,STR_SPACE);
          strcat(Alarm_Time,str_H); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_M); 
          strcatf(Alarm_Time,STR_ONE_SHIFT);
          strcat(Alarm_Time,str_S);   
          if(E_D==0)
            strcatf(Alarm_Time,STR_0_OFF);
          if(E_D==1)
            strcatf(Alarm_Time,STR_0_ON);
            
          LCD_WR_STR(0,1,Alarm_Time);  
          break;
        } 
        if(Locate==3)
        {
          strcatf(Alarm_Time,STR_SPACE);
          strcat(Alarm_Time,str_H); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_M); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_S);
          if(E_D==0)
            strcatf(Alarm_Time,STR_1_OFF);
          if(E_D==1)
            strcatf(Alarm_Time,STR_1_ON);  
             
          LCD_WR_STR(0,1,Alarm_Time);       
          break;
        }
        break;
      }
      case Key_Down:
      { 
        (*Pointer)--; 
        if(Locate==0)
        {
          if((*Pointer)>23)
            (*Pointer)=0;
        }
        if(Locate==1)
        {
          if((*Pointer)>59)
           (*Pointer)=0;
        }
        if(Locate==2)
        {
          if((*Pointer)>59) 
           (*Pointer)=0;
        } 
        if(Locate==3)
        {
          if((*Pointer)>1) 
           (*Pointer)=0;
        }
        sprintf(str_S,DEC_Format,S);
        sprintf(str_M,DEC_Format,M);
        sprintf(str_H,DEC_Format,H);  
        Alarm_Time[0]='\0';
        if(Locate==0)
        {
          strcatf(Alarm_Time,STR_ONE_SHIFT);
          strcat(Alarm_Time,str_H); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_M); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_S);  
          if(E_D==0)
            strcatf(Alarm_Time,STR_0_OFF);
          if(E_D==1)
            strcatf(Alarm_Time,STR_0_ON);
             
          LCD_WR_STR(0,1,Alarm_Time);     
          break;
        }
        if(Locate==1)
        {
          strcatf(Alarm_Time,STR_SPACE);
          strcat(Alarm_Time,str_H); 
          strcatf(Alarm_Time,STR_ONE_SHIFT);
          strcat(Alarm_Time,str_M); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_S);   
          if(E_D==0)
            strcatf(Alarm_Time,STR_0_OFF);
          if(E_D==1)
            strcatf(Alarm_Time,STR_0_ON);
            
          LCD_WR_STR(0,1,Alarm_Time); 
          break; 
        } 
        if(Locate==2)
        {
          strcatf(Alarm_Time,STR_SPACE);
          strcat(Alarm_Time,str_H); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_M); 
          strcatf(Alarm_Time,STR_ONE_SHIFT);
          strcat(Alarm_Time,str_S);   
          if(E_D==0)
            strcatf(Alarm_Time,STR_0_OFF);
          if(E_D==1)
            strcatf(Alarm_Time,STR_0_ON);
            
          LCD_WR_STR(0,1,Alarm_Time);  
          break;
        }
        if(Locate==3)
        {
          strcatf(Alarm_Time,STR_SPACE);
          strcat(Alarm_Time,str_H); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_M); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_S);
          if(E_D==0)
            strcatf(Alarm_Time,STR_1_OFF);
          if(E_D==1)
            strcatf(Alarm_Time,STR_1_ON);  
             
          LCD_WR_STR(0,1,Alarm_Time);       
          break;
        }
        break;
      }
      case Key_Right:
      {  
        sprintf(str_S,DEC_Format,S);
        sprintf(str_M,DEC_Format,M);
        sprintf(str_H,DEC_Format,H); 
        Alarm_Time[0]='\0'; 
        Locate++; 
        if(Locate>3)
          Locate=3;
        if(Locate==0)
        {
          strcatf(Alarm_Time,STR_ONE_SHIFT);
          strcat(Alarm_Time,str_H); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_M); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_S);
          if(E_D==0)
            strcatf(Alarm_Time,STR_0_OFF);
          if(E_D==1)
            strcatf(Alarm_Time,STR_0_ON);  
             
          LCD_WR_STR(0,1,Alarm_Time);       
          Pointer=&H; 
          break;
        }
        if(Locate==1)
        {
          strcatf(Alarm_Time,STR_SPACE);
          strcat(Alarm_Time,str_H); 
          strcatf(Alarm_Time,STR_ONE_SHIFT);
          strcat(Alarm_Time,str_M); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_S); 
          if(E_D==0)
            strcatf(Alarm_Time,STR_0_OFF);
          if(E_D==1)
            strcatf(Alarm_Time,STR_0_ON);
              
          LCD_WR_STR(0,1,Alarm_Time);   
          Pointer=&M; 
          break;
        } 
        if(Locate==2)
        {
          strcatf(Alarm_Time,STR_SPACE);
          strcat(Alarm_Time,str_H); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_M); 
          strcatf(Alarm_Time,STR_ONE_SHIFT);
          strcat(Alarm_Time,str_S);  
          if(E_D==0)
            strcatf(Alarm_Time,STR_0_OFF);
          if(E_D==1)
            strcatf(Alarm_Time,STR_0_ON);
             
          LCD_WR_STR(0,1,Alarm_Time);      
          Pointer=&S;   
          break; 
        }
        if(Locate==3)
        {
          strcatf(Alarm_Time,STR_SPACE);
          strcat(Alarm_Time,str_H); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_M); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_S);
          if(E_D==0)
            strcatf(Alarm_Time,STR_1_OFF);
          if(E_D==1)
            strcatf(Alarm_Time,STR_1_ON);  
             
          LCD_WR_STR(0,1,Alarm_Time);       
          Pointer=&E_D; 
          break;
        }
        break;
      }
      case Key_Left:
      { 
        sprintf(str_S,DEC_Format,S);
        sprintf(str_M,DEC_Format,M);
        sprintf(str_H,DEC_Format,H);  
        Alarm_Time[0]='\0'; 
        Locate--; 
        if(Locate>2)
          Locate=0;  
        if(Locate==0)
        {
          strcatf(Alarm_Time,STR_ONE_SHIFT);
          strcat(Alarm_Time,str_H); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_M); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_S);    
          if(E_D==0)
            strcatf(Alarm_Time,STR_0_OFF);
          if(E_D==1)
            strcatf(Alarm_Time,STR_0_ON);
            
          LCD_WR_STR(0,1,Alarm_Time);      
          Pointer=&H;   
          break;
        }
        if(Locate==1)
        {
          strcatf(Alarm_Time,STR_SPACE);
          strcat(Alarm_Time,str_H); 
          strcatf(Alarm_Time,STR_ONE_SHIFT);
          strcat(Alarm_Time,str_M); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_S);  
          if(E_D==0)
            strcatf(Alarm_Time,STR_0_OFF);
          if(E_D==1)
            strcatf(Alarm_Time,STR_0_ON);
              
          LCD_WR_STR(0,1,Alarm_Time);    
          Pointer=&M;  
          break;
        } 
        if(Locate==2)
        {
          strcatf(Alarm_Time,STR_SPACE);
          strcat(Alarm_Time,str_H); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_M); 
          strcatf(Alarm_Time,STR_ONE_SHIFT);
          strcat(Alarm_Time,str_S);  
          if(E_D==0)
            strcatf(Alarm_Time,STR_0_OFF);
          if(E_D==1)
            strcatf(Alarm_Time,STR_0_ON);
             
          LCD_WR_STR(0,1,Alarm_Time);    
          Pointer=&S;   
          break; 
        }
        if(Locate==0)
        {
          strcatf(Alarm_Time,STR_SPACE);
          strcat(Alarm_Time,str_H); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_M); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_S);    
          if(E_D==0)
            strcatf(Alarm_Time,STR_1_OFF);
          if(E_D==1)
            strcatf(Alarm_Time,STR_1_ON);
            
          LCD_WR_STR(0,1,Alarm_Time);      
          Pointer=&E_D;   
          break;
        } 
        break;
      }
      case Key_Menu:
      { 
        Alarm_ID+=4; 
        if(Alarm_ID>44) 
        {
          Alarm_ID=8; 
        }
        if(Alarm_ID==Alarm_1)
        {
          LCD_WR_STRF(0,0,"Set Alarm 1"); 
          Alarm_Read(&A,Alarm_ID); 
          E_D = A.Enable_Disable;
          H   = A.Hour;
          M   = A.Minute;
          S   = A.Second;  
          sprintf(str_S,DEC_Format,S);
          sprintf(str_M,DEC_Format,M);
          sprintf(str_H,DEC_Format,H); 
          Alarm_Time[0]='\0';  
          strcatf(Alarm_Time,STR_ONE_SHIFT);
          strcat(Alarm_Time,str_H); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_M); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_S);
          if(E_D==0)
            strcatf(Alarm_Time,STR_0_OFF);
          if(E_D==1)
            strcatf(Alarm_Time,STR_0_ON);  
             
          LCD_WR_STR(0,1,Alarm_Time);       
          Pointer=&H;
          Locate=0;
        }  
        if(Alarm_ID==Alarm_2) 
        {
          LCD_WR_STRF(0,0,"Set Alarm 2");   
          Alarm_Read(&A,Alarm_ID); 
          E_D = A.Enable_Disable;
          H   = A.Hour;
          M   = A.Minute;
          S   = A.Second;  
          sprintf(str_S,DEC_Format,S);
          sprintf(str_M,DEC_Format,M);
          sprintf(str_H,DEC_Format,H); 
          Alarm_Time[0]='\0';  
          strcatf(Alarm_Time,STR_ONE_SHIFT);
          strcat(Alarm_Time,str_H); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_M); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_S);
          if(E_D==0)
            strcatf(Alarm_Time,STR_0_OFF);
          if(E_D==1)
            strcatf(Alarm_Time,STR_0_ON);  
             
          LCD_WR_STR(0,1,Alarm_Time);       
          Pointer=&H;
          Locate=0;
        } 
        if(Alarm_ID==Alarm_3)
        {
          LCD_WR_STRF(0,0,"Set Alarm 3");  
          Alarm_Read(&A,Alarm_ID); 
          E_D = A.Enable_Disable;
          H   = A.Hour;
          M   = A.Minute;
          S   = A.Second;  
          sprintf(str_S,DEC_Format,S);
          sprintf(str_M,DEC_Format,M);
          sprintf(str_H,DEC_Format,H); 
          Alarm_Time[0]='\0';  
          strcatf(Alarm_Time,STR_ONE_SHIFT);
          strcat(Alarm_Time,str_H); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_M); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_S);
          if(E_D==0)
            strcatf(Alarm_Time,STR_0_OFF);
          if(E_D==1)
            strcatf(Alarm_Time,STR_0_ON);  
             
          LCD_WR_STR(0,1,Alarm_Time);       
          Pointer=&H;
          Locate=0;
        }  
        if(Alarm_ID==Alarm_4)  
        {
          LCD_WR_STRF(0,0,"Set Alarm 4"); 
          Alarm_Read(&A,Alarm_ID); 
          E_D = A.Enable_Disable;
          H   = A.Hour;
          M   = A.Minute;
          S   = A.Second;    
          sprintf(str_S,DEC_Format,S);
          sprintf(str_M,DEC_Format,M);
          sprintf(str_H,DEC_Format,H); 
          Alarm_Time[0]='\0';  
          strcatf(Alarm_Time,STR_ONE_SHIFT);
          strcat(Alarm_Time,str_H); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_M); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_S);
          if(E_D==0)
            strcatf(Alarm_Time,STR_0_OFF);
          if(E_D==1)
            strcatf(Alarm_Time,STR_0_ON);  
             
          LCD_WR_STR(0,1,Alarm_Time);       
          Pointer=&H;
          Locate=0;
        }  
        if(Alarm_ID==Alarm_5)  
        {
          LCD_WR_STRF(0,0,"Set Alarm 5"); 
          Alarm_Read(&A,Alarm_ID); 
          E_D = A.Enable_Disable;
          H   = A.Hour;
          M   = A.Minute;
          S   = A.Second;
          sprintf(str_S,DEC_Format,S);
          sprintf(str_M,DEC_Format,M);
          sprintf(str_H,DEC_Format,H); 
          Alarm_Time[0]='\0';  
          strcatf(Alarm_Time,STR_ONE_SHIFT);
          strcat(Alarm_Time,str_H); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_M); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_S);
          if(E_D==0)
            strcatf(Alarm_Time,STR_0_OFF);
          if(E_D==1)
            strcatf(Alarm_Time,STR_0_ON);  
             
          LCD_WR_STR(0,1,Alarm_Time);       
          Pointer=&H;
          Locate=0;
        } 
        if(Alarm_ID==Alarm_6)
        {
          LCD_WR_STRF(0,0,"Set Alarm 6");    
          Alarm_Read(&A,Alarm_ID); 
          E_D = A.Enable_Disable;
          H   = A.Hour;
          M   = A.Minute;
          S   = A.Second;  
          sprintf(str_S,DEC_Format,S);
          sprintf(str_M,DEC_Format,M);
          sprintf(str_H,DEC_Format,H); 
          Alarm_Time[0]='\0';  
          strcatf(Alarm_Time,STR_ONE_SHIFT);
          strcat(Alarm_Time,str_H); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_M); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_S);
          if(E_D==0)
            strcatf(Alarm_Time,STR_0_OFF);
          if(E_D==1)
            strcatf(Alarm_Time,STR_0_ON);  
             
          LCD_WR_STR(0,1,Alarm_Time);       
          Pointer=&H;
          Locate=0;
        } 
        if(Alarm_ID==Alarm_7) 
        {
          LCD_WR_STRF(0,0,"Set Alarm 7");   
          Alarm_Read(&A,Alarm_ID); 
          E_D = A.Enable_Disable;
          H   = A.Hour;
          M   = A.Minute;
          S   = A.Second;  
          sprintf(str_S,DEC_Format,S);
          sprintf(str_M,DEC_Format,M);
          sprintf(str_H,DEC_Format,H); 
          Alarm_Time[0]='\0';  
          strcatf(Alarm_Time,STR_ONE_SHIFT);
          strcat(Alarm_Time,str_H); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_M); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_S);
          if(E_D==0)
            strcatf(Alarm_Time,STR_0_OFF);
          if(E_D==1)
            strcatf(Alarm_Time,STR_0_ON);  
             
          LCD_WR_STR(0,1,Alarm_Time);       
          Pointer=&H;
          Locate=0;
        }  
        if(Alarm_ID==Alarm_8)
        {
          LCD_WR_STRF(0,0,"Set Alarm 8");    
          Alarm_Read(&A,Alarm_ID); 
          E_D = A.Enable_Disable;
          H   = A.Hour;
          M   = A.Minute;
          S   = A.Second;    
          sprintf(str_S,DEC_Format,S);
          sprintf(str_M,DEC_Format,M);
          sprintf(str_H,DEC_Format,H); 
          Alarm_Time[0]='\0';  
          strcatf(Alarm_Time,STR_ONE_SHIFT);
          strcat(Alarm_Time,str_H); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_M); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_S);
          if(E_D==0)
            strcatf(Alarm_Time,STR_0_OFF);
          if(E_D==1)
            strcatf(Alarm_Time,STR_0_ON);  
             
          LCD_WR_STR(0,1,Alarm_Time);       
          Pointer=&H;
          Locate=0;
        }  
        if(Alarm_ID==Alarm_9) 
        {
          LCD_WR_STRF(0,0,"Set Alarm 9");   
          Alarm_Read(&A,Alarm_ID); 
          E_D = A.Enable_Disable;
          H   = A.Hour;
          M   = A.Minute;
          S   = A.Second;  
          sprintf(str_S,DEC_Format,S);
          sprintf(str_M,DEC_Format,M);
          sprintf(str_H,DEC_Format,H); 
          Alarm_Time[0]='\0';  
          strcatf(Alarm_Time,STR_ONE_SHIFT);
          strcat(Alarm_Time,str_H); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_M); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_S);
          if(E_D==0)
            strcatf(Alarm_Time,STR_0_OFF);
          if(E_D==1)
            strcatf(Alarm_Time,STR_0_ON);  
             
          LCD_WR_STR(0,1,Alarm_Time);       
          Pointer=&H;
          Locate=0;
        }  
        if(Alarm_ID==Alarm_10)
        {
          LCD_WR_STRF(0,0,"Set Alarm 10");      
          Alarm_Read(&A,Alarm_ID); 
          E_D = A.Enable_Disable;
          H   = A.Hour;
          M   = A.Minute;
          S   = A.Second;  
          sprintf(str_S,DEC_Format,S);
          sprintf(str_M,DEC_Format,M);
          sprintf(str_H,DEC_Format,H); 
          Alarm_Time[0]='\0';  
          strcatf(Alarm_Time,STR_ONE_SHIFT);
          strcat(Alarm_Time,str_H); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_M); 
          strcatf(Alarm_Time,STR_TWO_DOT);
          strcat(Alarm_Time,str_S);
          if(E_D==0)
            strcatf(Alarm_Time,STR_0_OFF);
          if(E_D==1)
            strcatf(Alarm_Time,STR_0_ON);  
             
          LCD_WR_STR(0,1,Alarm_Time);       
          Pointer=&H;
          Locate=0;
        }                   
        break;
      }
      case Key_OK:
      {  
        A.Enable_Disable = E_D;
        A.Hour           = H;
        A.Minute         = M;
        A.Second         = S;
        Alarm_Save(A,Alarm_ID);
        LCD_WR_STRF(0,1,"Save Alarm OK");
        delay_ms(1000); 
        LCD_WR_STRF(0,1,"");
        break;
      }
      case Key_Return:
      { 
        T=0;
        break;
      }
      default:
      {  
        break;
      } 
    } 
  }
}

