#include <mega32.h>
#include "TWI.h"

void TWI_Init(void)
{
  // TWI initialization
  // Bit Rate: 50.000 kHz
  TWBR=0x48;
  // Two Wire Bus Slave Address: 0x0
  // General Call Recognition: Off
  TWAR=0x00;
  // Generate Acknowledge Pulse: Off
  // TWI Interrupt: Off
  TWCR=0x04;
  TWSR=0x00;
}

void TWI_Start(void)
{
   TWCR= (1<<TWINT)|(1<<TWSTA)|(1<<TWEN);    
   while(!(TWCR & (1<<TWINT))); 
   while((TWSR & 0xF8)!= START); 
}

void TWI_ReStart(void)
{
   TWCR= (1<<TWINT)|(1<<TWSTA)|(1<<TWEN);    
   while(!(TWCR & (1<<TWINT))); 
   while((TWSR & 0xF8)!= RE_START);
}

void TWI_Stop(void)
{
   TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTO); 
}

void TWI_Write_Byte(unsigned char Data)
{
   TWDR = Data;
   TWCR = (1<<TWINT) | (1<<TWEN); 
   while(!(TWCR & (1<<TWINT)));
}

unsigned char TWI_Read_Byte(void)
{
  TWCR=(1<<TWINT)|(1<<TWEN);    
  while (!(TWCR & (1<<TWINT))); 
  //TestAck(MR_DATA_ACK);
  return TWDR;
}