#define START 0x08
#define RE_START 0x10

#define MT_SLA_ACK    0x18
#define MT_SLA_NOACK  0x20
#define MT_DATA_ACK   0x28
#define MT_DATA_NOACK 0x30

#define MR_SLA_ACK    0x40
#define MR_SLA_NOACK  0x48
#define MR_DATA_ACK   0x50
#define MR_DATA_NOACK 0x58

#define TestAck(Data)    while((TWSR & 0xF8)!= Data);

#define SetAck()      (TWCR|=(1<<TWEA)) 
#define SetNoAck()    (TWCR&=~(1<<TWEA)) 

void TWI_Init(void);
void TWI_Start(void);
void TWI_ReStart(void);
void TWI_Stop(void);
void TWI_Write_Byte(unsigned char Data);
unsigned char TWI_Read_Byte(void);