#include <mega32.h>
#include <alcd.h>
#include "Alarm.h"
#include "DS1307.h"
#include "Timer1.h"



unsigned char Hour,Minute,Second;
Alarm A1,A2,A3,A4,A5,A6,A7,A8,A9,A10;

extern const char  Alarm_1;
extern const char  Alarm_2;
extern const char  Alarm_3;
extern const char  Alarm_4;
extern const char  Alarm_5;
extern const char  Alarm_6;
extern const char  Alarm_7;
extern const char  Alarm_8;
extern const char  Alarm_9;
extern const char  Alarm_10;


interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
  #asm("cli")
  TCNT1H=0x85EE >> 8;
  TCNT1L=0x85EE & 0xff;
   
  RTC_DS1307_Get_Time(&Hour,&Minute,&Second);  
  Hour   = BCD_To_DEC(Hour);
  Minute = BCD_To_DEC(Minute);
  Second = BCD_To_DEC(Second);
  
  Alarm_Read(&A1,Alarm_1);
  Alarm_Read(&A2,Alarm_2);
  Alarm_Read(&A3,Alarm_3);
  Alarm_Read(&A4,Alarm_4);
  Alarm_Read(&A5,Alarm_5);
  Alarm_Read(&A6,Alarm_6);
  Alarm_Read(&A7,Alarm_7);
  Alarm_Read(&A8,Alarm_8);
  Alarm_Read(&A9,Alarm_9); 
  Alarm_Read(&A10,Alarm_10);
  
  RTC_DS1307_Display_Date_Time(); 
  
  if(A1.Enable_Disable!=0 && A1.Hour==Hour && A1.Minute==Minute && A1.Second==Second)
  {  
    LCD_WR_STRF(0,1,"Alarm 1 OK"); 
    LCD_WR_STRF(0,1,"");
  }  
  if(A2.Enable_Disable!=0 && A2.Hour==Hour && A2.Minute==Minute && A2.Second==Second)
  {  
    LCD_WR_STRF(0,1,"Alarm 2 OK"); 
    LCD_WR_STRF(0,1,"");
  }
  if(A3.Enable_Disable!=0 && A3.Hour==Hour && A3.Minute==Minute && A3.Second==Second)
  {  
    LCD_WR_STRF(0,1,"Alarm 3 OK");
    LCD_WR_STRF(0,1,"");
  }
  if(A4.Enable_Disable!=0 && A4.Hour==Hour && A4.Minute==Minute && A4.Second==Second)
  {   
    LCD_WR_STRF(0,1,"Alarm 4 OK");
    LCD_WR_STRF(0,1,"");
  }
  if(A5.Enable_Disable!=0 && A5.Hour==Hour && A5.Minute==Minute && A5.Second==Second)
  {  
    LCD_WR_STRF(0,1,"Alarm 5 OK");
    LCD_WR_STRF(0,1,"");
  }
  if(A6.Enable_Disable!=0 && A6.Hour==Hour && A6.Minute==Minute && A6.Second==Second)
  {   
    LCD_WR_STRF(0,1,"Alarm 6 OK");
    LCD_WR_STRF(0,1,"");
  }
  if(A7.Enable_Disable!=0 && A7.Hour==Hour && A7.Minute==Minute && A7.Second==Second)
  {
    LCD_WR_STRF(0,1,"Alarm 7 OK");
    LCD_WR_STRF(0,1,"");
  }
  if(A8.Enable_Disable!=0 && A8.Hour==Hour && A8.Minute==Minute && A8.Second==Second)
  {     
    LCD_WR_STRF(0,1,"Alarm 8 OK");  
    LCD_WR_STRF(0,1,"");
  }
  if(A9.Enable_Disable!=0 && A9.Hour==Hour && A9.Minute==Minute && A9.Second==Second)
  {  
    LCD_WR_STRF(0,1,"Alarm 9 OK");
    LCD_WR_STRF(0,1,"");
  }
  if(A10.Enable_Disable!=0 && A10.Hour==Hour && A10.Minute==Minute && A10.Second==Second)
  {  
    LCD_WR_STRF(0,1,"Alarm 10 OK");
    LCD_WR_STRF(0,1,"");
  } 
  #asm("sei")
}

void Timer1_Init(void)
{
  // Timer/Counter 1 initialization
  // Clock source: System Clock
  // Clock value: 31.250 kHz
  // Mode: Normal top=0xFFFF
  // OC1A output: Disconnected
  // OC1B output: Disconnected
  // Noise Canceler: Off
  // Input Capture on Falling Edge
  // Timer Period: 1 s
  // Timer1 Overflow Interrupt: On
  // Input Capture Interrupt: Off
  // Compare A Match Interrupt: Off
  // Compare B Match Interrupt: Off
  TCCR1A=(0<<COM1A1) | (0<<COM1A0) | (0<<COM1B1) | (0<<COM1B0) | (0<<WGM11) | (0<<WGM10);
  TCCR1B=(0<<ICNC1) | (0<<ICES1) | (0<<WGM13) | (0<<WGM12) | (1<<CS12) | (0<<CS11) | (0<<CS10);
  TCNT1H=0x85;
  TCNT1L=0xEE;
  ICR1H=0x00;
  ICR1L=0x00;
  OCR1AH=0x00;
  OCR1AL=0x00;
  OCR1BH=0x00;
  OCR1BL=0x00; 
  // Timer(s)/Counter(s) Interrupt(s) initialization
  TIMSK=(0<<OCIE2) | (0<<TOIE2) | (0<<TICIE1) | (0<<OCIE1A) | (0<<OCIE1B) | (1<<TOIE1) | (0<<OCIE0) | (0<<TOIE0);
}