#include <mega32.h>
#include "Usart.h"

void Usart_Init(void)
{
  // USART initialization
  // Communication Parameters: 8 Data, 1 Stop, No Parity
  // USART Receiver: On
  // USART Transmitter: On
  // USART Mode: Asynchronous
  // USART Baud Rate: 9600
  UCSRA=(0<<RXC) | (0<<TXC) | (0<<UDRE) | (0<<FE) | (0<<DOR) | (0<<UPE) | (0<<U2X) | (0<<MPCM);
  UCSRB=(0<<RXCIE) | (0<<TXCIE) | (0<<UDRIE) | (1<<RXEN) | (1<<TXEN) | (0<<UCSZ2) | (0<<RXB8) | (0<<TXB8);
  UCSRC=(1<<URSEL) | (0<<UMSEL) | (0<<UPM1) | (0<<UPM0) | (0<<USBS) | (1<<UCSZ1) | (1<<UCSZ0) | (0<<UCPOL);
  UBRRH=0x00;
  UBRRL=0x33;
}
void Usart_Write_Byte(unsigned char Data)
{
    // wait until UDR ready
	while(!(UCSRA & (1 << UDRE)));
	UDR = Data;    // send character 
}
void Usart_Write_String(char *str)
{
    //  loop until *s != NULL
	while (*str) 
    {
		Usart_Write_Byte(*str);
		str++;
	}  
}
unsigned char Usart_Read_Byte(void)
{
  // wait until Rec Byte 
  while((UCSRA & 0x80)!=0x80);
  return UDR;
}
