
;CodeVisionAVR C Compiler V3.12 Advanced
;(C) Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Build configuration    : Debug
;Chip type              : ATmega32
;Program type           : Application
;Clock frequency        : 8.000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 200 byte(s)
;Heap size              : 50 byte(s)
;Promote 'char' to 'int': Yes
;'char' is unsigned     : Yes
;8 bit enums            : Yes
;Global 'const' stored in FLASH: Yes
;Enhanced function parameter passing: Yes
;Enhanced core instructions: On
;Automatic register allocation for global variables: On
;Smart register allocation: On

	#define _MODEL_SMALL_

	#pragma AVRPART ADMIN PART_NAME ATmega32
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2048
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x085F
	.EQU __DSTACK_SIZE=0x00C8
	.EQU __HEAP_SIZE=0x0032
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	PUSH R26
	PUSH R27
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	POP  R27
	POP  R26
	ICALL
	.ENDM

	.MACRO __CALL2EX
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	CALL __EEPROMRDD
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z
	MOVW R30,R0
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _SHOW_MODE=R5
	.DEF _Hour=R4
	.DEF _Minute=R7
	.DEF _Second=R6
	.DEF __lcd_x=R9
	.DEF __lcd_y=R8
	.DEF __lcd_maxx=R11

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer1_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_Week_Days:
	.DB  0x53,0x75,0x6E,0x64,0x61,0x79,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x4D,0x6F,0x6E,0x64
	.DB  0x61,0x79,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x54,0x75,0x65,0x73,0x64,0x61,0x79,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x57,0x65,0x64,0x6E
	.DB  0x65,0x73,0x64,0x61,0x79,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x54,0x68,0x75,0x72,0x73,0x64,0x61,0x79
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x46,0x72,0x69,0x64
	.DB  0x61,0x79,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x53,0x61,0x74,0x75,0x72,0x64,0x61,0x79
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0
_DEC_Format:
	.DB  0x25,0x30,0x32,0x64,0x0
_Hex_Format:
	.DB  0x25,0x30,0x32,0x78,0x0
_STR_TWO_DOT:
	.DB  0x3A,0x0
_STR_20:
	.DB  0x32,0x30,0x0
_STR_SLASH:
	.DB  0x2F,0x0
_Alarm_1:
	.DB  0x8
_Alarm_2:
	.DB  0xC
_Alarm_3:
	.DB  0x10
_Alarm_4:
	.DB  0x14
_Alarm_5:
	.DB  0x18
_Alarm_6:
	.DB  0x1C
_Alarm_7:
	.DB  0x20
_Alarm_8:
	.DB  0x24
_Alarm_9:
	.DB  0x28
_Alarm_10:
	.DB  0x2C
_STR_0_ON:
	.DB  0x20,0x20,0x20,0x4F,0x4E,0x0
_STR_1_ON:
	.DB  0x20,0x20,0x3E,0x4F,0x4E,0x0
_STR_0_OFF:
	.DB  0x20,0x20,0x20,0x4F,0x46,0x46,0x0
_STR_1_OFF:
	.DB  0x20,0x20,0x3E,0x4F,0x46,0x46,0x0
_STR_SPACE:
	.DB  0x20,0x0
_STR_ONE_SHIFT:
	.DB  0x3E,0x0
_tbl10_G100:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G100:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;GLOBAL REGISTER VARIABLES INITIALIZATION
__REG_VARS:
	.DB  0x0

;HEAP START MARKER INITIALIZATION
__HEAP_START_MARKER:
	.DW  0,0

_0x0:
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x0
_0x40000:
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x0
_0x60000:
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x0,0x41,0x6C,0x61,0x72,0x6D,0x20,0x31
	.DB  0x20,0x4F,0x4B,0x0,0x41,0x6C,0x61,0x72
	.DB  0x6D,0x20,0x32,0x20,0x4F,0x4B,0x0,0x41
	.DB  0x6C,0x61,0x72,0x6D,0x20,0x33,0x20,0x4F
	.DB  0x4B,0x0,0x41,0x6C,0x61,0x72,0x6D,0x20
	.DB  0x34,0x20,0x4F,0x4B,0x0,0x41,0x6C,0x61
	.DB  0x72,0x6D,0x20,0x35,0x20,0x4F,0x4B,0x0
	.DB  0x41,0x6C,0x61,0x72,0x6D,0x20,0x36,0x20
	.DB  0x4F,0x4B,0x0,0x41,0x6C,0x61,0x72,0x6D
	.DB  0x20,0x37,0x20,0x4F,0x4B,0x0,0x41,0x6C
	.DB  0x61,0x72,0x6D,0x20,0x38,0x20,0x4F,0x4B
	.DB  0x0,0x41,0x6C,0x61,0x72,0x6D,0x20,0x39
	.DB  0x20,0x4F,0x4B,0x0,0x41,0x6C,0x61,0x72
	.DB  0x6D,0x20,0x31,0x30,0x20,0x4F,0x4B,0x0
_0xA0065:
	.DB  0x0,0x1,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x13,0x0
_0xA0000:
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x0,0x53,0x65,0x74,0x20,0x54,0x69,0x6D
	.DB  0x65,0x0,0x53,0x61,0x76,0x65,0x20,0x54
	.DB  0x69,0x6D,0x65,0x20,0x4F,0x4B,0x0,0x53
	.DB  0x65,0x74,0x20,0x44,0x61,0x74,0x65,0x0
	.DB  0x53,0x61,0x76,0x65,0x20,0x44,0x61,0x74
	.DB  0x65,0x20,0x4F,0x4B,0x0,0x53,0x65,0x74
	.DB  0x20,0x44,0x61,0x79,0x0,0x53,0x61,0x76
	.DB  0x65,0x20,0x44,0x61,0x79,0x20,0x4F,0x4B
	.DB  0x0,0x53,0x65,0x74,0x20,0x41,0x6C,0x61
	.DB  0x72,0x6D,0x20,0x31,0x0,0x53,0x65,0x74
	.DB  0x20,0x41,0x6C,0x61,0x72,0x6D,0x20,0x32
	.DB  0x0,0x53,0x65,0x74,0x20,0x41,0x6C,0x61
	.DB  0x72,0x6D,0x20,0x33,0x0,0x53,0x65,0x74
	.DB  0x20,0x41,0x6C,0x61,0x72,0x6D,0x20,0x34
	.DB  0x0,0x53,0x65,0x74,0x20,0x41,0x6C,0x61
	.DB  0x72,0x6D,0x20,0x35,0x0,0x53,0x65,0x74
	.DB  0x20,0x41,0x6C,0x61,0x72,0x6D,0x20,0x36
	.DB  0x0,0x53,0x65,0x74,0x20,0x41,0x6C,0x61
	.DB  0x72,0x6D,0x20,0x37,0x0,0x53,0x65,0x74
	.DB  0x20,0x41,0x6C,0x61,0x72,0x6D,0x20,0x38
	.DB  0x0,0x53,0x65,0x74,0x20,0x41,0x6C,0x61
	.DB  0x72,0x6D,0x20,0x39,0x0,0x53,0x65,0x74
	.DB  0x20,0x41,0x6C,0x61,0x72,0x6D,0x20,0x31
	.DB  0x30,0x0,0x53,0x61,0x76,0x65,0x20,0x41
	.DB  0x6C,0x61,0x72,0x6D,0x20,0x4F,0x4B,0x0
_0x2020060:
	.DB  0x1
_0x2020000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0,0x49,0x4E,0x46
	.DB  0x0
_0x2040003:
	.DB  0x80,0xC0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x05
	.DW  __REG_VARS*2

	.DW  0x04
	.DW  0x82E
	.DW  __HEAP_START_MARKER*2

	.DW  0x11
	.DW  _0x9
	.DW  _0x0*2

	.DW  0x01
	.DW  _0x9+17
	.DW  _0x0*2+16

	.DW  0x11
	.DW  _0x9+18
	.DW  _0x0*2

	.DW  0x01
	.DW  _0x9+35
	.DW  _0x0*2+16

	.DW  0x11
	.DW  _0x9+36
	.DW  _0x0*2

	.DW  0x01
	.DW  _0x9+53
	.DW  _0x0*2+16

	.DW  0x11
	.DW  _0x9+54
	.DW  _0x0*2

	.DW  0x01
	.DW  _0x9+71
	.DW  _0x0*2+16

	.DW  0x11
	.DW  _0x40015
	.DW  _0x40000*2

	.DW  0x11
	.DW  _0x40016
	.DW  _0x40000*2

	.DW  0x11
	.DW  _0xA0003
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0003+17
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0003+34
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0003+51
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0003+68
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0003+85
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0003+102
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0003+119
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0003+136
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0003+153
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0003+170
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0003+187
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0003+204
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA002C
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA002C+17
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA002C+34
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA002C+51
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA002C+68
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA002C+85
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA002C+102
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA002C+119
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA002C+136
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA002C+153
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA002C+170
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA002C+187
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA002C+204
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068+17
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068+34
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068+51
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068+68
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068+85
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068+102
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068+119
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068+136
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068+153
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068+170
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068+187
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068+204
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068+221
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068+238
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068+255
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068+272
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068+289
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068+306
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068+323
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068+340
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068+357
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068+374
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068+391
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068+408
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068+425
	.DW  _0xA0000*2

	.DW  0x11
	.DW  _0xA0068+442
	.DW  _0xA0000*2

	.DW  0x01
	.DW  __seed_G101
	.DW  _0x2020060*2

	.DW  0x02
	.DW  __base_y_G102
	.DW  _0x2040003*2

_0xFFFFFFFF:
	.DW  0

#define __GLOBAL_INI_TBL_PRESENT 1

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x128

	.CSEG
;/*******************************************************
;This program was created by the
;CodeWizardAVR V3.12 Advanced
;Automatic Program Generator
; Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 2/26/2015
;Author  :
;Company :
;Comments:
;
;
;Chip type               : ATmega32
;Program type            : Application
;AVR Core Clock frequency: 8.000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 512
;*******************************************************/
;
;#include <mega32.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <stdio.h>
;#include <stdlib.h>
;#include <delay.h>
;#include <alcd.h>
;#include <string.h>
;#include <eeprom.h>
;#include "Menu.h"
;#include "DS1307.h"
;#include "Timer1.h"
;#include "Keyboard.h"
;
;
;
;void main(void)
; 0000 0027 {

	.CSEG
_main:
; .FSTART _main
; 0000 0028   char Pressed_Key,Menu_ID=0,T=1;
; 0000 0029   LCD_Init();
;	Pressed_Key -> R17
;	Menu_ID -> R16
;	T -> R19
	LDI  R16,0
	LDI  R19,1
	LDI  R26,LOW(16)
	CALL _lcd_init
; 0000 002A   Keyboard_Init();
	CALL _Keyboard_Init
; 0000 002B   Timer1_Init();
	CALL _Timer1_Init
; 0000 002C   RTC_DS1307_Init();
	CALL _RTC_DS1307_Init
; 0000 002D 
; 0000 002E   #asm("sei")
	sei
; 0000 002F 
; 0000 0030   while (1)
_0x3:
; 0000 0031   {
; 0000 0032     Pressed_Key = Keyboard_Get_Key();
	CALL _Keyboard_Get_Key
	MOV  R17,R30
; 0000 0033     if(Pressed_Key==Key_Menu && Menu_ID==0)
	CPI  R17,6
	BRNE _0x7
	CPI  R16,0
	BREQ _0x8
_0x7:
	RJMP _0x6
_0x8:
; 0000 0034     {
; 0000 0035       #asm("cli")
	cli
; 0000 0036       Menu_Set_Date();
	CALL _Menu_Set_Date
; 0000 0037       Menu_ID++;
	CALL SUBOPT_0x0
; 0000 0038       LCD_WR_STR(0,1,"");
	__POINTW2MN _0x9,0
	CALL SUBOPT_0x1
	__POINTW2MN _0x9,17
	CALL _lcd_puts
; 0000 0039       #asm("sei")
	sei
; 0000 003A       continue;
	RJMP _0x3
; 0000 003B     }
; 0000 003C     if(Pressed_Key==Key_Menu && Menu_ID==1)
_0x6:
	CPI  R17,6
	BRNE _0xB
	CPI  R16,1
	BREQ _0xC
_0xB:
	RJMP _0xA
_0xC:
; 0000 003D     {
; 0000 003E       #asm("cli")
	cli
; 0000 003F       Menu_Set_Time();
	CALL _Menu_Set_Time
; 0000 0040       Menu_ID++;
	CALL SUBOPT_0x0
; 0000 0041       LCD_WR_STR(0,1,"");
	__POINTW2MN _0x9,18
	CALL SUBOPT_0x1
	__POINTW2MN _0x9,35
	CALL _lcd_puts
; 0000 0042       #asm("sei")
	sei
; 0000 0043       continue;
	RJMP _0x3
; 0000 0044     }
; 0000 0045     if(Pressed_Key==Key_Menu && Menu_ID==2)
_0xA:
	CPI  R17,6
	BRNE _0xE
	CPI  R16,2
	BREQ _0xF
_0xE:
	RJMP _0xD
_0xF:
; 0000 0046     {
; 0000 0047       #asm("cli")
	cli
; 0000 0048       Menu_Set_DOW();
	CALL _Menu_Set_DOW
; 0000 0049       Menu_ID++;
	CALL SUBOPT_0x0
; 0000 004A       LCD_WR_STR(0,1,"");
	__POINTW2MN _0x9,36
	CALL SUBOPT_0x1
	__POINTW2MN _0x9,53
	CALL _lcd_puts
; 0000 004B       #asm("sei")
	sei
; 0000 004C       continue;
	RJMP _0x3
; 0000 004D     }
; 0000 004E     if(Pressed_Key==Key_Menu && Menu_ID==3)
_0xD:
	CPI  R17,6
	BRNE _0x11
	CPI  R16,3
	BREQ _0x12
_0x11:
	RJMP _0x10
_0x12:
; 0000 004F     {
; 0000 0050       #asm("cli")
	cli
; 0000 0051       Menu_Set_Alarm();
	CALL _Menu_Set_Alarm
; 0000 0052       Menu_ID++;
	CALL SUBOPT_0x0
; 0000 0053       LCD_WR_STR(0,1,"");
	__POINTW2MN _0x9,54
	CALL SUBOPT_0x1
	__POINTW2MN _0x9,71
	CALL _lcd_puts
; 0000 0054       #asm("sei")
	sei
; 0000 0055     }
; 0000 0056     if(Menu_ID>3)
_0x10:
	CPI  R16,4
	BRLO _0x13
; 0000 0057       Menu_ID=0;
	LDI  R16,LOW(0)
; 0000 0058   }
_0x13:
	RJMP _0x3
; 0000 0059 }
_0x14:
	RJMP _0x14
; .FEND

	.DSEG
_0x9:
	.BYTE 0x48
;#include <mega32.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include "TWI.h"
;
;void TWI_Init(void)
; 0001 0005 {

	.CSEG
_TWI_Init:
; .FSTART _TWI_Init
; 0001 0006   // TWI initialization
; 0001 0007   // Bit Rate: 50.000 kHz
; 0001 0008   TWBR=0x48;
	LDI  R30,LOW(72)
	OUT  0x0,R30
; 0001 0009   // Two Wire Bus Slave Address: 0x0
; 0001 000A   // General Call Recognition: Off
; 0001 000B   TWAR=0x00;
	LDI  R30,LOW(0)
	OUT  0x2,R30
; 0001 000C   // Generate Acknowledge Pulse: Off
; 0001 000D   // TWI Interrupt: Off
; 0001 000E   TWCR=0x04;
	LDI  R30,LOW(4)
	OUT  0x36,R30
; 0001 000F   TWSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x1,R30
; 0001 0010 }
	RET
; .FEND
;
;void TWI_Start(void)
; 0001 0013 {
_TWI_Start:
; .FSTART _TWI_Start
; 0001 0014    TWCR= (1<<TWINT)|(1<<TWSTA)|(1<<TWEN);
	LDI  R30,LOW(164)
	OUT  0x36,R30
; 0001 0015    while(!(TWCR & (1<<TWINT)));
_0x20003:
	IN   R30,0x36
	ANDI R30,LOW(0x80)
	BREQ _0x20003
; 0001 0016    while((TWSR & 0xF8)!= START);
_0x20006:
	IN   R30,0x1
	ANDI R30,LOW(0xF8)
	CPI  R30,LOW(0x8)
	BRNE _0x20006
; 0001 0017 }
	RET
; .FEND
;
;void TWI_ReStart(void)
; 0001 001A {
_TWI_ReStart:
; .FSTART _TWI_ReStart
; 0001 001B    TWCR= (1<<TWINT)|(1<<TWSTA)|(1<<TWEN);
	LDI  R30,LOW(164)
	OUT  0x36,R30
; 0001 001C    while(!(TWCR & (1<<TWINT)));
_0x20009:
	IN   R30,0x36
	ANDI R30,LOW(0x80)
	BREQ _0x20009
; 0001 001D    while((TWSR & 0xF8)!= RE_START);
_0x2000C:
	IN   R30,0x1
	ANDI R30,LOW(0xF8)
	CPI  R30,LOW(0x10)
	BRNE _0x2000C
; 0001 001E }
	RET
; .FEND
;
;void TWI_Stop(void)
; 0001 0021 {
_TWI_Stop:
; .FSTART _TWI_Stop
; 0001 0022    TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTO);
	LDI  R30,LOW(148)
	OUT  0x36,R30
; 0001 0023 }
	RET
; .FEND
;
;void TWI_Write_Byte(unsigned char Data)
; 0001 0026 {
_TWI_Write_Byte:
; .FSTART _TWI_Write_Byte
; 0001 0027    TWDR = Data;
	ST   -Y,R26
;	Data -> Y+0
	LD   R30,Y
	OUT  0x3,R30
; 0001 0028    TWCR = (1<<TWINT) | (1<<TWEN);
	LDI  R30,LOW(132)
	OUT  0x36,R30
; 0001 0029    while(!(TWCR & (1<<TWINT)));
_0x2000F:
	IN   R30,0x36
	ANDI R30,LOW(0x80)
	BREQ _0x2000F
; 0001 002A }
	RJMP _0x20E0006
; .FEND
;
;unsigned char TWI_Read_Byte(void)
; 0001 002D {
_TWI_Read_Byte:
; .FSTART _TWI_Read_Byte
; 0001 002E   TWCR=(1<<TWINT)|(1<<TWEN);
	LDI  R30,LOW(132)
	OUT  0x36,R30
; 0001 002F   while (!(TWCR & (1<<TWINT)));
_0x20012:
	IN   R30,0x36
	ANDI R30,LOW(0x80)
	BREQ _0x20012
; 0001 0030   //TestAck(MR_DATA_ACK);
; 0001 0031   return TWDR;
	IN   R30,0x3
	RET
; 0001 0032 }
; .FEND
;#include <mega32.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <stdio.h>
;#include <delay.h>
;#include <alcd.h>
;#include <string.h>
;#include "TWI.h"
;#include "DS1307.h"
;
;char SHOW_MODE=0;
;extern const char Week_Days[7][20];
;extern const char DEC_Format[];
;extern const char Hex_Format[];
;
;extern const char STR_TWO_DOT[];
;extern const char STR_20[];
;extern const char STR_SLASH[];
;
;void RTC_DS1307_Init(void)
; 0002 0013 {

	.CSEG
_RTC_DS1307_Init:
; .FSTART _RTC_DS1307_Init
; 0002 0014   TWI_Init();
	RCALL _TWI_Init
; 0002 0015 }
	RET
; .FEND
;
;void RTC_DS1307_WR_DATA(unsigned char ADD,unsigned char DATA)
; 0002 0018 {
_RTC_DS1307_WR_DATA:
; .FSTART _RTC_DS1307_WR_DATA
; 0002 0019   TWI_Start();
	ST   -Y,R26
;	ADD -> Y+1
;	DATA -> Y+0
	RCALL _TWI_Start
; 0002 001A   TWI_Write_Byte(DS1307_WR);
	LDI  R26,LOW(208)
	RCALL _TWI_Write_Byte
; 0002 001B   TestAck(MT_SLA_ACK);
_0x40003:
	IN   R30,0x1
	ANDI R30,LOW(0xF8)
	CPI  R30,LOW(0x18)
	BRNE _0x40003
; 0002 001C   TWI_Write_Byte(ADD);
	LDD  R26,Y+1
	RCALL _TWI_Write_Byte
; 0002 001D   TestAck(MT_DATA_ACK);
_0x40006:
	IN   R30,0x1
	ANDI R30,LOW(0xF8)
	CPI  R30,LOW(0x28)
	BRNE _0x40006
; 0002 001E   TWI_Write_Byte(DATA);
	LD   R26,Y
	RCALL _TWI_Write_Byte
; 0002 001F   TestAck(MT_DATA_ACK);
_0x40009:
	IN   R30,0x1
	ANDI R30,LOW(0xF8)
	CPI  R30,LOW(0x28)
	BRNE _0x40009
; 0002 0020   TWI_Stop();
	CALL SUBOPT_0x2
; 0002 0021   delay_ms(5);
; 0002 0022 }
	RJMP _0x20E0009
; .FEND
;
;unsigned char RTC_DS1307_RD_DATA(unsigned char ADD)
; 0002 0025 {
_RTC_DS1307_RD_DATA:
; .FSTART _RTC_DS1307_RD_DATA
; 0002 0026   unsigned char REC_Data;
; 0002 0027   TWI_Start();
	ST   -Y,R26
	ST   -Y,R17
;	ADD -> Y+1
;	REC_Data -> R17
	RCALL _TWI_Start
; 0002 0028   TWI_Write_Byte(DS1307_WR);
	LDI  R26,LOW(208)
	RCALL _TWI_Write_Byte
; 0002 0029   TestAck(MT_SLA_ACK);
_0x4000C:
	IN   R30,0x1
	ANDI R30,LOW(0xF8)
	CPI  R30,LOW(0x18)
	BRNE _0x4000C
; 0002 002A   TWI_Write_Byte(ADD);
	LDD  R26,Y+1
	RCALL _TWI_Write_Byte
; 0002 002B   TestAck(MT_DATA_ACK);
_0x4000F:
	IN   R30,0x1
	ANDI R30,LOW(0xF8)
	CPI  R30,LOW(0x28)
	BRNE _0x4000F
; 0002 002C   TWI_ReStart();
	RCALL _TWI_ReStart
; 0002 002D   TWI_Write_Byte(DS1307_RD);
	LDI  R26,LOW(209)
	RCALL _TWI_Write_Byte
; 0002 002E   TestAck(MR_SLA_ACK);
_0x40012:
	IN   R30,0x1
	ANDI R30,LOW(0xF8)
	CPI  R30,LOW(0x40)
	BRNE _0x40012
; 0002 002F   REC_Data= TWI_Read_Byte();
	RCALL _TWI_Read_Byte
	MOV  R17,R30
; 0002 0030   SetAck();
	IN   R30,0x36
	ORI  R30,0x40
	OUT  0x36,R30
; 0002 0031   delay_ms(5);
	LDI  R26,LOW(5)
	LDI  R27,0
	CALL _delay_ms
; 0002 0032   TWI_Stop();
	CALL SUBOPT_0x2
; 0002 0033   delay_ms(5);
; 0002 0034   return REC_Data;
	MOV  R30,R17
	LDD  R17,Y+0
_0x20E0009:
	ADIW R28,2
	RET
; 0002 0035 }
; .FEND
;
;void RTC_DS1307_Set_Time(unsigned char Hour,unsigned char Minute,unsigned char Second)
; 0002 0038 {
_RTC_DS1307_Set_Time:
; .FSTART _RTC_DS1307_Set_Time
; 0002 0039   RTC_DS1307_WR_DATA(DS1307_Second_ADD,DEC_To_BCD(Second));
	ST   -Y,R26
;	Hour -> Y+2
;	Minute -> Y+1
;	Second -> Y+0
	LDI  R30,LOW(0)
	CALL SUBOPT_0x3
; 0002 003A   RTC_DS1307_WR_DATA(DS1307_Minute_ADD,DEC_To_BCD(Minute));
	LDI  R30,LOW(1)
	CALL SUBOPT_0x4
; 0002 003B   RTC_DS1307_WR_DATA(DS1307_Hour_ADD,DEC_To_BCD(Hour));
	LDI  R30,LOW(2)
	RJMP _0x20E0008
; 0002 003C }
; .FEND
;
;void RTC_DS1307_Set_Date(unsigned char Year,unsigned char Month,unsigned char Date)
; 0002 003F {
_RTC_DS1307_Set_Date:
; .FSTART _RTC_DS1307_Set_Date
; 0002 0040   RTC_DS1307_WR_DATA(DS1307_Date_ADD,DEC_To_BCD(Date));
	ST   -Y,R26
;	Year -> Y+2
;	Month -> Y+1
;	Date -> Y+0
	LDI  R30,LOW(4)
	CALL SUBOPT_0x3
; 0002 0041   RTC_DS1307_WR_DATA(DS1307_Month_ADD,DEC_To_BCD(Month));
	LDI  R30,LOW(5)
	CALL SUBOPT_0x4
; 0002 0042   RTC_DS1307_WR_DATA(DS1307_Year_ADD,DEC_To_BCD(Year));
	LDI  R30,LOW(6)
_0x20E0008:
	ST   -Y,R30
	LDD  R26,Y+3
	RCALL _DEC_To_BCD
	MOV  R26,R30
	RCALL _RTC_DS1307_WR_DATA
; 0002 0043 }
	ADIW R28,3
	RET
; .FEND
;
;void RTC_DS1307_Set_DOW(unsigned char Day)
; 0002 0046 {
_RTC_DS1307_Set_DOW:
; .FSTART _RTC_DS1307_Set_DOW
; 0002 0047   RTC_DS1307_WR_DATA(DS1307_Day_ADD,Day);
	ST   -Y,R26
;	Day -> Y+0
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDD  R26,Y+1
	RCALL _RTC_DS1307_WR_DATA
; 0002 0048 }
	RJMP _0x20E0006
; .FEND
;
;void RTC_DS1307_Get_Time(unsigned char *Hour,unsigned char *Minute,unsigned char *Second)
; 0002 004B {
_RTC_DS1307_Get_Time:
; .FSTART _RTC_DS1307_Get_Time
; 0002 004C   *Second = RTC_DS1307_RD_DATA(DS1307_Second_ADD)&0x7F;
	ST   -Y,R27
	ST   -Y,R26
;	*Hour -> Y+4
;	*Minute -> Y+2
;	*Second -> Y+0
	LDI  R26,LOW(0)
	RCALL _RTC_DS1307_RD_DATA
	ANDI R30,0x7F
	LD   R26,Y
	LDD  R27,Y+1
	ST   X,R30
; 0002 004D   *Minute = RTC_DS1307_RD_DATA(DS1307_Minute_ADD);
	LDI  R26,LOW(1)
	RCALL _RTC_DS1307_RD_DATA
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ST   X,R30
; 0002 004E   *Hour   = RTC_DS1307_RD_DATA(DS1307_Hour_ADD)&0x3F;
	LDI  R26,LOW(2)
	RCALL _RTC_DS1307_RD_DATA
	ANDI R30,LOW(0x3F)
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ST   X,R30
; 0002 004F }
	ADIW R28,6
	RET
; .FEND
;
;void RTC_DS1307_Get_Date(unsigned char *Year,unsigned char *Month,unsigned char *Date,unsigned char *Day)
; 0002 0052 {
_RTC_DS1307_Get_Date:
; .FSTART _RTC_DS1307_Get_Date
; 0002 0053   *Day   = RTC_DS1307_RD_DATA(DS1307_Day_ADD)&0x07;
	ST   -Y,R27
	ST   -Y,R26
;	*Year -> Y+6
;	*Month -> Y+4
;	*Date -> Y+2
;	*Day -> Y+0
	LDI  R26,LOW(3)
	RCALL _RTC_DS1307_RD_DATA
	ANDI R30,LOW(0x7)
	LD   R26,Y
	LDD  R27,Y+1
	ST   X,R30
; 0002 0054   *Date  = RTC_DS1307_RD_DATA(DS1307_Date_ADD)&0x3F;
	LDI  R26,LOW(4)
	RCALL _RTC_DS1307_RD_DATA
	ANDI R30,LOW(0x3F)
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ST   X,R30
; 0002 0055   *Month = RTC_DS1307_RD_DATA(DS1307_Month_ADD)&0x1F;
	LDI  R26,LOW(5)
	RCALL _RTC_DS1307_RD_DATA
	ANDI R30,LOW(0x1F)
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ST   X,R30
; 0002 0056   *Year  = RTC_DS1307_RD_DATA(DS1307_Year_ADD);
	LDI  R26,LOW(6)
	RCALL _RTC_DS1307_RD_DATA
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ST   X,R30
; 0002 0057 }
	ADIW R28,8
	RET
; .FEND
;
;void RTC_DS1307_Display_Time(void)
; 0002 005A {
_RTC_DS1307_Display_Time:
; .FSTART _RTC_DS1307_Display_Time
; 0002 005B   unsigned char H,M,S;
; 0002 005C   char str_S[3],str_M[3],str_H[3];
; 0002 005D   char Time[12];
; 0002 005E   Time[0]='\0';
	SBIW R28,21
	CALL __SAVELOCR4
;	H -> R17
;	M -> R16
;	S -> R19
;	str_S -> Y+22
;	str_M -> Y+19
;	str_H -> Y+16
;	Time -> Y+4
	LDI  R30,LOW(0)
	STD  Y+4,R30
; 0002 005F 
; 0002 0060   RTC_DS1307_Get_Time(&H,&M,&S);
	IN   R30,SPL
	IN   R31,SPH
	ST   -Y,R31
	ST   -Y,R30
	PUSH R17
	IN   R30,SPL
	IN   R31,SPH
	ST   -Y,R31
	ST   -Y,R30
	PUSH R16
	IN   R26,SPL
	IN   R27,SPH
	PUSH R19
	RCALL _RTC_DS1307_Get_Time
	POP  R19
	POP  R16
	POP  R17
; 0002 0061 
; 0002 0062   sprintf(str_S,Hex_Format,S);
	CALL SUBOPT_0x5
	CALL SUBOPT_0x6
; 0002 0063   sprintf(str_M,Hex_Format,M);
	CALL SUBOPT_0x7
; 0002 0064   sprintf(str_H,Hex_Format,H);
	CALL SUBOPT_0x8
; 0002 0065 
; 0002 0066   strcat(Time,str_H);
	CALL SUBOPT_0x9
	MOVW R26,R28
	ADIW R26,18
	CALL SUBOPT_0xA
; 0002 0067   strcatf(Time,STR_TWO_DOT);
	CALL SUBOPT_0xB
; 0002 0068   strcat(Time,str_M);
	MOVW R26,R28
	ADIW R26,21
	CALL SUBOPT_0xA
; 0002 0069   strcatf(Time,STR_TWO_DOT);
	CALL SUBOPT_0xB
; 0002 006A   strcat(Time,str_S);
	CALL SUBOPT_0xC
; 0002 006B 
; 0002 006C   LCD_WR_STR(0,0,Time);
	LDI  R26,LOW(0)
	CALL _lcd_gotoxy
	__POINTW2MN _0x40015,0
	RJMP _0x20E0007
; 0002 006D   Time[0]='\0';
; 0002 006E }
; .FEND

	.DSEG
_0x40015:
	.BYTE 0x11
;
;void RTC_DS1307_Display_Date(void)
; 0002 0071 {

	.CSEG
_RTC_DS1307_Display_Date:
; .FSTART _RTC_DS1307_Display_Date
; 0002 0072   unsigned char Y,M,D,DOW;
; 0002 0073   char str_Y[3],str_M[3],str_D[3];
; 0002 0074   char Date[12];
; 0002 0075   Date[0]='\0';
	SBIW R28,21
	CALL __SAVELOCR4
;	Y -> R17
;	M -> R16
;	D -> R19
;	DOW -> R18
;	str_Y -> Y+22
;	str_M -> Y+19
;	str_D -> Y+16
;	Date -> Y+4
	LDI  R30,LOW(0)
	STD  Y+4,R30
; 0002 0076 
; 0002 0077   RTC_DS1307_Get_Date(&Y,&M,&D,&DOW);
	IN   R30,SPL
	IN   R31,SPH
	ST   -Y,R31
	ST   -Y,R30
	PUSH R17
	IN   R30,SPL
	IN   R31,SPH
	ST   -Y,R31
	ST   -Y,R30
	PUSH R16
	IN   R30,SPL
	IN   R31,SPH
	ST   -Y,R31
	ST   -Y,R30
	PUSH R19
	IN   R26,SPL
	IN   R27,SPH
	PUSH R18
	RCALL _RTC_DS1307_Get_Date
	POP  R18
	POP  R19
	POP  R16
	POP  R17
; 0002 0078 
; 0002 0079   sprintf(str_Y,Hex_Format,Y);
	CALL SUBOPT_0x5
	CALL SUBOPT_0x8
; 0002 007A   sprintf(str_M,Hex_Format,M);
	CALL SUBOPT_0x7
; 0002 007B   sprintf(str_D,Hex_Format,D);
	CALL SUBOPT_0x6
; 0002 007C 
; 0002 007D   strcatf(Date,STR_20);
	CALL SUBOPT_0x9
	CALL SUBOPT_0xD
; 0002 007E   strcat(Date,str_Y);
	CALL SUBOPT_0x9
	MOVW R26,R28
	ADIW R26,24
	CALL SUBOPT_0xA
; 0002 007F   strcatf(Date,STR_SLASH);
	CALL SUBOPT_0xE
; 0002 0080   strcat(Date,str_M);
	MOVW R26,R28
	ADIW R26,21
	CALL SUBOPT_0xA
; 0002 0081   strcatf(Date,STR_SLASH);
	CALL SUBOPT_0xE
; 0002 0082   strcat(Date,str_D);
	MOVW R26,R28
	ADIW R26,18
	CALL SUBOPT_0xF
; 0002 0083 
; 0002 0084   LCD_WR_STR(0,0,Date);
	LDI  R26,LOW(0)
	CALL _lcd_gotoxy
	__POINTW2MN _0x40016,0
_0x20E0007:
	CALL _lcd_puts
	CALL SUBOPT_0x10
	MOVW R26,R28
	ADIW R26,4
	CALL _lcd_puts
; 0002 0085   Date[0]='\0';
	LDI  R30,LOW(0)
	STD  Y+4,R30
; 0002 0086 }
	CALL __LOADLOCR4
	ADIW R28,25
	RET
; .FEND

	.DSEG
_0x40016:
	.BYTE 0x11
;
;void RTC_DS1307_Display_Day_Week(void)
; 0002 0089 {

	.CSEG
_RTC_DS1307_Display_Day_Week:
; .FSTART _RTC_DS1307_Display_Day_Week
; 0002 008A   unsigned char Y,M,D,DOW;
; 0002 008B   RTC_DS1307_Get_Date(&Y,&M,&D,&DOW);
	CALL __SAVELOCR4
;	Y -> R17
;	M -> R16
;	D -> R19
;	DOW -> R18
	IN   R30,SPL
	IN   R31,SPH
	ST   -Y,R31
	ST   -Y,R30
	PUSH R17
	IN   R30,SPL
	IN   R31,SPH
	ST   -Y,R31
	ST   -Y,R30
	PUSH R16
	IN   R30,SPL
	IN   R31,SPH
	ST   -Y,R31
	ST   -Y,R30
	PUSH R19
	IN   R26,SPL
	IN   R27,SPH
	PUSH R18
	RCALL _RTC_DS1307_Get_Date
	POP  R18
	POP  R19
	POP  R16
	POP  R17
; 0002 008C   switch(DOW)
	CALL SUBOPT_0x11
; 0002 008D   {
; 0002 008E     case 1:
	BRNE _0x4001A
; 0002 008F       LCD_WR_STRF(0,0,Week_Days[0]);
	CALL SUBOPT_0x10
	CALL SUBOPT_0x12
	LDI  R26,LOW(_Week_Days*2)
	LDI  R27,HIGH(_Week_Days*2)
	RJMP _0x40029
; 0002 0090       break;
; 0002 0091     case 2:
_0x4001A:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x4001B
; 0002 0092       LCD_WR_STRF(0,0,Week_Days[1]);
	CALL SUBOPT_0x10
	CALL SUBOPT_0x12
	__POINTW2FN _Week_Days,20
	RJMP _0x40029
; 0002 0093       break;
; 0002 0094     case 3:
_0x4001B:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x4001C
; 0002 0095       LCD_WR_STRF(0,0,Week_Days[2]);
	CALL SUBOPT_0x10
	CALL SUBOPT_0x12
	__POINTW2FN _Week_Days,40
	RJMP _0x40029
; 0002 0096       break;
; 0002 0097     case 4:
_0x4001C:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x4001D
; 0002 0098       LCD_WR_STRF(0,0,Week_Days[3]);
	CALL SUBOPT_0x10
	CALL SUBOPT_0x12
	__POINTW2FN _Week_Days,60
	RJMP _0x40029
; 0002 0099       break;
; 0002 009A     case 5:
_0x4001D:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x4001E
; 0002 009B       LCD_WR_STRF(0,0,Week_Days[4]);
	CALL SUBOPT_0x10
	CALL SUBOPT_0x12
	__POINTW2FN _Week_Days,80
	RJMP _0x40029
; 0002 009C       break;
; 0002 009D     case 6:
_0x4001E:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x4001F
; 0002 009E       LCD_WR_STRF(0,0,Week_Days[5]);
	CALL SUBOPT_0x10
	CALL SUBOPT_0x12
	__POINTW2FN _Week_Days,100
	RJMP _0x40029
; 0002 009F       break;
; 0002 00A0     case 7:
_0x4001F:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x40019
; 0002 00A1       LCD_WR_STRF(0,0,Week_Days[6]);
	CALL SUBOPT_0x10
	CALL SUBOPT_0x12
	__POINTW2FN _Week_Days,120
_0x40029:
	CALL _lcd_putsf
; 0002 00A2       break;
; 0002 00A3   }
_0x40019:
; 0002 00A4 }
	CALL __LOADLOCR4
	ADIW R28,4
	RET
; .FEND
;
;void RTC_DS1307_Display_Date_Time(void)
; 0002 00A7 {
_RTC_DS1307_Display_Date_Time:
; .FSTART _RTC_DS1307_Display_Date_Time
; 0002 00A8   if(SHOW_MODE<5)
	LDI  R30,LOW(5)
	CP   R5,R30
	BRSH _0x40021
; 0002 00A9 	{
; 0002 00AA 	  RTC_DS1307_Display_Time();
	RCALL _RTC_DS1307_Display_Time
; 0002 00AB 	}
; 0002 00AC 	if(SHOW_MODE>=5 && SHOW_MODE<=6)
_0x40021:
	LDI  R30,LOW(5)
	CP   R5,R30
	BRLO _0x40023
	LDI  R30,LOW(6)
	CP   R30,R5
	BRSH _0x40024
_0x40023:
	RJMP _0x40022
_0x40024:
; 0002 00AD 	{
; 0002 00AE 	  RTC_DS1307_Display_Date();
	RCALL _RTC_DS1307_Display_Date
; 0002 00AF 	}
; 0002 00B0 	if(SHOW_MODE>=7 && SHOW_MODE<=9)
_0x40022:
	LDI  R30,LOW(7)
	CP   R5,R30
	BRLO _0x40026
	LDI  R30,LOW(9)
	CP   R30,R5
	BRSH _0x40027
_0x40026:
	RJMP _0x40025
_0x40027:
; 0002 00B1 	{
; 0002 00B2 	  RTC_DS1307_Display_Day_Week();
	RCALL _RTC_DS1307_Display_Day_Week
; 0002 00B3 	}
; 0002 00B4 	SHOW_MODE++;
_0x40025:
	INC  R5
; 0002 00B5 	if(SHOW_MODE==9)
	LDI  R30,LOW(9)
	CP   R30,R5
	BRNE _0x40028
; 0002 00B6 	{
; 0002 00B7 	  SHOW_MODE=0;
	CLR  R5
; 0002 00B8 	}
; 0002 00B9 }
_0x40028:
	RET
; .FEND
;
;unsigned char DEC_To_BCD(unsigned char DEC)
; 0002 00BC {
_DEC_To_BCD:
; .FSTART _DEC_To_BCD
; 0002 00BD   return ( (DEC/10*16) + (DEC%10) );
	ST   -Y,R26
;	DEC -> Y+0
	LD   R26,Y
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	LDI  R26,LOW(16)
	MULS R30,R26
	MOV  R22,R0
	LD   R26,Y
	CLR  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	ADD  R30,R22
	RJMP _0x20E0006
; 0002 00BE }
; .FEND
;
;unsigned char BCD_To_DEC(unsigned char BCD)
; 0002 00C1 {
_BCD_To_DEC:
; .FSTART _BCD_To_DEC
; 0002 00C2   return ( (BCD/16*10) + (BCD%16) );
	ST   -Y,R26
;	BCD -> Y+0
	LD   R26,Y
	LDI  R27,0
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	CALL __DIVW21
	LDI  R26,LOW(10)
	MULS R30,R26
	LD   R30,Y
	LDI  R31,0
	LDI  R26,LOW(15)
	LDI  R27,HIGH(15)
	CALL __MANDW12
	ADD  R30,R0
_0x20E0006:
	ADIW R28,1
	RET
; 0002 00C3 }
; .FEND
;#include <mega32.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <alcd.h>
;#include "Alarm.h"
;#include "DS1307.h"
;#include "Timer1.h"
;
;
;
;unsigned char Hour,Minute,Second;
;Alarm A1,A2,A3,A4,A5,A6,A7,A8,A9,A10;
;
;extern const char  Alarm_1;
;extern const char  Alarm_2;
;extern const char  Alarm_3;
;extern const char  Alarm_4;
;extern const char  Alarm_5;
;extern const char  Alarm_6;
;extern const char  Alarm_7;
;extern const char  Alarm_8;
;extern const char  Alarm_9;
;extern const char  Alarm_10;
;
;
;interrupt [TIM1_OVF] void timer1_ovf_isr(void)
; 0003 0019 {

	.CSEG
_timer1_ovf_isr:
; .FSTART _timer1_ovf_isr
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0003 001A   #asm("cli")
	cli
; 0003 001B   TCNT1H=0x85EE >> 8;
	LDI  R30,LOW(133)
	OUT  0x2D,R30
; 0003 001C   TCNT1L=0x85EE & 0xff;
	LDI  R30,LOW(238)
	OUT  0x2C,R30
; 0003 001D 
; 0003 001E   RTC_DS1307_Get_Time(&Hour,&Minute,&Second);
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(6)
	LDI  R27,HIGH(6)
	RCALL _RTC_DS1307_Get_Time
; 0003 001F   Hour   = BCD_To_DEC(Hour);
	MOV  R26,R4
	RCALL _BCD_To_DEC
	MOV  R4,R30
; 0003 0020   Minute = BCD_To_DEC(Minute);
	MOV  R26,R7
	RCALL _BCD_To_DEC
	MOV  R7,R30
; 0003 0021   Second = BCD_To_DEC(Second);
	MOV  R26,R6
	RCALL _BCD_To_DEC
	MOV  R6,R30
; 0003 0022 
; 0003 0023   Alarm_Read(&A1,Alarm_1);
	LDI  R30,LOW(_A1)
	LDI  R31,HIGH(_A1)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_Alarm_1*2)
	LDI  R31,HIGH(_Alarm_1*2)
	LPM  R26,Z
	CALL _Alarm_Read
; 0003 0024   Alarm_Read(&A2,Alarm_2);
	LDI  R30,LOW(_A2)
	LDI  R31,HIGH(_A2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_Alarm_2*2)
	LDI  R31,HIGH(_Alarm_2*2)
	LPM  R26,Z
	CALL _Alarm_Read
; 0003 0025   Alarm_Read(&A3,Alarm_3);
	LDI  R30,LOW(_A3)
	LDI  R31,HIGH(_A3)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_Alarm_3*2)
	LDI  R31,HIGH(_Alarm_3*2)
	LPM  R26,Z
	CALL _Alarm_Read
; 0003 0026   Alarm_Read(&A4,Alarm_4);
	LDI  R30,LOW(_A4)
	LDI  R31,HIGH(_A4)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_Alarm_4*2)
	LDI  R31,HIGH(_Alarm_4*2)
	LPM  R26,Z
	CALL _Alarm_Read
; 0003 0027   Alarm_Read(&A5,Alarm_5);
	LDI  R30,LOW(_A5)
	LDI  R31,HIGH(_A5)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_Alarm_5*2)
	LDI  R31,HIGH(_Alarm_5*2)
	LPM  R26,Z
	CALL _Alarm_Read
; 0003 0028   Alarm_Read(&A6,Alarm_6);
	LDI  R30,LOW(_A6)
	LDI  R31,HIGH(_A6)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_Alarm_6*2)
	LDI  R31,HIGH(_Alarm_6*2)
	LPM  R26,Z
	CALL _Alarm_Read
; 0003 0029   Alarm_Read(&A7,Alarm_7);
	LDI  R30,LOW(_A7)
	LDI  R31,HIGH(_A7)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_Alarm_7*2)
	LDI  R31,HIGH(_Alarm_7*2)
	LPM  R26,Z
	CALL _Alarm_Read
; 0003 002A   Alarm_Read(&A8,Alarm_8);
	LDI  R30,LOW(_A8)
	LDI  R31,HIGH(_A8)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_Alarm_8*2)
	LDI  R31,HIGH(_Alarm_8*2)
	LPM  R26,Z
	CALL _Alarm_Read
; 0003 002B   Alarm_Read(&A9,Alarm_9);
	LDI  R30,LOW(_A9)
	LDI  R31,HIGH(_A9)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_Alarm_9*2)
	LDI  R31,HIGH(_Alarm_9*2)
	LPM  R26,Z
	CALL _Alarm_Read
; 0003 002C   Alarm_Read(&A10,Alarm_10);
	LDI  R30,LOW(_A10)
	LDI  R31,HIGH(_A10)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_Alarm_10*2)
	LDI  R31,HIGH(_Alarm_10*2)
	LPM  R26,Z
	CALL _Alarm_Read
; 0003 002D 
; 0003 002E   RTC_DS1307_Display_Date_Time();
	RCALL _RTC_DS1307_Display_Date_Time
; 0003 002F 
; 0003 0030   if(A1.Enable_Disable!=0 && A1.Hour==Hour && A1.Minute==Minute && A1.Second==Second)
	LDS  R26,_A1
	CPI  R26,LOW(0x0)
	BREQ _0x60004
	__GETB2MN _A1,1
	CP   R4,R26
	BRNE _0x60004
	__GETB2MN _A1,2
	CP   R7,R26
	BRNE _0x60004
	__GETB2MN _A1,3
	CP   R6,R26
	BREQ _0x60005
_0x60004:
	RJMP _0x60003
_0x60005:
; 0003 0031   {
; 0003 0032     LCD_WR_STRF(0,1,"Alarm 1 OK");
	CALL SUBOPT_0x13
	CALL SUBOPT_0x14
	__POINTW2FN _0x60000,17
	CALL SUBOPT_0x15
; 0003 0033     LCD_WR_STRF(0,1,"");
	CALL SUBOPT_0x14
	CALL SUBOPT_0x16
; 0003 0034   }
; 0003 0035   if(A2.Enable_Disable!=0 && A2.Hour==Hour && A2.Minute==Minute && A2.Second==Second)
_0x60003:
	LDS  R26,_A2
	CPI  R26,LOW(0x0)
	BREQ _0x60007
	__GETB2MN _A2,1
	CP   R4,R26
	BRNE _0x60007
	__GETB2MN _A2,2
	CP   R7,R26
	BRNE _0x60007
	__GETB2MN _A2,3
	CP   R6,R26
	BREQ _0x60008
_0x60007:
	RJMP _0x60006
_0x60008:
; 0003 0036   {
; 0003 0037     LCD_WR_STRF(0,1,"Alarm 2 OK");
	CALL SUBOPT_0x13
	CALL SUBOPT_0x14
	__POINTW2FN _0x60000,28
	CALL SUBOPT_0x15
; 0003 0038     LCD_WR_STRF(0,1,"");
	CALL SUBOPT_0x14
	CALL SUBOPT_0x16
; 0003 0039   }
; 0003 003A   if(A3.Enable_Disable!=0 && A3.Hour==Hour && A3.Minute==Minute && A3.Second==Second)
_0x60006:
	LDS  R26,_A3
	CPI  R26,LOW(0x0)
	BREQ _0x6000A
	__GETB2MN _A3,1
	CP   R4,R26
	BRNE _0x6000A
	__GETB2MN _A3,2
	CP   R7,R26
	BRNE _0x6000A
	__GETB2MN _A3,3
	CP   R6,R26
	BREQ _0x6000B
_0x6000A:
	RJMP _0x60009
_0x6000B:
; 0003 003B   {
; 0003 003C     LCD_WR_STRF(0,1,"Alarm 3 OK");
	CALL SUBOPT_0x13
	CALL SUBOPT_0x14
	__POINTW2FN _0x60000,39
	CALL SUBOPT_0x15
; 0003 003D     LCD_WR_STRF(0,1,"");
	CALL SUBOPT_0x14
	CALL SUBOPT_0x16
; 0003 003E   }
; 0003 003F   if(A4.Enable_Disable!=0 && A4.Hour==Hour && A4.Minute==Minute && A4.Second==Second)
_0x60009:
	LDS  R26,_A4
	CPI  R26,LOW(0x0)
	BREQ _0x6000D
	__GETB2MN _A4,1
	CP   R4,R26
	BRNE _0x6000D
	__GETB2MN _A4,2
	CP   R7,R26
	BRNE _0x6000D
	__GETB2MN _A4,3
	CP   R6,R26
	BREQ _0x6000E
_0x6000D:
	RJMP _0x6000C
_0x6000E:
; 0003 0040   {
; 0003 0041     LCD_WR_STRF(0,1,"Alarm 4 OK");
	CALL SUBOPT_0x13
	CALL SUBOPT_0x14
	__POINTW2FN _0x60000,50
	CALL SUBOPT_0x15
; 0003 0042     LCD_WR_STRF(0,1,"");
	CALL SUBOPT_0x14
	CALL SUBOPT_0x16
; 0003 0043   }
; 0003 0044   if(A5.Enable_Disable!=0 && A5.Hour==Hour && A5.Minute==Minute && A5.Second==Second)
_0x6000C:
	LDS  R26,_A5
	CPI  R26,LOW(0x0)
	BREQ _0x60010
	__GETB2MN _A5,1
	CP   R4,R26
	BRNE _0x60010
	__GETB2MN _A5,2
	CP   R7,R26
	BRNE _0x60010
	__GETB2MN _A5,3
	CP   R6,R26
	BREQ _0x60011
_0x60010:
	RJMP _0x6000F
_0x60011:
; 0003 0045   {
; 0003 0046     LCD_WR_STRF(0,1,"Alarm 5 OK");
	CALL SUBOPT_0x13
	CALL SUBOPT_0x14
	__POINTW2FN _0x60000,61
	CALL SUBOPT_0x15
; 0003 0047     LCD_WR_STRF(0,1,"");
	CALL SUBOPT_0x14
	CALL SUBOPT_0x16
; 0003 0048   }
; 0003 0049   if(A6.Enable_Disable!=0 && A6.Hour==Hour && A6.Minute==Minute && A6.Second==Second)
_0x6000F:
	LDS  R26,_A6
	CPI  R26,LOW(0x0)
	BREQ _0x60013
	__GETB2MN _A6,1
	CP   R4,R26
	BRNE _0x60013
	__GETB2MN _A6,2
	CP   R7,R26
	BRNE _0x60013
	__GETB2MN _A6,3
	CP   R6,R26
	BREQ _0x60014
_0x60013:
	RJMP _0x60012
_0x60014:
; 0003 004A   {
; 0003 004B     LCD_WR_STRF(0,1,"Alarm 6 OK");
	CALL SUBOPT_0x13
	CALL SUBOPT_0x14
	__POINTW2FN _0x60000,72
	CALL SUBOPT_0x15
; 0003 004C     LCD_WR_STRF(0,1,"");
	CALL SUBOPT_0x14
	CALL SUBOPT_0x16
; 0003 004D   }
; 0003 004E   if(A7.Enable_Disable!=0 && A7.Hour==Hour && A7.Minute==Minute && A7.Second==Second)
_0x60012:
	LDS  R26,_A7
	CPI  R26,LOW(0x0)
	BREQ _0x60016
	__GETB2MN _A7,1
	CP   R4,R26
	BRNE _0x60016
	__GETB2MN _A7,2
	CP   R7,R26
	BRNE _0x60016
	__GETB2MN _A7,3
	CP   R6,R26
	BREQ _0x60017
_0x60016:
	RJMP _0x60015
_0x60017:
; 0003 004F   {
; 0003 0050     LCD_WR_STRF(0,1,"Alarm 7 OK");
	CALL SUBOPT_0x13
	CALL SUBOPT_0x14
	__POINTW2FN _0x60000,83
	CALL SUBOPT_0x15
; 0003 0051     LCD_WR_STRF(0,1,"");
	CALL SUBOPT_0x14
	CALL SUBOPT_0x16
; 0003 0052   }
; 0003 0053   if(A8.Enable_Disable!=0 && A8.Hour==Hour && A8.Minute==Minute && A8.Second==Second)
_0x60015:
	LDS  R26,_A8
	CPI  R26,LOW(0x0)
	BREQ _0x60019
	__GETB2MN _A8,1
	CP   R4,R26
	BRNE _0x60019
	__GETB2MN _A8,2
	CP   R7,R26
	BRNE _0x60019
	__GETB2MN _A8,3
	CP   R6,R26
	BREQ _0x6001A
_0x60019:
	RJMP _0x60018
_0x6001A:
; 0003 0054   {
; 0003 0055     LCD_WR_STRF(0,1,"Alarm 8 OK");
	CALL SUBOPT_0x13
	CALL SUBOPT_0x14
	__POINTW2FN _0x60000,94
	CALL SUBOPT_0x15
; 0003 0056     LCD_WR_STRF(0,1,"");
	CALL SUBOPT_0x14
	CALL SUBOPT_0x16
; 0003 0057   }
; 0003 0058   if(A9.Enable_Disable!=0 && A9.Hour==Hour && A9.Minute==Minute && A9.Second==Second)
_0x60018:
	LDS  R26,_A9
	CPI  R26,LOW(0x0)
	BREQ _0x6001C
	__GETB2MN _A9,1
	CP   R4,R26
	BRNE _0x6001C
	__GETB2MN _A9,2
	CP   R7,R26
	BRNE _0x6001C
	__GETB2MN _A9,3
	CP   R6,R26
	BREQ _0x6001D
_0x6001C:
	RJMP _0x6001B
_0x6001D:
; 0003 0059   {
; 0003 005A     LCD_WR_STRF(0,1,"Alarm 9 OK");
	CALL SUBOPT_0x13
	CALL SUBOPT_0x14
	__POINTW2FN _0x60000,105
	CALL SUBOPT_0x15
; 0003 005B     LCD_WR_STRF(0,1,"");
	CALL SUBOPT_0x14
	CALL SUBOPT_0x16
; 0003 005C   }
; 0003 005D   if(A10.Enable_Disable!=0 && A10.Hour==Hour && A10.Minute==Minute && A10.Second==Second)
_0x6001B:
	LDS  R26,_A10
	CPI  R26,LOW(0x0)
	BREQ _0x6001F
	__GETB2MN _A10,1
	CP   R4,R26
	BRNE _0x6001F
	__GETB2MN _A10,2
	CP   R7,R26
	BRNE _0x6001F
	__GETB2MN _A10,3
	CP   R6,R26
	BREQ _0x60020
_0x6001F:
	RJMP _0x6001E
_0x60020:
; 0003 005E   {
; 0003 005F     LCD_WR_STRF(0,1,"Alarm 10 OK");
	CALL SUBOPT_0x13
	CALL SUBOPT_0x14
	__POINTW2FN _0x60000,116
	CALL SUBOPT_0x15
; 0003 0060     LCD_WR_STRF(0,1,"");
	CALL SUBOPT_0x14
	CALL SUBOPT_0x16
; 0003 0061   }
; 0003 0062   #asm("sei")
_0x6001E:
	sei
; 0003 0063 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
; .FEND
;
;void Timer1_Init(void)
; 0003 0066 {
_Timer1_Init:
; .FSTART _Timer1_Init
; 0003 0067   // Timer/Counter 1 initialization
; 0003 0068   // Clock source: System Clock
; 0003 0069   // Clock value: 31.250 kHz
; 0003 006A   // Mode: Normal top=0xFFFF
; 0003 006B   // OC1A output: Disconnected
; 0003 006C   // OC1B output: Disconnected
; 0003 006D   // Noise Canceler: Off
; 0003 006E   // Input Capture on Falling Edge
; 0003 006F   // Timer Period: 1 s
; 0003 0070   // Timer1 Overflow Interrupt: On
; 0003 0071   // Input Capture Interrupt: Off
; 0003 0072   // Compare A Match Interrupt: Off
; 0003 0073   // Compare B Match Interrupt: Off
; 0003 0074   TCCR1A=(0<<COM1A1) | (0<<COM1A0) | (0<<COM1B1) | (0<<COM1B0) | (0<<WGM11) | (0<<WGM10);
	LDI  R30,LOW(0)
	OUT  0x2F,R30
; 0003 0075   TCCR1B=(0<<ICNC1) | (0<<ICES1) | (0<<WGM13) | (0<<WGM12) | (1<<CS12) | (0<<CS11) | (0<<CS10);
	LDI  R30,LOW(4)
	OUT  0x2E,R30
; 0003 0076   TCNT1H=0x85;
	LDI  R30,LOW(133)
	OUT  0x2D,R30
; 0003 0077   TCNT1L=0xEE;
	LDI  R30,LOW(238)
	OUT  0x2C,R30
; 0003 0078   ICR1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x27,R30
; 0003 0079   ICR1L=0x00;
	OUT  0x26,R30
; 0003 007A   OCR1AH=0x00;
	OUT  0x2B,R30
; 0003 007B   OCR1AL=0x00;
	OUT  0x2A,R30
; 0003 007C   OCR1BH=0x00;
	OUT  0x29,R30
; 0003 007D   OCR1BL=0x00;
	OUT  0x28,R30
; 0003 007E   // Timer(s)/Counter(s) Interrupt(s) initialization
; 0003 007F   TIMSK=(0<<OCIE2) | (0<<TOIE2) | (0<<TICIE1) | (0<<OCIE1A) | (0<<OCIE1B) | (1<<TOIE1) | (0<<OCIE0) | (0<<TOIE0);
	LDI  R30,LOW(4)
	OUT  0x39,R30
; 0003 0080 }
	RET
; .FEND
;#include <mega32.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include "Keyboard.h"
;
;void Keyboard_Init(void)
; 0004 0006 {

	.CSEG
_Keyboard_Init:
; .FSTART _Keyboard_Init
; 0004 0007   Keyboard_DDR = 0x00;
	LDI  R30,LOW(0)
	OUT  0x11,R30
; 0004 0008 }
	RET
; .FEND
;
;unsigned char Keyboard_Get_Key(void)
; 0004 000B {
_Keyboard_Get_Key:
; .FSTART _Keyboard_Get_Key
; 0004 000C    switch(Keyboard_PIN&0x7F)
	IN   R30,0x10
	ANDI R30,0x7F
; 0004 000D    {
; 0004 000E      case 0x7E:
	CPI  R30,LOW(0x7E)
	BRNE _0x80006
; 0004 000F        delay_ms(50);
	CALL SUBOPT_0x17
; 0004 0010        return Key_UP;
	LDI  R30,LOW(1)
	RET
; 0004 0011      case 0x7D:
_0x80006:
	CPI  R30,LOW(0x7D)
	BRNE _0x80007
; 0004 0012        delay_ms(50);
	CALL SUBOPT_0x17
; 0004 0013        return Key_Down;
	LDI  R30,LOW(2)
	RET
; 0004 0014      case 0x7B:
_0x80007:
	CPI  R30,LOW(0x7B)
	BRNE _0x80008
; 0004 0015        delay_ms(50);
	CALL SUBOPT_0x17
; 0004 0016        return Key_Right;
	LDI  R30,LOW(3)
	RET
; 0004 0017      case 0x77:
_0x80008:
	CPI  R30,LOW(0x77)
	BRNE _0x80009
; 0004 0018        delay_ms(50);
	CALL SUBOPT_0x17
; 0004 0019        return Key_Left;
	LDI  R30,LOW(4)
	RET
; 0004 001A      case 0x6F:
_0x80009:
	CPI  R30,LOW(0x6F)
	BRNE _0x8000A
; 0004 001B        delay_ms(50);
	CALL SUBOPT_0x17
; 0004 001C        return Key_OK;
	LDI  R30,LOW(5)
	RET
; 0004 001D      case 0x5F:
_0x8000A:
	CPI  R30,LOW(0x5F)
	BRNE _0x8000B
; 0004 001E        delay_ms(50);
	CALL SUBOPT_0x17
; 0004 001F        return Key_Menu;
	LDI  R30,LOW(6)
	RET
; 0004 0020      case 0x3F:
_0x8000B:
	CPI  R30,LOW(0x3F)
	BRNE _0x8000D
; 0004 0021        delay_ms(50);
	CALL SUBOPT_0x17
; 0004 0022        return Key_Return;
	LDI  R30,LOW(7)
	RET
; 0004 0023      default :
_0x8000D:
; 0004 0024        delay_ms(50);
	CALL SUBOPT_0x17
; 0004 0025        return 0;
	LDI  R30,LOW(0)
	RET
; 0004 0026    }
; 0004 0027 }
	RET
; .FEND
;#include <mega32.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <stdio.h>
;#include <stdlib.h>
;#include <delay.h>
;#include <alcd.h>
;#include <string.h>
;#include "Menu.h"
;#include "Alarm.h"
;#include "DS1307.h"
;#include "Keyboard.h"
;
;
;const char Week_Days[7][20]={"Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"};
;const char DEC_Format[]="%02d";
;const char Hex_Format[]="%02x";
;
;const char STR_0_ON[] ="   ON";
;const char STR_1_ON[] ="  >ON";
;const char STR_0_OFF[]="   OFF";
;const char STR_1_OFF[]="  >OFF";
;
;const char STR_SPACE[]    =" ";
;const char STR_TWO_DOT[]  =":";
;const char STR_ONE_SHIFT[]=">";
;const char STR_20[]       ="20";
;const char STR_SLASH[]    ="/";
;
;extern const char  Alarm_1;
;extern const char  Alarm_2;
;extern const char  Alarm_3;
;extern const char  Alarm_4;
;extern const char  Alarm_5;
;extern const char  Alarm_6;
;extern const char  Alarm_7;
;extern const char  Alarm_8;
;extern const char  Alarm_9;
;extern const char  Alarm_10;
;
;
;void Menu_Set_Time(void)
; 0005 0029 {

	.CSEG
_Menu_Set_Time:
; .FSTART _Menu_Set_Time
; 0005 002A   unsigned char S=0,M=0,H=0;
; 0005 002B   unsigned char *Pointer=&H;
; 0005 002C   char str_S[4],str_M[4],str_H[4],Time[12];
; 0005 002D   char Pressed_Key,T=1,Locate=0;
; 0005 002E   Time[0]='\0';
	SBIW R28,26
	CALL SUBOPT_0x18
;	S -> R17
;	M -> R16
;	H -> R19
;	*Pointer -> R20,R21
;	str_S -> Y+28
;	str_M -> Y+24
;	str_H -> Y+20
;	Time -> Y+8
;	Pressed_Key -> R18
;	T -> Y+7
;	Locate -> Y+6
	__GETWRN 20,21,19
	CALL SUBOPT_0x19
; 0005 002F   LCD_WR_STRF(0,0,"Set Time");
	CALL SUBOPT_0x1A
	__POINTW2FN _0xA0000,17
	CALL _lcd_putsf
; 0005 0030   sprintf(str_S,DEC_Format,S);
	CALL SUBOPT_0x1B
; 0005 0031   sprintf(str_M,DEC_Format,M);
	CALL SUBOPT_0x1C
; 0005 0032   sprintf(str_H,DEC_Format,H);
; 0005 0033   strcatf(Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x1E
; 0005 0034   strcat(Time,str_H);
	CALL SUBOPT_0x1F
; 0005 0035   strcatf(Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 0036   strcat(Time,str_M);
	CALL SUBOPT_0x21
; 0005 0037   strcatf(Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 0038   strcat(Time,str_S);
	CALL SUBOPT_0x22
; 0005 0039   LCD_WR_STR(0,1,Time);
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2MN _0xA0003,0
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 003A   while(T)
_0xA0004:
	LDD  R30,Y+7
	CPI  R30,0
	BRNE PC+2
	RJMP _0xA0006
; 0005 003B   {
; 0005 003C     delay_ms(250);
	CALL SUBOPT_0x24
; 0005 003D     Pressed_Key = Keyboard_Get_Key();
; 0005 003E     switch(Pressed_Key)
; 0005 003F     {
; 0005 0040       case Key_UP:
	BREQ PC+2
	RJMP _0xA000A
; 0005 0041       {
; 0005 0042         (*Pointer)++;
	CALL SUBOPT_0x25
; 0005 0043         if(Locate==0)
	BRNE _0xA000B
; 0005 0044         {
; 0005 0045           if((*Pointer)>23)
	MOVW R26,R20
	LD   R26,X
	CPI  R26,LOW(0x18)
	BRLO _0xA000C
; 0005 0046             (*Pointer)=23;
	MOVW R26,R20
	LDI  R30,LOW(23)
	ST   X,R30
; 0005 0047         }
_0xA000C:
; 0005 0048         if(Locate==1)
_0xA000B:
	LDD  R26,Y+6
	CPI  R26,LOW(0x1)
	BRNE _0xA000D
; 0005 0049         {
; 0005 004A           if((*Pointer)>59)
	MOVW R26,R20
	LD   R26,X
	CPI  R26,LOW(0x3C)
	BRLO _0xA000E
; 0005 004B            (*Pointer)=59;
	MOVW R26,R20
	LDI  R30,LOW(59)
	ST   X,R30
; 0005 004C         }
_0xA000E:
; 0005 004D         if(Locate==2)
_0xA000D:
	LDD  R26,Y+6
	CPI  R26,LOW(0x2)
	BRNE _0xA000F
; 0005 004E         {
; 0005 004F           if((*Pointer)>59)
	MOVW R26,R20
	LD   R26,X
	CPI  R26,LOW(0x3C)
	BRLO _0xA0010
; 0005 0050            (*Pointer)=59;
	MOVW R26,R20
	LDI  R30,LOW(59)
	ST   X,R30
; 0005 0051         }
_0xA0010:
; 0005 0052         sprintf(str_S,DEC_Format,S);
_0xA000F:
	CALL SUBOPT_0x1B
; 0005 0053         sprintf(str_M,DEC_Format,M);
	CALL SUBOPT_0x1C
; 0005 0054         sprintf(str_H,DEC_Format,H);
; 0005 0055         Time[0]='\0';
	CALL SUBOPT_0x26
; 0005 0056         if(Locate==0)
	BRNE _0xA0011
; 0005 0057         {
; 0005 0058           strcatf(Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x1E
; 0005 0059           strcat(Time,str_H);
	CALL SUBOPT_0x1F
; 0005 005A           strcatf(Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 005B           strcat(Time,str_M);
	CALL SUBOPT_0x21
; 0005 005C           strcatf(Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 005D           strcat(Time,str_S);
	CALL SUBOPT_0x22
; 0005 005E           LCD_WR_STR(0,1,Time);
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2MN _0xA0003,17
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 005F           break;
	RJMP _0xA0009
; 0005 0060         }
; 0005 0061         if(Locate==1)
_0xA0011:
	LDD  R26,Y+6
	CPI  R26,LOW(0x1)
	BRNE _0xA0012
; 0005 0062         {
; 0005 0063           strcatf(Time,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 0064           strcat(Time,str_H);
	CALL SUBOPT_0x1F
; 0005 0065           strcatf(Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 0066           strcat(Time,str_M);
	CALL SUBOPT_0x21
; 0005 0067           strcatf(Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 0068           strcat(Time,str_S);
	CALL SUBOPT_0x22
; 0005 0069           LCD_WR_STR(0,1,Time);
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2MN _0xA0003,34
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 006A           break;
	RJMP _0xA0009
; 0005 006B         }
; 0005 006C         if(Locate==2)
_0xA0012:
	LDD  R26,Y+6
	CPI  R26,LOW(0x2)
	BRNE _0xA0013
; 0005 006D         {
; 0005 006E           strcatf(Time,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 006F           strcat(Time,str_H);
	CALL SUBOPT_0x1F
; 0005 0070           strcatf(Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 0071           strcat(Time,str_M);
	CALL SUBOPT_0x21
; 0005 0072           strcatf(Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 0073           strcat(Time,str_S);
	CALL SUBOPT_0x22
; 0005 0074           LCD_WR_STR(0,1,Time);
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2MN _0xA0003,51
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 0075           break;
	RJMP _0xA0009
; 0005 0076         }
; 0005 0077         break;
_0xA0013:
	RJMP _0xA0009
; 0005 0078       }
; 0005 0079       case Key_Down:
_0xA000A:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0xA0014
; 0005 007A       {
; 0005 007B         (*Pointer)--;
	CALL SUBOPT_0x28
; 0005 007C         if(Locate==0)
	BRNE _0xA0015
; 0005 007D         {
; 0005 007E           if((*Pointer)>23)
	MOVW R26,R20
	LD   R26,X
	CPI  R26,LOW(0x18)
	BRLO _0xA0016
; 0005 007F             (*Pointer)=0;
	MOVW R26,R20
	LDI  R30,LOW(0)
	ST   X,R30
; 0005 0080         }
_0xA0016:
; 0005 0081         if(Locate==1)
_0xA0015:
	LDD  R26,Y+6
	CPI  R26,LOW(0x1)
	BRNE _0xA0017
; 0005 0082         {
; 0005 0083           if((*Pointer)>59)
	MOVW R26,R20
	LD   R26,X
	CPI  R26,LOW(0x3C)
	BRLO _0xA0018
; 0005 0084            (*Pointer)=0;
	MOVW R26,R20
	LDI  R30,LOW(0)
	ST   X,R30
; 0005 0085         }
_0xA0018:
; 0005 0086         if(Locate==2)
_0xA0017:
	LDD  R26,Y+6
	CPI  R26,LOW(0x2)
	BRNE _0xA0019
; 0005 0087         {
; 0005 0088           if((*Pointer)>59)
	MOVW R26,R20
	LD   R26,X
	CPI  R26,LOW(0x3C)
	BRLO _0xA001A
; 0005 0089            (*Pointer)=0;
	MOVW R26,R20
	LDI  R30,LOW(0)
	ST   X,R30
; 0005 008A         }
_0xA001A:
; 0005 008B         sprintf(str_S,DEC_Format,S);
_0xA0019:
	CALL SUBOPT_0x1B
; 0005 008C         sprintf(str_M,DEC_Format,M);
	CALL SUBOPT_0x1C
; 0005 008D         sprintf(str_H,DEC_Format,H);
; 0005 008E         Time[0]='\0';
	CALL SUBOPT_0x26
; 0005 008F         if(Locate==0)
	BRNE _0xA001B
; 0005 0090         {
; 0005 0091           strcatf(Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x1E
; 0005 0092           strcat(Time,str_H);
	CALL SUBOPT_0x1F
; 0005 0093           strcatf(Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 0094           strcat(Time,str_M);
	CALL SUBOPT_0x21
; 0005 0095           strcatf(Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 0096           strcat(Time,str_S);
	CALL SUBOPT_0x22
; 0005 0097           LCD_WR_STR(0,1,Time);
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2MN _0xA0003,68
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 0098           break;
	RJMP _0xA0009
; 0005 0099         }
; 0005 009A         if(Locate==1)
_0xA001B:
	LDD  R26,Y+6
	CPI  R26,LOW(0x1)
	BRNE _0xA001C
; 0005 009B         {
; 0005 009C           strcatf(Time,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 009D           strcat(Time,str_H);
	CALL SUBOPT_0x1F
; 0005 009E           strcatf(Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 009F           strcat(Time,str_M);
	CALL SUBOPT_0x21
; 0005 00A0           strcatf(Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 00A1           strcat(Time,str_S);
	CALL SUBOPT_0x22
; 0005 00A2           LCD_WR_STR(0,1,Time);
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2MN _0xA0003,85
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 00A3           break;
	RJMP _0xA0009
; 0005 00A4         }
; 0005 00A5         if(Locate==2)
_0xA001C:
	LDD  R26,Y+6
	CPI  R26,LOW(0x2)
	BRNE _0xA001D
; 0005 00A6         {
; 0005 00A7           strcatf(Time,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 00A8           strcat(Time,str_H);
	CALL SUBOPT_0x1F
; 0005 00A9           strcatf(Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 00AA           strcat(Time,str_M);
	CALL SUBOPT_0x21
; 0005 00AB           strcatf(Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 00AC           strcat(Time,str_S);
	CALL SUBOPT_0x22
; 0005 00AD           LCD_WR_STR(0,1,Time);
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2MN _0xA0003,102
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 00AE           break;
	RJMP _0xA0009
; 0005 00AF         }
; 0005 00B0         break;
_0xA001D:
	RJMP _0xA0009
; 0005 00B1       }
; 0005 00B2       case Key_Right:
_0xA0014:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0xA001E
; 0005 00B3       {
; 0005 00B4         sprintf(str_S,DEC_Format,S);
	CALL SUBOPT_0x1B
; 0005 00B5         sprintf(str_M,DEC_Format,M);
	CALL SUBOPT_0x1C
; 0005 00B6         sprintf(str_H,DEC_Format,H);
; 0005 00B7         Time[0]='\0';
	CALL SUBOPT_0x29
; 0005 00B8         Locate++;
; 0005 00B9         if(Locate>2)
	BRLO _0xA001F
; 0005 00BA           Locate=2;
	LDI  R30,LOW(2)
	STD  Y+6,R30
; 0005 00BB         if(Locate==0)
_0xA001F:
	LDD  R30,Y+6
	CPI  R30,0
	BRNE _0xA0020
; 0005 00BC         {
; 0005 00BD           strcatf(Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x1E
; 0005 00BE           strcat(Time,str_H);
	CALL SUBOPT_0x1F
; 0005 00BF           strcatf(Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 00C0           strcat(Time,str_M);
	CALL SUBOPT_0x21
; 0005 00C1           strcatf(Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 00C2           strcat(Time,str_S);
	CALL SUBOPT_0x22
; 0005 00C3           LCD_WR_STR(0,1,Time);
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2MN _0xA0003,119
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 00C4           Pointer=&H;
	__GETWRN 20,21,19
; 0005 00C5           break;
	RJMP _0xA0009
; 0005 00C6         }
; 0005 00C7         if(Locate==1)
_0xA0020:
	LDD  R26,Y+6
	CPI  R26,LOW(0x1)
	BRNE _0xA0021
; 0005 00C8         {
; 0005 00C9           strcatf(Time,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 00CA           strcat(Time,str_H);
	CALL SUBOPT_0x1F
; 0005 00CB           strcatf(Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 00CC           strcat(Time,str_M);
	CALL SUBOPT_0x21
; 0005 00CD           strcatf(Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 00CE           strcat(Time,str_S);
	CALL SUBOPT_0x22
; 0005 00CF           LCD_WR_STR(0,1,Time);
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2MN _0xA0003,136
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 00D0           Pointer=&M;
	__GETWRN 20,21,16
; 0005 00D1           break;
	RJMP _0xA0009
; 0005 00D2         }
; 0005 00D3         if(Locate==2)
_0xA0021:
	LDD  R26,Y+6
	CPI  R26,LOW(0x2)
	BRNE _0xA0022
; 0005 00D4         {
; 0005 00D5           strcatf(Time,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 00D6           strcat(Time,str_H);
	CALL SUBOPT_0x1F
; 0005 00D7           strcatf(Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 00D8           strcat(Time,str_M);
	CALL SUBOPT_0x21
; 0005 00D9           strcatf(Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 00DA           strcat(Time,str_S);
	CALL SUBOPT_0x22
; 0005 00DB           LCD_WR_STR(0,1,Time);
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2MN _0xA0003,153
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 00DC           Pointer=&S;
	__GETWRN 20,21,17
; 0005 00DD           break;
	RJMP _0xA0009
; 0005 00DE         }
; 0005 00DF         break;
_0xA0022:
	RJMP _0xA0009
; 0005 00E0       }
; 0005 00E1       case Key_Left:
_0xA001E:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0xA0023
; 0005 00E2       {
; 0005 00E3         sprintf(str_S,DEC_Format,S);
	CALL SUBOPT_0x1B
; 0005 00E4         sprintf(str_M,DEC_Format,M);
	CALL SUBOPT_0x1C
; 0005 00E5         sprintf(str_H,DEC_Format,H);
; 0005 00E6         Time[0]='\0';
	CALL SUBOPT_0x2A
; 0005 00E7         Locate--;
; 0005 00E8         if(Locate>2)
	BRLO _0xA0024
; 0005 00E9           Locate=0;
	LDI  R30,LOW(0)
	STD  Y+6,R30
; 0005 00EA         if(Locate==0)
_0xA0024:
	LDD  R30,Y+6
	CPI  R30,0
	BRNE _0xA0025
; 0005 00EB         {
; 0005 00EC           strcatf(Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x1E
; 0005 00ED           strcat(Time,str_H);
	CALL SUBOPT_0x1F
; 0005 00EE           strcatf(Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 00EF           strcat(Time,str_M);
	CALL SUBOPT_0x21
; 0005 00F0           strcatf(Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 00F1           strcat(Time,str_S);
	CALL SUBOPT_0x22
; 0005 00F2           LCD_WR_STR(0,1,Time);
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2MN _0xA0003,170
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 00F3           Pointer=&H;
	__GETWRN 20,21,19
; 0005 00F4           break;
	RJMP _0xA0009
; 0005 00F5         }
; 0005 00F6         if(Locate==1)
_0xA0025:
	LDD  R26,Y+6
	CPI  R26,LOW(0x1)
	BRNE _0xA0026
; 0005 00F7         {
; 0005 00F8           strcatf(Time,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 00F9           strcat(Time,str_H);
	CALL SUBOPT_0x1F
; 0005 00FA           strcatf(Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 00FB           strcat(Time,str_M);
	CALL SUBOPT_0x21
; 0005 00FC           strcatf(Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 00FD           strcat(Time,str_S);
	CALL SUBOPT_0x22
; 0005 00FE           LCD_WR_STR(0,1,Time);
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2MN _0xA0003,187
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 00FF           Pointer=&M;
	__GETWRN 20,21,16
; 0005 0100           break;
	RJMP _0xA0009
; 0005 0101         }
; 0005 0102         if(Locate==2)
_0xA0026:
	LDD  R26,Y+6
	CPI  R26,LOW(0x2)
	BRNE _0xA0027
; 0005 0103         {
; 0005 0104           strcatf(Time,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 0105           strcat(Time,str_H);
	CALL SUBOPT_0x1F
; 0005 0106           strcatf(Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 0107           strcat(Time,str_M);
	CALL SUBOPT_0x21
; 0005 0108           strcatf(Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 0109           strcat(Time,str_S);
	CALL SUBOPT_0x22
; 0005 010A           LCD_WR_STR(0,1,Time);
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2MN _0xA0003,204
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 010B           Pointer=&S;
	__GETWRN 20,21,17
; 0005 010C           break;
	RJMP _0xA0009
; 0005 010D         }
; 0005 010E         break;
_0xA0027:
	RJMP _0xA0009
; 0005 010F       }
; 0005 0110       case Key_Menu:
_0xA0023:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BREQ _0xA0009
; 0005 0111       {
; 0005 0112         break;
; 0005 0113       }
; 0005 0114       case Key_OK:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0xA0029
; 0005 0115       {
; 0005 0116         RTC_DS1307_Set_Time(H,M,S);
	ST   -Y,R19
	ST   -Y,R16
	MOV  R26,R17
	CALL _RTC_DS1307_Set_Time
; 0005 0117         LCD_WR_STRF(0,1,"Save Time OK");
	CALL SUBOPT_0x13
	CALL SUBOPT_0x2B
	__POINTW2FN _0xA0000,26
	CALL SUBOPT_0x2C
; 0005 0118         delay_ms(1000);
; 0005 0119         LCD_WR_STRF(0,1,"");
	CALL SUBOPT_0x2B
	CALL SUBOPT_0x2D
; 0005 011A         T=0;
; 0005 011B         break;
	RJMP _0xA0009
; 0005 011C       }
; 0005 011D       case Key_Return:
_0xA0029:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0xA002B
; 0005 011E       {
; 0005 011F         T=0;
	LDI  R30,LOW(0)
	STD  Y+7,R30
; 0005 0120         break;
; 0005 0121       }
; 0005 0122       default:
_0xA002B:
; 0005 0123       {
; 0005 0124         break;
; 0005 0125       }
; 0005 0126     }
_0xA0009:
; 0005 0127   }
	RJMP _0xA0004
_0xA0006:
; 0005 0128 }
	CALL __LOADLOCR6
	ADIW R28,32
	RET
; .FEND

	.DSEG
_0xA0003:
	.BYTE 0xDD
;
;void Menu_Set_Date(void)
; 0005 012B {

	.CSEG
_Menu_Set_Date:
; .FSTART _Menu_Set_Date
; 0005 012C   unsigned char Y=0,M=0,D=0;
; 0005 012D   unsigned char *Pointer=&Y;
; 0005 012E   char str_Y[6],str_M[4],str_D[4],Date[14];
; 0005 012F   char Pressed_Key,T=1,Locate=0;
; 0005 0130   Date[0]='\0';
	SBIW R28,30
	CALL SUBOPT_0x18
;	Y -> R17
;	M -> R16
;	D -> R19
;	*Pointer -> R20,R21
;	str_Y -> Y+30
;	str_M -> Y+26
;	str_D -> Y+22
;	Date -> Y+8
;	Pressed_Key -> R18
;	T -> Y+7
;	Locate -> Y+6
	__GETWRN 20,21,17
	CALL SUBOPT_0x19
; 0005 0131   LCD_WR_STRF(0,0,"Set Date");
	CALL SUBOPT_0x1A
	__POINTW2FN _0xA0000,39
	CALL _lcd_putsf
; 0005 0132   sprintf(str_D,DEC_Format,D);
	CALL SUBOPT_0x2E
; 0005 0133   sprintf(str_M,DEC_Format,M);
	CALL SUBOPT_0x2F
; 0005 0134   sprintf(str_Y,DEC_Format,Y);
; 0005 0135   strcatf(Date,STR_ONE_SHIFT);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x1E
; 0005 0136   strcatf(Date,STR_20);
	CALL SUBOPT_0xD
; 0005 0137   strcat(Date,str_Y);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x30
; 0005 0138   strcatf(Date,STR_SLASH);
	CALL SUBOPT_0x31
; 0005 0139   strcat(Date,str_M);
	CALL SUBOPT_0x32
; 0005 013A   strcatf(Date,STR_SLASH);
	CALL SUBOPT_0x31
; 0005 013B   strcat(Date,str_D);
	CALL SUBOPT_0xC
; 0005 013C   LCD_WR_STR(0,1,Date);
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2MN _0xA002C,0
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 013D   while(T)
_0xA002D:
	LDD  R30,Y+7
	CPI  R30,0
	BRNE PC+2
	RJMP _0xA002F
; 0005 013E   {
; 0005 013F     delay_ms(250);
	CALL SUBOPT_0x24
; 0005 0140     Pressed_Key = Keyboard_Get_Key();
; 0005 0141     switch(Pressed_Key)
; 0005 0142     {
; 0005 0143       case Key_UP:
	BREQ PC+2
	RJMP _0xA0033
; 0005 0144       {
; 0005 0145         (*Pointer)++;
	CALL SUBOPT_0x25
; 0005 0146         if(Locate==0)
	BRNE _0xA0034
; 0005 0147         {
; 0005 0148           if((*Pointer)>99)
	MOVW R26,R20
	LD   R26,X
	CPI  R26,LOW(0x64)
	BRLO _0xA0035
; 0005 0149             (*Pointer)=99;
	MOVW R26,R20
	LDI  R30,LOW(99)
	ST   X,R30
; 0005 014A         }
_0xA0035:
; 0005 014B         if(Locate==1)
_0xA0034:
	LDD  R26,Y+6
	CPI  R26,LOW(0x1)
	BRNE _0xA0036
; 0005 014C         {
; 0005 014D           if((*Pointer)>12)
	MOVW R26,R20
	LD   R26,X
	CPI  R26,LOW(0xD)
	BRLO _0xA0037
; 0005 014E            (*Pointer)=12;
	MOVW R26,R20
	LDI  R30,LOW(12)
	ST   X,R30
; 0005 014F         }
_0xA0037:
; 0005 0150         if(Locate==2)
_0xA0036:
	LDD  R26,Y+6
	CPI  R26,LOW(0x2)
	BRNE _0xA0038
; 0005 0151         {
; 0005 0152           if((*Pointer)>31)
	MOVW R26,R20
	LD   R26,X
	CPI  R26,LOW(0x20)
	BRLO _0xA0039
; 0005 0153            (*Pointer)=31;
	MOVW R26,R20
	LDI  R30,LOW(31)
	ST   X,R30
; 0005 0154         }
_0xA0039:
; 0005 0155         sprintf(str_D,DEC_Format,D);
_0xA0038:
	CALL SUBOPT_0x2E
; 0005 0156         sprintf(str_M,DEC_Format,M);
	CALL SUBOPT_0x2F
; 0005 0157         sprintf(str_Y,DEC_Format,Y);
; 0005 0158         Date[0]='\0';
	CALL SUBOPT_0x26
; 0005 0159         if(Locate==0)
	BRNE _0xA003A
; 0005 015A         {
; 0005 015B           strcatf(Date,STR_ONE_SHIFT);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x1E
; 0005 015C           strcatf(Date,STR_20);
	CALL SUBOPT_0xD
; 0005 015D           strcat(Date,str_Y);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x30
; 0005 015E           strcatf(Date,STR_SLASH);
	CALL SUBOPT_0x31
; 0005 015F           strcat(Date,str_M);
	CALL SUBOPT_0x32
; 0005 0160           strcatf(Date,STR_SLASH);
	CALL SUBOPT_0x31
; 0005 0161           strcat(Date,str_D);
	CALL SUBOPT_0xC
; 0005 0162           LCD_WR_STR(0,1,Date);
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2MN _0xA002C,17
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 0163           break;
	RJMP _0xA0032
; 0005 0164         }
; 0005 0165         if(Locate==1)
_0xA003A:
	LDD  R26,Y+6
	CPI  R26,LOW(0x1)
	BRNE _0xA003B
; 0005 0166         {
; 0005 0167           strcatf(Date,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 0168           strcatf(Date,STR_20);
	CALL SUBOPT_0xD
; 0005 0169           strcat(Date,str_Y);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x30
; 0005 016A           strcatf(Date,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 016B           strcat(Date,str_M);
	CALL SUBOPT_0x32
; 0005 016C           strcatf(Date,STR_SLASH);
	CALL SUBOPT_0x31
; 0005 016D           strcat(Date,str_D);
	CALL SUBOPT_0xC
; 0005 016E           LCD_WR_STR(0,1,Date);
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2MN _0xA002C,34
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 016F           break;
	RJMP _0xA0032
; 0005 0170         }
; 0005 0171         if(Locate==2)
_0xA003B:
	LDD  R26,Y+6
	CPI  R26,LOW(0x2)
	BRNE _0xA003C
; 0005 0172         {
; 0005 0173           strcatf(Date,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 0174           strcatf(Date,STR_20);
	CALL SUBOPT_0xD
; 0005 0175           strcat(Date,str_Y);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x30
; 0005 0176           strcatf(Date,STR_SLASH);
	CALL SUBOPT_0x31
; 0005 0177           strcat(Date,str_M);
	CALL SUBOPT_0x32
; 0005 0178           strcatf(Date,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 0179           strcat(Date,str_D);
	CALL SUBOPT_0xC
; 0005 017A           LCD_WR_STR(0,1,Date);
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2MN _0xA002C,51
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 017B           break;
	RJMP _0xA0032
; 0005 017C         }
; 0005 017D         break;
_0xA003C:
	RJMP _0xA0032
; 0005 017E       }
; 0005 017F       case Key_Down:
_0xA0033:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0xA003D
; 0005 0180       {
; 0005 0181         (*Pointer)--;
	CALL SUBOPT_0x28
; 0005 0182         if(Locate==0)
	BRNE _0xA003E
; 0005 0183         {
; 0005 0184           if((*Pointer)>99)
	MOVW R26,R20
	LD   R26,X
	CPI  R26,LOW(0x64)
	BRLO _0xA003F
; 0005 0185             (*Pointer)=0;
	MOVW R26,R20
	LDI  R30,LOW(0)
	ST   X,R30
; 0005 0186         }
_0xA003F:
; 0005 0187         if(Locate==1)
_0xA003E:
	LDD  R26,Y+6
	CPI  R26,LOW(0x1)
	BRNE _0xA0040
; 0005 0188         {
; 0005 0189           if((*Pointer)>12)
	MOVW R26,R20
	LD   R26,X
	CPI  R26,LOW(0xD)
	BRLO _0xA0041
; 0005 018A            (*Pointer)=0;
	MOVW R26,R20
	LDI  R30,LOW(0)
	ST   X,R30
; 0005 018B         }
_0xA0041:
; 0005 018C         if(Locate==2)
_0xA0040:
	LDD  R26,Y+6
	CPI  R26,LOW(0x2)
	BRNE _0xA0042
; 0005 018D         {
; 0005 018E           if((*Pointer)>31)
	MOVW R26,R20
	LD   R26,X
	CPI  R26,LOW(0x20)
	BRLO _0xA0043
; 0005 018F            (*Pointer)=0;
	MOVW R26,R20
	LDI  R30,LOW(0)
	ST   X,R30
; 0005 0190         }
_0xA0043:
; 0005 0191         sprintf(str_D,DEC_Format,D);
_0xA0042:
	CALL SUBOPT_0x2E
; 0005 0192         sprintf(str_M,DEC_Format,M);
	CALL SUBOPT_0x2F
; 0005 0193         sprintf(str_Y,DEC_Format,Y);
; 0005 0194         Date[0]='\0';
	CALL SUBOPT_0x26
; 0005 0195         if(Locate==0)
	BRNE _0xA0044
; 0005 0196         {
; 0005 0197           strcatf(Date,STR_ONE_SHIFT);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x1E
; 0005 0198           strcatf(Date,STR_20);
	CALL SUBOPT_0xD
; 0005 0199           strcat(Date,str_Y);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x30
; 0005 019A           strcatf(Date,STR_SLASH);
	CALL SUBOPT_0x31
; 0005 019B           strcat(Date,str_M);
	CALL SUBOPT_0x32
; 0005 019C           strcatf(Date,STR_SLASH);
	CALL SUBOPT_0x31
; 0005 019D           strcat(Date,str_D);
	CALL SUBOPT_0xC
; 0005 019E           LCD_WR_STR(0,1,Date);
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2MN _0xA002C,68
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 019F           break;
	RJMP _0xA0032
; 0005 01A0         }
; 0005 01A1         if(Locate==1)
_0xA0044:
	LDD  R26,Y+6
	CPI  R26,LOW(0x1)
	BRNE _0xA0045
; 0005 01A2         {
; 0005 01A3           strcatf(Date,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 01A4           strcatf(Date,STR_20);
	CALL SUBOPT_0xD
; 0005 01A5           strcat(Date,str_Y);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x30
; 0005 01A6           strcatf(Date,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 01A7           strcat(Date,str_M);
	CALL SUBOPT_0x32
; 0005 01A8           strcatf(Date,STR_SLASH);
	CALL SUBOPT_0x31
; 0005 01A9           strcat(Date,str_D);
	CALL SUBOPT_0xC
; 0005 01AA           LCD_WR_STR(0,1,Date);
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2MN _0xA002C,85
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 01AB           break;
	RJMP _0xA0032
; 0005 01AC         }
; 0005 01AD         if(Locate==2)
_0xA0045:
	LDD  R26,Y+6
	CPI  R26,LOW(0x2)
	BRNE _0xA0046
; 0005 01AE         {
; 0005 01AF           strcatf(Date,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 01B0           strcatf(Date,STR_20);
	CALL SUBOPT_0xD
; 0005 01B1           strcat(Date,str_Y);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x30
; 0005 01B2           strcatf(Date,STR_SLASH);
	CALL SUBOPT_0x31
; 0005 01B3           strcat(Date,str_M);
	CALL SUBOPT_0x32
; 0005 01B4           strcatf(Date,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 01B5           strcat(Date,str_D);
	CALL SUBOPT_0xC
; 0005 01B6           LCD_WR_STR(0,1,Date);
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2MN _0xA002C,102
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 01B7           break;
	RJMP _0xA0032
; 0005 01B8         }
; 0005 01B9         break;
_0xA0046:
	RJMP _0xA0032
; 0005 01BA       }
; 0005 01BB       case Key_Right:
_0xA003D:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0xA0047
; 0005 01BC       {
; 0005 01BD         sprintf(str_D,DEC_Format,D);
	CALL SUBOPT_0x2E
; 0005 01BE         sprintf(str_M,DEC_Format,M);
	CALL SUBOPT_0x2F
; 0005 01BF         sprintf(str_Y,DEC_Format,Y);
; 0005 01C0         Date[0]='\0';
	CALL SUBOPT_0x29
; 0005 01C1         Locate++;
; 0005 01C2         if(Locate>2)
	BRLO _0xA0048
; 0005 01C3           Locate=2;
	LDI  R30,LOW(2)
	STD  Y+6,R30
; 0005 01C4         if(Locate==0)
_0xA0048:
	LDD  R30,Y+6
	CPI  R30,0
	BRNE _0xA0049
; 0005 01C5         {
; 0005 01C6           strcatf(Date,STR_ONE_SHIFT);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x1E
; 0005 01C7           strcatf(Date,STR_20);
	CALL SUBOPT_0xD
; 0005 01C8           strcat(Date,str_Y);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x30
; 0005 01C9           strcatf(Date,STR_SLASH);
	CALL SUBOPT_0x31
; 0005 01CA           strcat(Date,str_M);
	CALL SUBOPT_0x32
; 0005 01CB           strcatf(Date,STR_SLASH);
	CALL SUBOPT_0x31
; 0005 01CC           strcat(Date,str_D);
	CALL SUBOPT_0xC
; 0005 01CD           LCD_WR_STR(0,1,Date);
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2MN _0xA002C,119
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 01CE           Pointer=&Y;
	__GETWRN 20,21,17
; 0005 01CF           break;
	RJMP _0xA0032
; 0005 01D0         }
; 0005 01D1         if(Locate==1)
_0xA0049:
	LDD  R26,Y+6
	CPI  R26,LOW(0x1)
	BRNE _0xA004A
; 0005 01D2         {
; 0005 01D3           strcatf(Date,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 01D4           strcatf(Date,STR_20);
	CALL SUBOPT_0xD
; 0005 01D5           strcat(Date,str_Y);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x30
; 0005 01D6           strcatf(Date,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 01D7           strcat(Date,str_M);
	CALL SUBOPT_0x32
; 0005 01D8           strcatf(Date,STR_SLASH);
	CALL SUBOPT_0x31
; 0005 01D9           strcat(Date,str_D);
	CALL SUBOPT_0xC
; 0005 01DA           LCD_WR_STR(0,1,Date);
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2MN _0xA002C,136
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 01DB           Pointer=&M;
	__GETWRN 20,21,16
; 0005 01DC           break;
	RJMP _0xA0032
; 0005 01DD         }
; 0005 01DE         if(Locate==2)
_0xA004A:
	LDD  R26,Y+6
	CPI  R26,LOW(0x2)
	BRNE _0xA004B
; 0005 01DF         {
; 0005 01E0           strcatf(Date,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 01E1           strcatf(Date,STR_20);
	CALL SUBOPT_0xD
; 0005 01E2           strcat(Date,str_Y);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x30
; 0005 01E3           strcatf(Date,STR_SLASH);
	CALL SUBOPT_0x31
; 0005 01E4           strcat(Date,str_M);
	CALL SUBOPT_0x32
; 0005 01E5           strcatf(Date,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 01E6           strcat(Date,str_D);
	CALL SUBOPT_0xC
; 0005 01E7           LCD_WR_STR(0,1,Date);
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2MN _0xA002C,153
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 01E8           Pointer=&D;
	__GETWRN 20,21,19
; 0005 01E9           break;
	RJMP _0xA0032
; 0005 01EA         }
; 0005 01EB         break;
_0xA004B:
	RJMP _0xA0032
; 0005 01EC       }
; 0005 01ED       case Key_Left:
_0xA0047:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0xA004C
; 0005 01EE       {
; 0005 01EF         sprintf(str_D,DEC_Format,D);
	CALL SUBOPT_0x2E
; 0005 01F0         sprintf(str_M,DEC_Format,M);
	CALL SUBOPT_0x2F
; 0005 01F1         sprintf(str_Y,DEC_Format,Y);
; 0005 01F2         Date[0]='\0';
	CALL SUBOPT_0x2A
; 0005 01F3         Locate--;
; 0005 01F4         if(Locate>2)
	BRLO _0xA004D
; 0005 01F5           Locate=0;
	LDI  R30,LOW(0)
	STD  Y+6,R30
; 0005 01F6         if(Locate==0)
_0xA004D:
	LDD  R30,Y+6
	CPI  R30,0
	BRNE _0xA004E
; 0005 01F7         {
; 0005 01F8           strcatf(Date,STR_ONE_SHIFT);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x1E
; 0005 01F9           strcatf(Date,STR_20);
	CALL SUBOPT_0xD
; 0005 01FA           strcat(Date,str_Y);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x30
; 0005 01FB           strcatf(Date,STR_SLASH);
	CALL SUBOPT_0x31
; 0005 01FC           strcat(Date,str_M);
	CALL SUBOPT_0x32
; 0005 01FD           strcatf(Date,STR_SLASH);
	CALL SUBOPT_0x31
; 0005 01FE           strcat(Date,str_D);
	CALL SUBOPT_0xC
; 0005 01FF           LCD_WR_STR(0,1,Date);
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2MN _0xA002C,170
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 0200           Pointer=&Y;
	__GETWRN 20,21,17
; 0005 0201           break;
	RJMP _0xA0032
; 0005 0202         }
; 0005 0203         if(Locate==1)
_0xA004E:
	LDD  R26,Y+6
	CPI  R26,LOW(0x1)
	BRNE _0xA004F
; 0005 0204         {
; 0005 0205           strcatf(Date,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 0206           strcatf(Date,STR_20);
	CALL SUBOPT_0xD
; 0005 0207           strcat(Date,str_Y);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x30
; 0005 0208           strcatf(Date,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 0209           strcat(Date,str_M);
	CALL SUBOPT_0x32
; 0005 020A           strcatf(Date,STR_SLASH);
	CALL SUBOPT_0x31
; 0005 020B           strcat(Date,str_D);
	CALL SUBOPT_0xC
; 0005 020C           LCD_WR_STR(0,1,Date);
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2MN _0xA002C,187
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 020D           Pointer=&M;
	__GETWRN 20,21,16
; 0005 020E           break;
	RJMP _0xA0032
; 0005 020F         }
; 0005 0210         if(Locate==2)
_0xA004F:
	LDD  R26,Y+6
	CPI  R26,LOW(0x2)
	BRNE _0xA0050
; 0005 0211         {
; 0005 0212           strcatf(Date,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 0213           strcatf(Date,STR_20);
	CALL SUBOPT_0xD
; 0005 0214           strcat(Date,str_Y);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x30
; 0005 0215           strcatf(Date,STR_SLASH);
	CALL SUBOPT_0x31
; 0005 0216           strcat(Date,str_M);
	CALL SUBOPT_0x32
; 0005 0217           strcatf(Date,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 0218           strcat(Date,str_D);
	CALL SUBOPT_0xC
; 0005 0219           LCD_WR_STR(0,1,Date);
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2MN _0xA002C,204
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 021A           Pointer=&D;
	__GETWRN 20,21,19
; 0005 021B           break;
	RJMP _0xA0032
; 0005 021C         }
; 0005 021D         break;
_0xA0050:
	RJMP _0xA0032
; 0005 021E       }
; 0005 021F       case Key_Menu:
_0xA004C:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BREQ _0xA0032
; 0005 0220       {
; 0005 0221         break;
; 0005 0222       }
; 0005 0223       case Key_OK:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0xA0052
; 0005 0224       {
; 0005 0225         RTC_DS1307_Set_Date(Y,M,D);
	ST   -Y,R17
	ST   -Y,R16
	MOV  R26,R19
	CALL _RTC_DS1307_Set_Date
; 0005 0226         LCD_WR_STRF(0,1,"Save Date OK");
	CALL SUBOPT_0x13
	CALL SUBOPT_0x2B
	__POINTW2FN _0xA0000,48
	CALL SUBOPT_0x2C
; 0005 0227         delay_ms(1000);
; 0005 0228         LCD_WR_STRF(0,1,"");
	CALL SUBOPT_0x2B
	CALL SUBOPT_0x2D
; 0005 0229         T=0;
; 0005 022A         break;
	RJMP _0xA0032
; 0005 022B       }
; 0005 022C       case Key_Return:
_0xA0052:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0xA0054
; 0005 022D       {
; 0005 022E         T=0;
	LDI  R30,LOW(0)
	STD  Y+7,R30
; 0005 022F         break;
; 0005 0230       }
; 0005 0231       default:
_0xA0054:
; 0005 0232       {
; 0005 0233         break;
; 0005 0234       }
; 0005 0235     }
_0xA0032:
; 0005 0236   }
	RJMP _0xA002D
_0xA002F:
; 0005 0237 }
	CALL __LOADLOCR6
	ADIW R28,36
	RET
; .FEND

	.DSEG
_0xA002C:
	.BYTE 0xDD
;
;void Menu_Set_DOW(void)
; 0005 023A {

	.CSEG
_Menu_Set_DOW:
; .FSTART _Menu_Set_DOW
; 0005 023B   unsigned char DOW=0;
; 0005 023C   char Pressed_Key,T=1;
; 0005 023D   LCD_WR_STRF(0,0,"Set Day");
	CALL __SAVELOCR4
;	DOW -> R17
;	Pressed_Key -> R16
;	T -> R19
	LDI  R17,0
	LDI  R19,1
	CALL SUBOPT_0x10
	CALL SUBOPT_0x1A
	__POINTW2FN _0xA0000,61
	CALL SUBOPT_0x15
; 0005 023E   LCD_WR_STRF(0,1,Week_Days[DOW]);
	CALL SUBOPT_0x2B
	CALL SUBOPT_0x33
; 0005 023F   while(T)
_0xA0055:
	CPI  R19,0
	BRNE PC+2
	RJMP _0xA0057
; 0005 0240   {
; 0005 0241     delay_ms(250);
	CALL SUBOPT_0x34
; 0005 0242     Pressed_Key = Keyboard_Get_Key();
	MOV  R16,R30
; 0005 0243     switch(Pressed_Key)
	LDI  R31,0
; 0005 0244     {
; 0005 0245       case Key_UP:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0xA005B
; 0005 0246       {
; 0005 0247         DOW++;
	SUBI R17,-1
; 0005 0248         if(DOW>=7)
	CPI  R17,7
	BRLO _0xA005C
; 0005 0249         {
; 0005 024A           DOW=6;
	LDI  R17,LOW(6)
; 0005 024B         }
; 0005 024C         LCD_WR_STRF(0,1,Week_Days[DOW]);
_0xA005C:
	CALL SUBOPT_0x13
	CALL SUBOPT_0x2B
	CALL SUBOPT_0x33
; 0005 024D         break;
	RJMP _0xA005A
; 0005 024E       }
; 0005 024F       case Key_Down:
_0xA005B:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0xA005D
; 0005 0250       {
; 0005 0251         DOW--;
	SUBI R17,1
; 0005 0252         if(DOW>=7)
	CPI  R17,7
	BRLO _0xA005E
; 0005 0253         {
; 0005 0254           DOW=0;
	LDI  R17,LOW(0)
; 0005 0255         }
; 0005 0256         LCD_WR_STRF(0,1,Week_Days[DOW]);
_0xA005E:
	CALL SUBOPT_0x13
	CALL SUBOPT_0x2B
	CALL SUBOPT_0x33
; 0005 0257         break;
	RJMP _0xA005A
; 0005 0258       }
; 0005 0259       case Key_Right:
_0xA005D:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BREQ _0xA005A
; 0005 025A       {
; 0005 025B         break;
; 0005 025C       }
; 0005 025D       case Key_Left:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BREQ _0xA005A
; 0005 025E       {
; 0005 025F         break;
; 0005 0260       }
; 0005 0261       case Key_Menu:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BREQ _0xA005A
; 0005 0262       {
; 0005 0263         break;
; 0005 0264       }
; 0005 0265       case Key_OK:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0xA0062
; 0005 0266       {
; 0005 0267         RTC_DS1307_Set_DOW(DOW+1);
	MOV  R26,R17
	SUBI R26,-LOW(1)
	CALL _RTC_DS1307_Set_DOW
; 0005 0268         LCD_WR_STRF(0,1,"Save Day OK");
	CALL SUBOPT_0x13
	CALL SUBOPT_0x2B
	__POINTW2FN _0xA0000,69
	CALL _lcd_putsf
; 0005 0269         delay_ms(1000);
	LDI  R26,LOW(1000)
	LDI  R27,HIGH(1000)
	CALL _delay_ms
; 0005 026A         T=0;
	LDI  R19,LOW(0)
; 0005 026B         break;
	RJMP _0xA005A
; 0005 026C       }
; 0005 026D       case Key_Return:
_0xA0062:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0xA0064
; 0005 026E       {
; 0005 026F         T=0;
	LDI  R19,LOW(0)
; 0005 0270         break;
; 0005 0271       }
; 0005 0272       default:
_0xA0064:
; 0005 0273       {
; 0005 0274         break;
; 0005 0275       }
; 0005 0276     }
_0xA005A:
; 0005 0277   }
	RJMP _0xA0055
_0xA0057:
; 0005 0278 }
	CALL __LOADLOCR4
	ADIW R28,4
	RET
; .FEND
;
;void Menu_Set_Alarm(void)
; 0005 027B {
_Menu_Set_Alarm:
; .FSTART _Menu_Set_Alarm
; 0005 027C   Alarm A;
; 0005 027D   unsigned char S=0,M=0,H=0,E_D=0,Alarm_ID=8;
; 0005 027E   unsigned char *Pointer=&H;
; 0005 027F   char str_S[4],str_M[4],str_H[4],Alarm_Time[20];
; 0005 0280   char Pressed_Key,T=1,Locate=0;
; 0005 0281   Alarm_Time[0]='\0';
	SBIW R28,40
	LDI  R24,36
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0xA0065*2)
	LDI  R31,HIGH(_0xA0065*2)
	CALL __INITLOCB
	CALL __SAVELOCR6
;	A -> Y+42
;	S -> R17
;	M -> R16
;	H -> R19
;	E_D -> R18
;	Alarm_ID -> R21
;	*Pointer -> Y+40
;	str_S -> Y+36
;	str_M -> Y+32
;	str_H -> Y+28
;	Alarm_Time -> Y+8
;	Pressed_Key -> R20
;	T -> Y+7
;	Locate -> Y+6
	LDI  R17,0
	LDI  R16,0
	LDI  R19,0
	LDI  R18,0
	LDI  R21,8
	CALL SUBOPT_0x19
; 0005 0282   LCD_WR_STRF(0,0,"Set Alarm 1");
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x35
; 0005 0283   Alarm_Read(&A,Alarm_ID);
; 0005 0284   E_D = A.Enable_Disable;
; 0005 0285   H   = A.Hour;
; 0005 0286   M   = A.Minute;
; 0005 0287   S   = A.Second;
; 0005 0288   sprintf(str_S,DEC_Format,S);
; 0005 0289   sprintf(str_M,DEC_Format,M);
	CALL SUBOPT_0x36
; 0005 028A   sprintf(str_H,DEC_Format,H);
; 0005 028B   Alarm_Time[0]='\0';
	CALL SUBOPT_0x37
; 0005 028C   strcatf(Alarm_Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 028D   strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 028E   strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 028F   strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 0290   strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 0291   strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 0292   if(E_D==0)
	BRNE _0xA0066
; 0005 0293     strcatf(Alarm_Time,STR_0_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3B
; 0005 0294   if(E_D==1)
_0xA0066:
	CPI  R18,1
	BRNE _0xA0067
; 0005 0295     strcatf(Alarm_Time,STR_0_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3C
; 0005 0296 
; 0005 0297   LCD_WR_STR(0,1,Alarm_Time);
_0xA0067:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,0
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 0298   while(T)
_0xA0069:
	LDD  R30,Y+7
	CPI  R30,0
	BRNE PC+2
	RJMP _0xA006B
; 0005 0299   {
; 0005 029A     delay_ms(250);
	CALL SUBOPT_0x34
; 0005 029B     Pressed_Key = Keyboard_Get_Key();
	MOV  R20,R30
; 0005 029C     switch(Pressed_Key)
	LDI  R31,0
; 0005 029D     {
; 0005 029E       case Key_UP:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0xA006F
; 0005 029F       {
; 0005 02A0         (*Pointer)++;
	LDD  R26,Y+40
	LDD  R27,Y+40+1
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
; 0005 02A1         if(Locate==0)
	LDD  R30,Y+6
	CPI  R30,0
	BRNE _0xA0070
; 0005 02A2         {
; 0005 02A3           if((*Pointer)>23)
	LD   R26,X
	CPI  R26,LOW(0x18)
	BRLO _0xA0071
; 0005 02A4             (*Pointer)=23;
	LDD  R26,Y+40
	LDD  R27,Y+40+1
	LDI  R30,LOW(23)
	ST   X,R30
; 0005 02A5         }
_0xA0071:
; 0005 02A6         if(Locate==1)
_0xA0070:
	LDD  R26,Y+6
	CPI  R26,LOW(0x1)
	BRNE _0xA0072
; 0005 02A7         {
; 0005 02A8           if((*Pointer)>59)
	CALL SUBOPT_0x3D
	BRLO _0xA0073
; 0005 02A9            (*Pointer)=59;
	LDD  R26,Y+40
	LDD  R27,Y+40+1
	LDI  R30,LOW(59)
	ST   X,R30
; 0005 02AA         }
_0xA0073:
; 0005 02AB         if(Locate==2)
_0xA0072:
	LDD  R26,Y+6
	CPI  R26,LOW(0x2)
	BRNE _0xA0074
; 0005 02AC         {
; 0005 02AD           if((*Pointer)>59)
	CALL SUBOPT_0x3D
	BRLO _0xA0075
; 0005 02AE            (*Pointer)=59;
	LDD  R26,Y+40
	LDD  R27,Y+40+1
	LDI  R30,LOW(59)
	ST   X,R30
; 0005 02AF         }
_0xA0075:
; 0005 02B0         if(Locate==3)
_0xA0074:
	LDD  R26,Y+6
	CPI  R26,LOW(0x3)
	BRNE _0xA0076
; 0005 02B1         {
; 0005 02B2           if((*Pointer)>1)
	LDD  R26,Y+40
	LDD  R27,Y+40+1
	LD   R26,X
	CPI  R26,LOW(0x2)
	BRLO _0xA0077
; 0005 02B3            (*Pointer)=1;
	LDD  R26,Y+40
	LDD  R27,Y+40+1
	LDI  R30,LOW(1)
	ST   X,R30
; 0005 02B4         }
_0xA0077:
; 0005 02B5         sprintf(str_S,DEC_Format,S);
_0xA0076:
	CALL SUBOPT_0x3E
; 0005 02B6         sprintf(str_M,DEC_Format,M);
	CALL SUBOPT_0x36
; 0005 02B7         sprintf(str_H,DEC_Format,H);
; 0005 02B8         Alarm_Time[0]='\0';
	CALL SUBOPT_0x26
; 0005 02B9         if(Locate==0)
	BRNE _0xA0078
; 0005 02BA         {
; 0005 02BB           strcatf(Alarm_Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x1E
; 0005 02BC           strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 02BD           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 02BE           strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 02BF           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 02C0           strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 02C1           if(E_D==0)
	BRNE _0xA0079
; 0005 02C2             strcatf(Alarm_Time,STR_0_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3B
; 0005 02C3           if(E_D==1)
_0xA0079:
	CPI  R18,1
	BRNE _0xA007A
; 0005 02C4             strcatf(Alarm_Time,STR_0_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3C
; 0005 02C5 
; 0005 02C6           LCD_WR_STR(0,1,Alarm_Time);
_0xA007A:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,17
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 02C7           break;
	RJMP _0xA006E
; 0005 02C8         }
; 0005 02C9         if(Locate==1)
_0xA0078:
	LDD  R26,Y+6
	CPI  R26,LOW(0x1)
	BRNE _0xA007B
; 0005 02CA         {
; 0005 02CB           strcatf(Alarm_Time,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 02CC           strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 02CD           strcatf(Alarm_Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 02CE           strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 02CF           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 02D0           strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 02D1           if(E_D==0)
	BRNE _0xA007C
; 0005 02D2             strcatf(Alarm_Time,STR_0_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3B
; 0005 02D3           if(E_D==1)
_0xA007C:
	CPI  R18,1
	BRNE _0xA007D
; 0005 02D4             strcatf(Alarm_Time,STR_0_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3C
; 0005 02D5 
; 0005 02D6           LCD_WR_STR(0,1,Alarm_Time);
_0xA007D:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,34
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 02D7           break;
	RJMP _0xA006E
; 0005 02D8         }
; 0005 02D9         if(Locate==2)
_0xA007B:
	LDD  R26,Y+6
	CPI  R26,LOW(0x2)
	BRNE _0xA007E
; 0005 02DA         {
; 0005 02DB           strcatf(Alarm_Time,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 02DC           strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 02DD           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 02DE           strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 02DF           strcatf(Alarm_Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 02E0           strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 02E1           if(E_D==0)
	BRNE _0xA007F
; 0005 02E2             strcatf(Alarm_Time,STR_0_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3B
; 0005 02E3           if(E_D==1)
_0xA007F:
	CPI  R18,1
	BRNE _0xA0080
; 0005 02E4             strcatf(Alarm_Time,STR_0_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3C
; 0005 02E5 
; 0005 02E6           LCD_WR_STR(0,1,Alarm_Time);
_0xA0080:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,51
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 02E7           break;
	RJMP _0xA006E
; 0005 02E8         }
; 0005 02E9         if(Locate==3)
_0xA007E:
	LDD  R26,Y+6
	CPI  R26,LOW(0x3)
	BRNE _0xA0081
; 0005 02EA         {
; 0005 02EB           strcatf(Alarm_Time,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 02EC           strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 02ED           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 02EE           strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 02EF           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 02F0           strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 02F1           if(E_D==0)
	BRNE _0xA0082
; 0005 02F2             strcatf(Alarm_Time,STR_1_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3F
; 0005 02F3           if(E_D==1)
_0xA0082:
	CPI  R18,1
	BRNE _0xA0083
; 0005 02F4             strcatf(Alarm_Time,STR_1_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x40
; 0005 02F5 
; 0005 02F6           LCD_WR_STR(0,1,Alarm_Time);
_0xA0083:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,68
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 02F7           break;
	RJMP _0xA006E
; 0005 02F8         }
; 0005 02F9         break;
_0xA0081:
	RJMP _0xA006E
; 0005 02FA       }
; 0005 02FB       case Key_Down:
_0xA006F:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0xA0084
; 0005 02FC       {
; 0005 02FD         (*Pointer)--;
	LDD  R26,Y+40
	LDD  R27,Y+40+1
	LD   R30,X
	SUBI R30,LOW(1)
	ST   X,R30
; 0005 02FE         if(Locate==0)
	LDD  R30,Y+6
	CPI  R30,0
	BRNE _0xA0085
; 0005 02FF         {
; 0005 0300           if((*Pointer)>23)
	LD   R26,X
	CPI  R26,LOW(0x18)
	BRLO _0xA0086
; 0005 0301             (*Pointer)=0;
	CALL SUBOPT_0x41
; 0005 0302         }
_0xA0086:
; 0005 0303         if(Locate==1)
_0xA0085:
	LDD  R26,Y+6
	CPI  R26,LOW(0x1)
	BRNE _0xA0087
; 0005 0304         {
; 0005 0305           if((*Pointer)>59)
	CALL SUBOPT_0x3D
	BRLO _0xA0088
; 0005 0306            (*Pointer)=0;
	CALL SUBOPT_0x41
; 0005 0307         }
_0xA0088:
; 0005 0308         if(Locate==2)
_0xA0087:
	LDD  R26,Y+6
	CPI  R26,LOW(0x2)
	BRNE _0xA0089
; 0005 0309         {
; 0005 030A           if((*Pointer)>59)
	CALL SUBOPT_0x3D
	BRLO _0xA008A
; 0005 030B            (*Pointer)=0;
	CALL SUBOPT_0x41
; 0005 030C         }
_0xA008A:
; 0005 030D         if(Locate==3)
_0xA0089:
	LDD  R26,Y+6
	CPI  R26,LOW(0x3)
	BRNE _0xA008B
; 0005 030E         {
; 0005 030F           if((*Pointer)>1)
	LDD  R26,Y+40
	LDD  R27,Y+40+1
	LD   R26,X
	CPI  R26,LOW(0x2)
	BRLO _0xA008C
; 0005 0310            (*Pointer)=0;
	CALL SUBOPT_0x41
; 0005 0311         }
_0xA008C:
; 0005 0312         sprintf(str_S,DEC_Format,S);
_0xA008B:
	CALL SUBOPT_0x3E
; 0005 0313         sprintf(str_M,DEC_Format,M);
	CALL SUBOPT_0x36
; 0005 0314         sprintf(str_H,DEC_Format,H);
; 0005 0315         Alarm_Time[0]='\0';
	CALL SUBOPT_0x26
; 0005 0316         if(Locate==0)
	BRNE _0xA008D
; 0005 0317         {
; 0005 0318           strcatf(Alarm_Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x1E
; 0005 0319           strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 031A           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 031B           strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 031C           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 031D           strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 031E           if(E_D==0)
	BRNE _0xA008E
; 0005 031F             strcatf(Alarm_Time,STR_0_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3B
; 0005 0320           if(E_D==1)
_0xA008E:
	CPI  R18,1
	BRNE _0xA008F
; 0005 0321             strcatf(Alarm_Time,STR_0_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3C
; 0005 0322 
; 0005 0323           LCD_WR_STR(0,1,Alarm_Time);
_0xA008F:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,85
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 0324           break;
	RJMP _0xA006E
; 0005 0325         }
; 0005 0326         if(Locate==1)
_0xA008D:
	LDD  R26,Y+6
	CPI  R26,LOW(0x1)
	BRNE _0xA0090
; 0005 0327         {
; 0005 0328           strcatf(Alarm_Time,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 0329           strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 032A           strcatf(Alarm_Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 032B           strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 032C           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 032D           strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 032E           if(E_D==0)
	BRNE _0xA0091
; 0005 032F             strcatf(Alarm_Time,STR_0_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3B
; 0005 0330           if(E_D==1)
_0xA0091:
	CPI  R18,1
	BRNE _0xA0092
; 0005 0331             strcatf(Alarm_Time,STR_0_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3C
; 0005 0332 
; 0005 0333           LCD_WR_STR(0,1,Alarm_Time);
_0xA0092:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,102
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 0334           break;
	RJMP _0xA006E
; 0005 0335         }
; 0005 0336         if(Locate==2)
_0xA0090:
	LDD  R26,Y+6
	CPI  R26,LOW(0x2)
	BRNE _0xA0093
; 0005 0337         {
; 0005 0338           strcatf(Alarm_Time,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 0339           strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 033A           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 033B           strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 033C           strcatf(Alarm_Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 033D           strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 033E           if(E_D==0)
	BRNE _0xA0094
; 0005 033F             strcatf(Alarm_Time,STR_0_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3B
; 0005 0340           if(E_D==1)
_0xA0094:
	CPI  R18,1
	BRNE _0xA0095
; 0005 0341             strcatf(Alarm_Time,STR_0_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3C
; 0005 0342 
; 0005 0343           LCD_WR_STR(0,1,Alarm_Time);
_0xA0095:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,119
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 0344           break;
	RJMP _0xA006E
; 0005 0345         }
; 0005 0346         if(Locate==3)
_0xA0093:
	LDD  R26,Y+6
	CPI  R26,LOW(0x3)
	BRNE _0xA0096
; 0005 0347         {
; 0005 0348           strcatf(Alarm_Time,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 0349           strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 034A           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 034B           strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 034C           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 034D           strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 034E           if(E_D==0)
	BRNE _0xA0097
; 0005 034F             strcatf(Alarm_Time,STR_1_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3F
; 0005 0350           if(E_D==1)
_0xA0097:
	CPI  R18,1
	BRNE _0xA0098
; 0005 0351             strcatf(Alarm_Time,STR_1_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x40
; 0005 0352 
; 0005 0353           LCD_WR_STR(0,1,Alarm_Time);
_0xA0098:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,136
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 0354           break;
	RJMP _0xA006E
; 0005 0355         }
; 0005 0356         break;
_0xA0096:
	RJMP _0xA006E
; 0005 0357       }
; 0005 0358       case Key_Right:
_0xA0084:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0xA0099
; 0005 0359       {
; 0005 035A         sprintf(str_S,DEC_Format,S);
	CALL SUBOPT_0x3E
; 0005 035B         sprintf(str_M,DEC_Format,M);
	CALL SUBOPT_0x36
; 0005 035C         sprintf(str_H,DEC_Format,H);
; 0005 035D         Alarm_Time[0]='\0';
	LDI  R30,LOW(0)
	STD  Y+8,R30
; 0005 035E         Locate++;
	LDD  R30,Y+6
	SUBI R30,-LOW(1)
	STD  Y+6,R30
; 0005 035F         if(Locate>3)
	LDD  R26,Y+6
	CPI  R26,LOW(0x4)
	BRLO _0xA009A
; 0005 0360           Locate=3;
	LDI  R30,LOW(3)
	STD  Y+6,R30
; 0005 0361         if(Locate==0)
_0xA009A:
	LDD  R30,Y+6
	CPI  R30,0
	BRNE _0xA009B
; 0005 0362         {
; 0005 0363           strcatf(Alarm_Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x1E
; 0005 0364           strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 0365           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 0366           strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 0367           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 0368           strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 0369           if(E_D==0)
	BRNE _0xA009C
; 0005 036A             strcatf(Alarm_Time,STR_0_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3B
; 0005 036B           if(E_D==1)
_0xA009C:
	CPI  R18,1
	BRNE _0xA009D
; 0005 036C             strcatf(Alarm_Time,STR_0_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3C
; 0005 036D 
; 0005 036E           LCD_WR_STR(0,1,Alarm_Time);
_0xA009D:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,153
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 036F           Pointer=&H;
	CALL SUBOPT_0x42
; 0005 0370           break;
	RJMP _0xA006E
; 0005 0371         }
; 0005 0372         if(Locate==1)
_0xA009B:
	LDD  R26,Y+6
	CPI  R26,LOW(0x1)
	BRNE _0xA009E
; 0005 0373         {
; 0005 0374           strcatf(Alarm_Time,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 0375           strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 0376           strcatf(Alarm_Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 0377           strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 0378           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 0379           strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 037A           if(E_D==0)
	BRNE _0xA009F
; 0005 037B             strcatf(Alarm_Time,STR_0_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3B
; 0005 037C           if(E_D==1)
_0xA009F:
	CPI  R18,1
	BRNE _0xA00A0
; 0005 037D             strcatf(Alarm_Time,STR_0_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3C
; 0005 037E 
; 0005 037F           LCD_WR_STR(0,1,Alarm_Time);
_0xA00A0:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,170
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 0380           Pointer=&M;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	STD  Y+40,R30
	STD  Y+40+1,R31
; 0005 0381           break;
	RJMP _0xA006E
; 0005 0382         }
; 0005 0383         if(Locate==2)
_0xA009E:
	LDD  R26,Y+6
	CPI  R26,LOW(0x2)
	BRNE _0xA00A1
; 0005 0384         {
; 0005 0385           strcatf(Alarm_Time,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 0386           strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 0387           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 0388           strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 0389           strcatf(Alarm_Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 038A           strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 038B           if(E_D==0)
	BRNE _0xA00A2
; 0005 038C             strcatf(Alarm_Time,STR_0_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3B
; 0005 038D           if(E_D==1)
_0xA00A2:
	CPI  R18,1
	BRNE _0xA00A3
; 0005 038E             strcatf(Alarm_Time,STR_0_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3C
; 0005 038F 
; 0005 0390           LCD_WR_STR(0,1,Alarm_Time);
_0xA00A3:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,187
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 0391           Pointer=&S;
	LDI  R30,LOW(17)
	LDI  R31,HIGH(17)
	STD  Y+40,R30
	STD  Y+40+1,R31
; 0005 0392           break;
	RJMP _0xA006E
; 0005 0393         }
; 0005 0394         if(Locate==3)
_0xA00A1:
	LDD  R26,Y+6
	CPI  R26,LOW(0x3)
	BRNE _0xA00A4
; 0005 0395         {
; 0005 0396           strcatf(Alarm_Time,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 0397           strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 0398           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 0399           strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 039A           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 039B           strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 039C           if(E_D==0)
	BRNE _0xA00A5
; 0005 039D             strcatf(Alarm_Time,STR_1_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3F
; 0005 039E           if(E_D==1)
_0xA00A5:
	CPI  R18,1
	BRNE _0xA00A6
; 0005 039F             strcatf(Alarm_Time,STR_1_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x40
; 0005 03A0 
; 0005 03A1           LCD_WR_STR(0,1,Alarm_Time);
_0xA00A6:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,204
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 03A2           Pointer=&E_D;
	LDI  R30,LOW(18)
	LDI  R31,HIGH(18)
	STD  Y+40,R30
	STD  Y+40+1,R31
; 0005 03A3           break;
	RJMP _0xA006E
; 0005 03A4         }
; 0005 03A5         break;
_0xA00A4:
	RJMP _0xA006E
; 0005 03A6       }
; 0005 03A7       case Key_Left:
_0xA0099:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0xA00A7
; 0005 03A8       {
; 0005 03A9         sprintf(str_S,DEC_Format,S);
	CALL SUBOPT_0x3E
; 0005 03AA         sprintf(str_M,DEC_Format,M);
	CALL SUBOPT_0x36
; 0005 03AB         sprintf(str_H,DEC_Format,H);
; 0005 03AC         Alarm_Time[0]='\0';
	CALL SUBOPT_0x2A
; 0005 03AD         Locate--;
; 0005 03AE         if(Locate>2)
	BRLO _0xA00A8
; 0005 03AF           Locate=0;
	LDI  R30,LOW(0)
	STD  Y+6,R30
; 0005 03B0         if(Locate==0)
_0xA00A8:
	LDD  R30,Y+6
	CPI  R30,0
	BRNE _0xA00A9
; 0005 03B1         {
; 0005 03B2           strcatf(Alarm_Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x1E
; 0005 03B3           strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 03B4           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 03B5           strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 03B6           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 03B7           strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 03B8           if(E_D==0)
	BRNE _0xA00AA
; 0005 03B9             strcatf(Alarm_Time,STR_0_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3B
; 0005 03BA           if(E_D==1)
_0xA00AA:
	CPI  R18,1
	BRNE _0xA00AB
; 0005 03BB             strcatf(Alarm_Time,STR_0_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3C
; 0005 03BC 
; 0005 03BD           LCD_WR_STR(0,1,Alarm_Time);
_0xA00AB:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,221
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 03BE           Pointer=&H;
	CALL SUBOPT_0x42
; 0005 03BF           break;
	RJMP _0xA006E
; 0005 03C0         }
; 0005 03C1         if(Locate==1)
_0xA00A9:
	LDD  R26,Y+6
	CPI  R26,LOW(0x1)
	BRNE _0xA00AC
; 0005 03C2         {
; 0005 03C3           strcatf(Alarm_Time,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 03C4           strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 03C5           strcatf(Alarm_Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 03C6           strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 03C7           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 03C8           strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 03C9           if(E_D==0)
	BRNE _0xA00AD
; 0005 03CA             strcatf(Alarm_Time,STR_0_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3B
; 0005 03CB           if(E_D==1)
_0xA00AD:
	CPI  R18,1
	BRNE _0xA00AE
; 0005 03CC             strcatf(Alarm_Time,STR_0_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3C
; 0005 03CD 
; 0005 03CE           LCD_WR_STR(0,1,Alarm_Time);
_0xA00AE:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,238
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 03CF           Pointer=&M;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	STD  Y+40,R30
	STD  Y+40+1,R31
; 0005 03D0           break;
	RJMP _0xA006E
; 0005 03D1         }
; 0005 03D2         if(Locate==2)
_0xA00AC:
	LDD  R26,Y+6
	CPI  R26,LOW(0x2)
	BRNE _0xA00AF
; 0005 03D3         {
; 0005 03D4           strcatf(Alarm_Time,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 03D5           strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 03D6           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 03D7           strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 03D8           strcatf(Alarm_Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 03D9           strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 03DA           if(E_D==0)
	BRNE _0xA00B0
; 0005 03DB             strcatf(Alarm_Time,STR_0_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3B
; 0005 03DC           if(E_D==1)
_0xA00B0:
	CPI  R18,1
	BRNE _0xA00B1
; 0005 03DD             strcatf(Alarm_Time,STR_0_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3C
; 0005 03DE 
; 0005 03DF           LCD_WR_STR(0,1,Alarm_Time);
_0xA00B1:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,255
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 03E0           Pointer=&S;
	LDI  R30,LOW(17)
	LDI  R31,HIGH(17)
	STD  Y+40,R30
	STD  Y+40+1,R31
; 0005 03E1           break;
	RJMP _0xA006E
; 0005 03E2         }
; 0005 03E3         if(Locate==0)
_0xA00AF:
	LDD  R30,Y+6
	CPI  R30,0
	BRNE _0xA00B2
; 0005 03E4         {
; 0005 03E5           strcatf(Alarm_Time,STR_SPACE);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x27
; 0005 03E6           strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 03E7           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 03E8           strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 03E9           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 03EA           strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 03EB           if(E_D==0)
	BRNE _0xA00B3
; 0005 03EC             strcatf(Alarm_Time,STR_1_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3F
; 0005 03ED           if(E_D==1)
_0xA00B3:
	CPI  R18,1
	BRNE _0xA00B4
; 0005 03EE             strcatf(Alarm_Time,STR_1_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x40
; 0005 03EF 
; 0005 03F0           LCD_WR_STR(0,1,Alarm_Time);
_0xA00B4:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,272
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 03F1           Pointer=&E_D;
	LDI  R30,LOW(18)
	LDI  R31,HIGH(18)
	STD  Y+40,R30
	STD  Y+40+1,R31
; 0005 03F2           break;
	RJMP _0xA006E
; 0005 03F3         }
; 0005 03F4         break;
_0xA00B2:
	RJMP _0xA006E
; 0005 03F5       }
; 0005 03F6       case Key_Menu:
_0xA00A7:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0xA00B5
; 0005 03F7       {
; 0005 03F8         Alarm_ID+=4;
	SUBI R21,-LOW(4)
; 0005 03F9         if(Alarm_ID>44)
	CPI  R21,45
	BRLO _0xA00B6
; 0005 03FA         {
; 0005 03FB           Alarm_ID=8;
	LDI  R21,LOW(8)
; 0005 03FC         }
; 0005 03FD         if(Alarm_ID==Alarm_1)
_0xA00B6:
	LDI  R30,LOW(_Alarm_1*2)
	LDI  R31,HIGH(_Alarm_1*2)
	LPM  R30,Z
	CP   R30,R21
	BRNE _0xA00B7
; 0005 03FE         {
; 0005 03FF           LCD_WR_STRF(0,0,"Set Alarm 1");
	CALL SUBOPT_0x10
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x35
; 0005 0400           Alarm_Read(&A,Alarm_ID);
; 0005 0401           E_D = A.Enable_Disable;
; 0005 0402           H   = A.Hour;
; 0005 0403           M   = A.Minute;
; 0005 0404           S   = A.Second;
; 0005 0405           sprintf(str_S,DEC_Format,S);
; 0005 0406           sprintf(str_M,DEC_Format,M);
	CALL SUBOPT_0x36
; 0005 0407           sprintf(str_H,DEC_Format,H);
; 0005 0408           Alarm_Time[0]='\0';
	CALL SUBOPT_0x37
; 0005 0409           strcatf(Alarm_Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 040A           strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 040B           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 040C           strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 040D           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 040E           strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 040F           if(E_D==0)
	BRNE _0xA00B8
; 0005 0410             strcatf(Alarm_Time,STR_0_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3B
; 0005 0411           if(E_D==1)
_0xA00B8:
	CPI  R18,1
	BRNE _0xA00B9
; 0005 0412             strcatf(Alarm_Time,STR_0_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3C
; 0005 0413 
; 0005 0414           LCD_WR_STR(0,1,Alarm_Time);
_0xA00B9:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,289
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 0415           Pointer=&H;
	CALL SUBOPT_0x42
; 0005 0416           Locate=0;
	LDI  R30,LOW(0)
	STD  Y+6,R30
; 0005 0417         }
; 0005 0418         if(Alarm_ID==Alarm_2)
_0xA00B7:
	LDI  R30,LOW(_Alarm_2*2)
	LDI  R31,HIGH(_Alarm_2*2)
	LPM  R30,Z
	CP   R30,R21
	BRNE _0xA00BA
; 0005 0419         {
; 0005 041A           LCD_WR_STRF(0,0,"Set Alarm 2");
	CALL SUBOPT_0x10
	CALL SUBOPT_0x1A
	__POINTW2FN _0xA0000,93
	CALL SUBOPT_0x43
; 0005 041B           Alarm_Read(&A,Alarm_ID);
; 0005 041C           E_D = A.Enable_Disable;
; 0005 041D           H   = A.Hour;
; 0005 041E           M   = A.Minute;
; 0005 041F           S   = A.Second;
; 0005 0420           sprintf(str_S,DEC_Format,S);
; 0005 0421           sprintf(str_M,DEC_Format,M);
	CALL SUBOPT_0x36
; 0005 0422           sprintf(str_H,DEC_Format,H);
; 0005 0423           Alarm_Time[0]='\0';
	CALL SUBOPT_0x37
; 0005 0424           strcatf(Alarm_Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 0425           strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 0426           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 0427           strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 0428           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 0429           strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 042A           if(E_D==0)
	BRNE _0xA00BB
; 0005 042B             strcatf(Alarm_Time,STR_0_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3B
; 0005 042C           if(E_D==1)
_0xA00BB:
	CPI  R18,1
	BRNE _0xA00BC
; 0005 042D             strcatf(Alarm_Time,STR_0_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3C
; 0005 042E 
; 0005 042F           LCD_WR_STR(0,1,Alarm_Time);
_0xA00BC:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,306
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 0430           Pointer=&H;
	CALL SUBOPT_0x42
; 0005 0431           Locate=0;
	LDI  R30,LOW(0)
	STD  Y+6,R30
; 0005 0432         }
; 0005 0433         if(Alarm_ID==Alarm_3)
_0xA00BA:
	LDI  R30,LOW(_Alarm_3*2)
	LDI  R31,HIGH(_Alarm_3*2)
	LPM  R30,Z
	CP   R30,R21
	BRNE _0xA00BD
; 0005 0434         {
; 0005 0435           LCD_WR_STRF(0,0,"Set Alarm 3");
	CALL SUBOPT_0x10
	CALL SUBOPT_0x1A
	__POINTW2FN _0xA0000,105
	CALL SUBOPT_0x43
; 0005 0436           Alarm_Read(&A,Alarm_ID);
; 0005 0437           E_D = A.Enable_Disable;
; 0005 0438           H   = A.Hour;
; 0005 0439           M   = A.Minute;
; 0005 043A           S   = A.Second;
; 0005 043B           sprintf(str_S,DEC_Format,S);
; 0005 043C           sprintf(str_M,DEC_Format,M);
	CALL SUBOPT_0x36
; 0005 043D           sprintf(str_H,DEC_Format,H);
; 0005 043E           Alarm_Time[0]='\0';
	CALL SUBOPT_0x37
; 0005 043F           strcatf(Alarm_Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 0440           strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 0441           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 0442           strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 0443           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 0444           strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 0445           if(E_D==0)
	BRNE _0xA00BE
; 0005 0446             strcatf(Alarm_Time,STR_0_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3B
; 0005 0447           if(E_D==1)
_0xA00BE:
	CPI  R18,1
	BRNE _0xA00BF
; 0005 0448             strcatf(Alarm_Time,STR_0_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3C
; 0005 0449 
; 0005 044A           LCD_WR_STR(0,1,Alarm_Time);
_0xA00BF:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,323
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 044B           Pointer=&H;
	CALL SUBOPT_0x42
; 0005 044C           Locate=0;
	LDI  R30,LOW(0)
	STD  Y+6,R30
; 0005 044D         }
; 0005 044E         if(Alarm_ID==Alarm_4)
_0xA00BD:
	LDI  R30,LOW(_Alarm_4*2)
	LDI  R31,HIGH(_Alarm_4*2)
	LPM  R30,Z
	CP   R30,R21
	BRNE _0xA00C0
; 0005 044F         {
; 0005 0450           LCD_WR_STRF(0,0,"Set Alarm 4");
	CALL SUBOPT_0x10
	CALL SUBOPT_0x1A
	__POINTW2FN _0xA0000,117
	CALL SUBOPT_0x43
; 0005 0451           Alarm_Read(&A,Alarm_ID);
; 0005 0452           E_D = A.Enable_Disable;
; 0005 0453           H   = A.Hour;
; 0005 0454           M   = A.Minute;
; 0005 0455           S   = A.Second;
; 0005 0456           sprintf(str_S,DEC_Format,S);
; 0005 0457           sprintf(str_M,DEC_Format,M);
	CALL SUBOPT_0x36
; 0005 0458           sprintf(str_H,DEC_Format,H);
; 0005 0459           Alarm_Time[0]='\0';
	CALL SUBOPT_0x37
; 0005 045A           strcatf(Alarm_Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 045B           strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 045C           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 045D           strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 045E           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 045F           strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 0460           if(E_D==0)
	BRNE _0xA00C1
; 0005 0461             strcatf(Alarm_Time,STR_0_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3B
; 0005 0462           if(E_D==1)
_0xA00C1:
	CPI  R18,1
	BRNE _0xA00C2
; 0005 0463             strcatf(Alarm_Time,STR_0_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3C
; 0005 0464 
; 0005 0465           LCD_WR_STR(0,1,Alarm_Time);
_0xA00C2:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,340
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 0466           Pointer=&H;
	CALL SUBOPT_0x42
; 0005 0467           Locate=0;
	LDI  R30,LOW(0)
	STD  Y+6,R30
; 0005 0468         }
; 0005 0469         if(Alarm_ID==Alarm_5)
_0xA00C0:
	LDI  R30,LOW(_Alarm_5*2)
	LDI  R31,HIGH(_Alarm_5*2)
	LPM  R30,Z
	CP   R30,R21
	BRNE _0xA00C3
; 0005 046A         {
; 0005 046B           LCD_WR_STRF(0,0,"Set Alarm 5");
	CALL SUBOPT_0x10
	CALL SUBOPT_0x1A
	__POINTW2FN _0xA0000,129
	CALL SUBOPT_0x43
; 0005 046C           Alarm_Read(&A,Alarm_ID);
; 0005 046D           E_D = A.Enable_Disable;
; 0005 046E           H   = A.Hour;
; 0005 046F           M   = A.Minute;
; 0005 0470           S   = A.Second;
; 0005 0471           sprintf(str_S,DEC_Format,S);
; 0005 0472           sprintf(str_M,DEC_Format,M);
	CALL SUBOPT_0x36
; 0005 0473           sprintf(str_H,DEC_Format,H);
; 0005 0474           Alarm_Time[0]='\0';
	CALL SUBOPT_0x37
; 0005 0475           strcatf(Alarm_Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 0476           strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 0477           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 0478           strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 0479           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 047A           strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 047B           if(E_D==0)
	BRNE _0xA00C4
; 0005 047C             strcatf(Alarm_Time,STR_0_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3B
; 0005 047D           if(E_D==1)
_0xA00C4:
	CPI  R18,1
	BRNE _0xA00C5
; 0005 047E             strcatf(Alarm_Time,STR_0_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3C
; 0005 047F 
; 0005 0480           LCD_WR_STR(0,1,Alarm_Time);
_0xA00C5:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,357
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 0481           Pointer=&H;
	CALL SUBOPT_0x42
; 0005 0482           Locate=0;
	LDI  R30,LOW(0)
	STD  Y+6,R30
; 0005 0483         }
; 0005 0484         if(Alarm_ID==Alarm_6)
_0xA00C3:
	LDI  R30,LOW(_Alarm_6*2)
	LDI  R31,HIGH(_Alarm_6*2)
	LPM  R30,Z
	CP   R30,R21
	BRNE _0xA00C6
; 0005 0485         {
; 0005 0486           LCD_WR_STRF(0,0,"Set Alarm 6");
	CALL SUBOPT_0x10
	CALL SUBOPT_0x1A
	__POINTW2FN _0xA0000,141
	CALL SUBOPT_0x43
; 0005 0487           Alarm_Read(&A,Alarm_ID);
; 0005 0488           E_D = A.Enable_Disable;
; 0005 0489           H   = A.Hour;
; 0005 048A           M   = A.Minute;
; 0005 048B           S   = A.Second;
; 0005 048C           sprintf(str_S,DEC_Format,S);
; 0005 048D           sprintf(str_M,DEC_Format,M);
	CALL SUBOPT_0x36
; 0005 048E           sprintf(str_H,DEC_Format,H);
; 0005 048F           Alarm_Time[0]='\0';
	CALL SUBOPT_0x37
; 0005 0490           strcatf(Alarm_Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 0491           strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 0492           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 0493           strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 0494           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 0495           strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 0496           if(E_D==0)
	BRNE _0xA00C7
; 0005 0497             strcatf(Alarm_Time,STR_0_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3B
; 0005 0498           if(E_D==1)
_0xA00C7:
	CPI  R18,1
	BRNE _0xA00C8
; 0005 0499             strcatf(Alarm_Time,STR_0_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3C
; 0005 049A 
; 0005 049B           LCD_WR_STR(0,1,Alarm_Time);
_0xA00C8:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,374
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 049C           Pointer=&H;
	CALL SUBOPT_0x42
; 0005 049D           Locate=0;
	LDI  R30,LOW(0)
	STD  Y+6,R30
; 0005 049E         }
; 0005 049F         if(Alarm_ID==Alarm_7)
_0xA00C6:
	LDI  R30,LOW(_Alarm_7*2)
	LDI  R31,HIGH(_Alarm_7*2)
	LPM  R30,Z
	CP   R30,R21
	BRNE _0xA00C9
; 0005 04A0         {
; 0005 04A1           LCD_WR_STRF(0,0,"Set Alarm 7");
	CALL SUBOPT_0x10
	CALL SUBOPT_0x1A
	__POINTW2FN _0xA0000,153
	CALL SUBOPT_0x43
; 0005 04A2           Alarm_Read(&A,Alarm_ID);
; 0005 04A3           E_D = A.Enable_Disable;
; 0005 04A4           H   = A.Hour;
; 0005 04A5           M   = A.Minute;
; 0005 04A6           S   = A.Second;
; 0005 04A7           sprintf(str_S,DEC_Format,S);
; 0005 04A8           sprintf(str_M,DEC_Format,M);
	CALL SUBOPT_0x36
; 0005 04A9           sprintf(str_H,DEC_Format,H);
; 0005 04AA           Alarm_Time[0]='\0';
	CALL SUBOPT_0x37
; 0005 04AB           strcatf(Alarm_Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 04AC           strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 04AD           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 04AE           strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 04AF           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 04B0           strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 04B1           if(E_D==0)
	BRNE _0xA00CA
; 0005 04B2             strcatf(Alarm_Time,STR_0_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3B
; 0005 04B3           if(E_D==1)
_0xA00CA:
	CPI  R18,1
	BRNE _0xA00CB
; 0005 04B4             strcatf(Alarm_Time,STR_0_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3C
; 0005 04B5 
; 0005 04B6           LCD_WR_STR(0,1,Alarm_Time);
_0xA00CB:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,391
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 04B7           Pointer=&H;
	CALL SUBOPT_0x42
; 0005 04B8           Locate=0;
	LDI  R30,LOW(0)
	STD  Y+6,R30
; 0005 04B9         }
; 0005 04BA         if(Alarm_ID==Alarm_8)
_0xA00C9:
	LDI  R30,LOW(_Alarm_8*2)
	LDI  R31,HIGH(_Alarm_8*2)
	LPM  R30,Z
	CP   R30,R21
	BRNE _0xA00CC
; 0005 04BB         {
; 0005 04BC           LCD_WR_STRF(0,0,"Set Alarm 8");
	CALL SUBOPT_0x10
	CALL SUBOPT_0x1A
	__POINTW2FN _0xA0000,165
	CALL SUBOPT_0x43
; 0005 04BD           Alarm_Read(&A,Alarm_ID);
; 0005 04BE           E_D = A.Enable_Disable;
; 0005 04BF           H   = A.Hour;
; 0005 04C0           M   = A.Minute;
; 0005 04C1           S   = A.Second;
; 0005 04C2           sprintf(str_S,DEC_Format,S);
; 0005 04C3           sprintf(str_M,DEC_Format,M);
	CALL SUBOPT_0x36
; 0005 04C4           sprintf(str_H,DEC_Format,H);
; 0005 04C5           Alarm_Time[0]='\0';
	CALL SUBOPT_0x37
; 0005 04C6           strcatf(Alarm_Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 04C7           strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 04C8           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 04C9           strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 04CA           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 04CB           strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 04CC           if(E_D==0)
	BRNE _0xA00CD
; 0005 04CD             strcatf(Alarm_Time,STR_0_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3B
; 0005 04CE           if(E_D==1)
_0xA00CD:
	CPI  R18,1
	BRNE _0xA00CE
; 0005 04CF             strcatf(Alarm_Time,STR_0_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3C
; 0005 04D0 
; 0005 04D1           LCD_WR_STR(0,1,Alarm_Time);
_0xA00CE:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,408
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 04D2           Pointer=&H;
	CALL SUBOPT_0x42
; 0005 04D3           Locate=0;
	LDI  R30,LOW(0)
	STD  Y+6,R30
; 0005 04D4         }
; 0005 04D5         if(Alarm_ID==Alarm_9)
_0xA00CC:
	LDI  R30,LOW(_Alarm_9*2)
	LDI  R31,HIGH(_Alarm_9*2)
	LPM  R30,Z
	CP   R30,R21
	BRNE _0xA00CF
; 0005 04D6         {
; 0005 04D7           LCD_WR_STRF(0,0,"Set Alarm 9");
	CALL SUBOPT_0x10
	CALL SUBOPT_0x1A
	__POINTW2FN _0xA0000,177
	CALL SUBOPT_0x43
; 0005 04D8           Alarm_Read(&A,Alarm_ID);
; 0005 04D9           E_D = A.Enable_Disable;
; 0005 04DA           H   = A.Hour;
; 0005 04DB           M   = A.Minute;
; 0005 04DC           S   = A.Second;
; 0005 04DD           sprintf(str_S,DEC_Format,S);
; 0005 04DE           sprintf(str_M,DEC_Format,M);
	CALL SUBOPT_0x36
; 0005 04DF           sprintf(str_H,DEC_Format,H);
; 0005 04E0           Alarm_Time[0]='\0';
	CALL SUBOPT_0x37
; 0005 04E1           strcatf(Alarm_Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 04E2           strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 04E3           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 04E4           strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 04E5           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 04E6           strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 04E7           if(E_D==0)
	BRNE _0xA00D0
; 0005 04E8             strcatf(Alarm_Time,STR_0_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3B
; 0005 04E9           if(E_D==1)
_0xA00D0:
	CPI  R18,1
	BRNE _0xA00D1
; 0005 04EA             strcatf(Alarm_Time,STR_0_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3C
; 0005 04EB 
; 0005 04EC           LCD_WR_STR(0,1,Alarm_Time);
_0xA00D1:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,425
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 04ED           Pointer=&H;
	CALL SUBOPT_0x42
; 0005 04EE           Locate=0;
	LDI  R30,LOW(0)
	STD  Y+6,R30
; 0005 04EF         }
; 0005 04F0         if(Alarm_ID==Alarm_10)
_0xA00CF:
	LDI  R30,LOW(_Alarm_10*2)
	LDI  R31,HIGH(_Alarm_10*2)
	LPM  R30,Z
	CP   R30,R21
	BRNE _0xA00D2
; 0005 04F1         {
; 0005 04F2           LCD_WR_STRF(0,0,"Set Alarm 10");
	CALL SUBOPT_0x10
	CALL SUBOPT_0x1A
	__POINTW2FN _0xA0000,189
	CALL SUBOPT_0x43
; 0005 04F3           Alarm_Read(&A,Alarm_ID);
; 0005 04F4           E_D = A.Enable_Disable;
; 0005 04F5           H   = A.Hour;
; 0005 04F6           M   = A.Minute;
; 0005 04F7           S   = A.Second;
; 0005 04F8           sprintf(str_S,DEC_Format,S);
; 0005 04F9           sprintf(str_M,DEC_Format,M);
	CALL SUBOPT_0x36
; 0005 04FA           sprintf(str_H,DEC_Format,H);
; 0005 04FB           Alarm_Time[0]='\0';
	CALL SUBOPT_0x37
; 0005 04FC           strcatf(Alarm_Time,STR_ONE_SHIFT);
	CALL SUBOPT_0x1E
; 0005 04FD           strcat(Alarm_Time,str_H);
	CALL SUBOPT_0x38
; 0005 04FE           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 04FF           strcat(Alarm_Time,str_M);
	CALL SUBOPT_0x39
; 0005 0500           strcatf(Alarm_Time,STR_TWO_DOT);
	CALL SUBOPT_0x20
; 0005 0501           strcat(Alarm_Time,str_S);
	CALL SUBOPT_0x3A
; 0005 0502           if(E_D==0)
	BRNE _0xA00D3
; 0005 0503             strcatf(Alarm_Time,STR_0_OFF);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3B
; 0005 0504           if(E_D==1)
_0xA00D3:
	CPI  R18,1
	BRNE _0xA00D4
; 0005 0505             strcatf(Alarm_Time,STR_0_ON);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x3C
; 0005 0506 
; 0005 0507           LCD_WR_STR(0,1,Alarm_Time);
_0xA00D4:
	CALL SUBOPT_0x13
	__POINTW2MN _0xA0068,442
	CALL SUBOPT_0x1
	CALL SUBOPT_0x23
; 0005 0508           Pointer=&H;
	CALL SUBOPT_0x42
; 0005 0509           Locate=0;
	LDI  R30,LOW(0)
	STD  Y+6,R30
; 0005 050A         }
; 0005 050B         break;
_0xA00D2:
	RJMP _0xA006E
; 0005 050C       }
; 0005 050D       case Key_OK:
_0xA00B5:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0xA00D5
; 0005 050E       {
; 0005 050F         A.Enable_Disable = E_D;
	__PUTBSR 18,42
; 0005 0510         A.Hour           = H;
	__PUTBSR 19,43
; 0005 0511         A.Minute         = M;
	__PUTBSR 16,44
; 0005 0512         A.Second         = S;
	__PUTBSR 17,45
; 0005 0513         Alarm_Save(A,Alarm_ID);
	__GETD1S 42
	CALL __PUTPARD1
	MOV  R26,R21
	RCALL _Alarm_Save
; 0005 0514         LCD_WR_STRF(0,1,"Save Alarm OK");
	CALL SUBOPT_0x13
	CALL SUBOPT_0x2B
	__POINTW2FN _0xA0000,202
	CALL SUBOPT_0x2C
; 0005 0515         delay_ms(1000);
; 0005 0516         LCD_WR_STRF(0,1,"");
	CALL SUBOPT_0x2B
	__POINTW2FN _0xA0000,16
	CALL _lcd_putsf
; 0005 0517         break;
	RJMP _0xA006E
; 0005 0518       }
; 0005 0519       case Key_Return:
_0xA00D5:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0xA00D7
; 0005 051A       {
; 0005 051B         T=0;
	LDI  R30,LOW(0)
	STD  Y+7,R30
; 0005 051C         break;
; 0005 051D       }
; 0005 051E       default:
_0xA00D7:
; 0005 051F       {
; 0005 0520         break;
; 0005 0521       }
; 0005 0522     }
_0xA006E:
; 0005 0523   }
	RJMP _0xA0069
_0xA006B:
; 0005 0524 }
	CALL __LOADLOCR6
	ADIW R28,46
	RET
; .FEND

	.DSEG
_0xA0068:
	.BYTE 0x1CB
;
;#include <string.h>
;#include "Alarm.h"
;#include "DS1307.h"
;
;
;const char  Alarm_1    = 8;
;const char  Alarm_2    = 12;
;const char  Alarm_3    = 16;
;const char  Alarm_4    = 20;
;const char  Alarm_5    = 24;
;const char  Alarm_6    = 28;
;const char  Alarm_7    = 32;
;const char  Alarm_8    = 36;
;const char  Alarm_9    = 40;
;const char  Alarm_10   = 44;
;
;void Alarm_Save(Alarm A,char ID)
; 0006 0012 {

	.CSEG
_Alarm_Save:
; .FSTART _Alarm_Save
; 0006 0013   RTC_DS1307_WR_DATA(ID,A.Enable_Disable);
	ST   -Y,R26
;	A -> Y+1
;	ID -> Y+0
	LD   R30,Y
	ST   -Y,R30
	LDD  R26,Y+2
	CALL _RTC_DS1307_WR_DATA
; 0006 0014   RTC_DS1307_WR_DATA(ID+1,A.Hour);
	LD   R30,Y
	SUBI R30,-LOW(1)
	ST   -Y,R30
	LDD  R26,Y+3
	CALL _RTC_DS1307_WR_DATA
; 0006 0015   RTC_DS1307_WR_DATA(ID+2,A.Minute);
	LD   R30,Y
	SUBI R30,-LOW(2)
	ST   -Y,R30
	LDD  R26,Y+4
	CALL _RTC_DS1307_WR_DATA
; 0006 0016   RTC_DS1307_WR_DATA(ID+3,A.Second);
	LD   R30,Y
	SUBI R30,-LOW(3)
	ST   -Y,R30
	LDD  R26,Y+5
	CALL _RTC_DS1307_WR_DATA
; 0006 0017 }
	RJMP _0x20E0005
; .FEND
;
;void Alarm_Read(Alarm *A,char ID)
; 0006 001A {
_Alarm_Read:
; .FSTART _Alarm_Read
; 0006 001B   A->Enable_Disable = RTC_DS1307_RD_DATA(ID);
	ST   -Y,R26
;	*A -> Y+1
;	ID -> Y+0
	LD   R26,Y
	CALL _RTC_DS1307_RD_DATA
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	ST   X,R30
; 0006 001C   A->Hour           = RTC_DS1307_RD_DATA(ID+1);
	LD   R26,Y
	SUBI R26,-LOW(1)
	CALL _RTC_DS1307_RD_DATA
	__PUTB1SNS 1,1
; 0006 001D   A->Minute         = RTC_DS1307_RD_DATA(ID+2);
	LD   R26,Y
	SUBI R26,-LOW(2)
	CALL _RTC_DS1307_RD_DATA
	__PUTB1SNS 1,2
; 0006 001E   A->Second         = RTC_DS1307_RD_DATA(ID+3);
	LD   R26,Y
	SUBI R26,-LOW(3)
	CALL _RTC_DS1307_RD_DATA
	__PUTB1SNS 1,3
; 0006 001F }
	JMP  _0x20E0003
; .FEND
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_put_buff_G100:
; .FSTART _put_buff_G100
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x2000010
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,4
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2000012
	__CPWRN 16,17,2
	BRLO _0x2000013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2000012:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
_0x2000013:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	TST  R31
	BRMI _0x2000014
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
_0x2000014:
	RJMP _0x2000015
_0x2000010:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2000015:
	LDD  R17,Y+1
	LDD  R16,Y+0
_0x20E0005:
	ADIW R28,5
	RET
; .FEND
__print_G100:
; .FSTART __print_G100
	ST   -Y,R27
	ST   -Y,R26
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2000016:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x2000018
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x200001C
	CPI  R18,37
	BRNE _0x200001D
	LDI  R17,LOW(1)
	RJMP _0x200001E
_0x200001D:
	CALL SUBOPT_0x44
_0x200001E:
	RJMP _0x200001B
_0x200001C:
	CPI  R30,LOW(0x1)
	BRNE _0x200001F
	CPI  R18,37
	BRNE _0x2000020
	CALL SUBOPT_0x44
	RJMP _0x20000CC
_0x2000020:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2000021
	LDI  R16,LOW(1)
	RJMP _0x200001B
_0x2000021:
	CPI  R18,43
	BRNE _0x2000022
	LDI  R20,LOW(43)
	RJMP _0x200001B
_0x2000022:
	CPI  R18,32
	BRNE _0x2000023
	LDI  R20,LOW(32)
	RJMP _0x200001B
_0x2000023:
	RJMP _0x2000024
_0x200001F:
	CPI  R30,LOW(0x2)
	BRNE _0x2000025
_0x2000024:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2000026
	ORI  R16,LOW(128)
	RJMP _0x200001B
_0x2000026:
	RJMP _0x2000027
_0x2000025:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x200001B
_0x2000027:
	CPI  R18,48
	BRLO _0x200002A
	CPI  R18,58
	BRLO _0x200002B
_0x200002A:
	RJMP _0x2000029
_0x200002B:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x200001B
_0x2000029:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x200002F
	CALL SUBOPT_0x45
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	LDD  R26,Z+4
	ST   -Y,R26
	CALL SUBOPT_0x46
	RJMP _0x2000030
_0x200002F:
	CPI  R30,LOW(0x73)
	BRNE _0x2000032
	CALL SUBOPT_0x45
	CALL SUBOPT_0x47
	CALL _strlen
	MOV  R17,R30
	RJMP _0x2000033
_0x2000032:
	CPI  R30,LOW(0x70)
	BRNE _0x2000035
	CALL SUBOPT_0x45
	CALL SUBOPT_0x47
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2000033:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x2000036
_0x2000035:
	CPI  R30,LOW(0x64)
	BREQ _0x2000039
	CPI  R30,LOW(0x69)
	BRNE _0x200003A
_0x2000039:
	ORI  R16,LOW(4)
	RJMP _0x200003B
_0x200003A:
	CPI  R30,LOW(0x75)
	BRNE _0x200003C
_0x200003B:
	LDI  R30,LOW(_tbl10_G100*2)
	LDI  R31,HIGH(_tbl10_G100*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x200003D
_0x200003C:
	CPI  R30,LOW(0x58)
	BRNE _0x200003F
	ORI  R16,LOW(8)
	RJMP _0x2000040
_0x200003F:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x2000071
_0x2000040:
	LDI  R30,LOW(_tbl16_G100*2)
	LDI  R31,HIGH(_tbl16_G100*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x200003D:
	SBRS R16,2
	RJMP _0x2000042
	CALL SUBOPT_0x45
	CALL SUBOPT_0x48
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2000043
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x2000043:
	CPI  R20,0
	BREQ _0x2000044
	SUBI R17,-LOW(1)
	RJMP _0x2000045
_0x2000044:
	ANDI R16,LOW(251)
_0x2000045:
	RJMP _0x2000046
_0x2000042:
	CALL SUBOPT_0x45
	CALL SUBOPT_0x48
_0x2000046:
_0x2000036:
	SBRC R16,0
	RJMP _0x2000047
_0x2000048:
	CP   R17,R21
	BRSH _0x200004A
	SBRS R16,7
	RJMP _0x200004B
	SBRS R16,2
	RJMP _0x200004C
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x200004D
_0x200004C:
	LDI  R18,LOW(48)
_0x200004D:
	RJMP _0x200004E
_0x200004B:
	LDI  R18,LOW(32)
_0x200004E:
	CALL SUBOPT_0x44
	SUBI R21,LOW(1)
	RJMP _0x2000048
_0x200004A:
_0x2000047:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x200004F
_0x2000050:
	CPI  R19,0
	BREQ _0x2000052
	SBRS R16,3
	RJMP _0x2000053
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LPM  R18,Z+
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x2000054
_0x2000053:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x2000054:
	CALL SUBOPT_0x44
	CPI  R21,0
	BREQ _0x2000055
	SUBI R21,LOW(1)
_0x2000055:
	SUBI R19,LOW(1)
	RJMP _0x2000050
_0x2000052:
	RJMP _0x2000056
_0x200004F:
_0x2000058:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x200005A:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x200005C
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x200005A
_0x200005C:
	CPI  R18,58
	BRLO _0x200005D
	SBRS R16,3
	RJMP _0x200005E
	SUBI R18,-LOW(7)
	RJMP _0x200005F
_0x200005E:
	SUBI R18,-LOW(39)
_0x200005F:
_0x200005D:
	SBRC R16,4
	RJMP _0x2000061
	CPI  R18,49
	BRSH _0x2000063
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x2000062
_0x2000063:
	RJMP _0x20000CD
_0x2000062:
	CP   R21,R19
	BRLO _0x2000067
	SBRS R16,0
	RJMP _0x2000068
_0x2000067:
	RJMP _0x2000066
_0x2000068:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2000069
	LDI  R18,LOW(48)
_0x20000CD:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x200006A
	ANDI R16,LOW(251)
	ST   -Y,R20
	CALL SUBOPT_0x46
	CPI  R21,0
	BREQ _0x200006B
	SUBI R21,LOW(1)
_0x200006B:
_0x200006A:
_0x2000069:
_0x2000061:
	CALL SUBOPT_0x44
	CPI  R21,0
	BREQ _0x200006C
	SUBI R21,LOW(1)
_0x200006C:
_0x2000066:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x2000059
	RJMP _0x2000058
_0x2000059:
_0x2000056:
	SBRS R16,0
	RJMP _0x200006D
_0x200006E:
	CPI  R21,0
	BREQ _0x2000070
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL SUBOPT_0x46
	RJMP _0x200006E
_0x2000070:
_0x200006D:
_0x2000071:
_0x2000030:
_0x20000CC:
	LDI  R17,LOW(0)
_0x200001B:
	RJMP _0x2000016
_0x2000018:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CALL __GETW1P
	CALL __LOADLOCR6
	ADIW R28,20
	RET
; .FEND
_sprintf:
; .FSTART _sprintf
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	CALL __SAVELOCR4
	CALL SUBOPT_0x49
	SBIW R30,0
	BRNE _0x2000072
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x20E0004
_0x2000072:
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	MOVW R16,R26
	CALL SUBOPT_0x49
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G100)
	LDI  R31,HIGH(_put_buff_G100)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R26,R28
	ADIW R26,10
	RCALL __print_G100
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x20E0004:
	CALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET
; .FEND

	.CSEG

	.DSEG

	.CSEG
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.DSEG

	.CSEG
__lcd_write_nibble_G102:
; .FSTART __lcd_write_nibble_G102
	ST   -Y,R26
	IN   R30,0x1B
	ANDI R30,LOW(0xF)
	MOV  R26,R30
	LD   R30,Y
	ANDI R30,LOW(0xF0)
	OR   R30,R26
	OUT  0x1B,R30
	__DELAY_USB 13
	SBI  0x1B,2
	__DELAY_USB 13
	CBI  0x1B,2
	__DELAY_USB 13
	RJMP _0x20E0001
; .FEND
__lcd_write_data:
; .FSTART __lcd_write_data
	ST   -Y,R26
	LD   R26,Y
	RCALL __lcd_write_nibble_G102
    ld    r30,y
    swap  r30
    st    y,r30
	LD   R26,Y
	RCALL __lcd_write_nibble_G102
	__DELAY_USB 133
	RJMP _0x20E0001
; .FEND
_lcd_gotoxy:
; .FSTART _lcd_gotoxy
	ST   -Y,R26
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G102)
	SBCI R31,HIGH(-__base_y_G102)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R26,R30
	RCALL __lcd_write_data
	LDD  R9,Y+1
	LDD  R8,Y+0
	ADIW R28,2
	RET
; .FEND
_lcd_clear:
; .FSTART _lcd_clear
	LDI  R26,LOW(2)
	CALL SUBOPT_0x4A
	LDI  R26,LOW(12)
	RCALL __lcd_write_data
	LDI  R26,LOW(1)
	CALL SUBOPT_0x4A
	LDI  R30,LOW(0)
	MOV  R8,R30
	MOV  R9,R30
	RET
; .FEND
_lcd_putchar:
; .FSTART _lcd_putchar
	ST   -Y,R26
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BREQ _0x2040005
	CP   R9,R11
	BRLO _0x2040004
_0x2040005:
	LDI  R30,LOW(0)
	ST   -Y,R30
	INC  R8
	MOV  R26,R8
	RCALL _lcd_gotoxy
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BRNE _0x2040007
	RJMP _0x20E0001
_0x2040007:
_0x2040004:
	INC  R9
	SBI  0x1B,0
	LD   R26,Y
	RCALL __lcd_write_data
	CBI  0x1B,0
	RJMP _0x20E0001
; .FEND
_lcd_puts:
; .FSTART _lcd_puts
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
_0x2040008:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x204000A
	MOV  R26,R17
	RCALL _lcd_putchar
	RJMP _0x2040008
_0x204000A:
	RJMP _0x20E0002
; .FEND
_lcd_putsf:
; .FSTART _lcd_putsf
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
_0x204000B:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x204000D
	MOV  R26,R17
	RCALL _lcd_putchar
	RJMP _0x204000B
_0x204000D:
_0x20E0002:
	LDD  R17,Y+0
_0x20E0003:
	ADIW R28,3
	RET
; .FEND
_lcd_init:
; .FSTART _lcd_init
	ST   -Y,R26
	IN   R30,0x1A
	ORI  R30,LOW(0xF0)
	OUT  0x1A,R30
	SBI  0x1A,2
	SBI  0x1A,0
	SBI  0x1A,1
	CBI  0x1B,2
	CBI  0x1B,0
	CBI  0x1B,1
	LDD  R11,Y+0
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G102,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G102,3
	LDI  R26,LOW(20)
	LDI  R27,0
	CALL _delay_ms
	CALL SUBOPT_0x4B
	CALL SUBOPT_0x4B
	CALL SUBOPT_0x4B
	LDI  R26,LOW(32)
	RCALL __lcd_write_nibble_G102
	__DELAY_USW 200
	LDI  R26,LOW(40)
	RCALL __lcd_write_data
	LDI  R26,LOW(4)
	RCALL __lcd_write_data
	LDI  R26,LOW(133)
	RCALL __lcd_write_data
	LDI  R26,LOW(6)
	RCALL __lcd_write_data
	RCALL _lcd_clear
_0x20E0001:
	ADIW R28,1
	RET
; .FEND

	.CSEG
_strcat:
; .FSTART _strcat
	ST   -Y,R27
	ST   -Y,R26
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strcat0:
    ld   r22,x+
    tst  r22
    brne strcat0
    sbiw r26,1
strcat1:
    ld   r22,z+
    st   x+,r22
    tst  r22
    brne strcat1
    movw r30,r24
    ret
; .FEND
_strcatf:
; .FSTART _strcatf
	ST   -Y,R27
	ST   -Y,R26
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strcatf0:
    ld   r22,x+
    tst  r22
    brne strcatf0
    sbiw r26,1
strcatf1:
	lpm  r0,z+
    st   x+,r0
    tst  r0
    brne strcatf1
    movw r30,r24
    ret
; .FEND
_strlen:
; .FSTART _strlen
	ST   -Y,R27
	ST   -Y,R26
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
; .FEND
_strlenf:
; .FSTART _strlenf
	ST   -Y,R27
	ST   -Y,R26
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret
; .FEND

	.CSEG

	.CSEG

	.CSEG

	.DSEG
_A1:
	.BYTE 0x4
_A2:
	.BYTE 0x4
_A3:
	.BYTE 0x4
_A4:
	.BYTE 0x4
_A5:
	.BYTE 0x4
_A6:
	.BYTE 0x4
_A7:
	.BYTE 0x4
_A8:
	.BYTE 0x4
_A9:
	.BYTE 0x4
_A10:
	.BYTE 0x4
__seed_G101:
	.BYTE 0x4
__base_y_G102:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x0:
	SUBI R16,-1
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(1)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 57 TIMES, CODE SIZE REDUCTION:277 WORDS
SUBOPT_0x1:
	CALL _lcd_puts
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(1)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	CALL _TWI_Stop
	LDI  R26,LOW(5)
	LDI  R27,0
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3:
	ST   -Y,R30
	LDD  R26,Y+1
	CALL _DEC_To_BCD
	MOV  R26,R30
	JMP  _RTC_DS1307_WR_DATA

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4:
	ST   -Y,R30
	LDD  R26,Y+2
	CALL _DEC_To_BCD
	MOV  R26,R30
	JMP  _RTC_DS1307_WR_DATA

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x5:
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_Hex_Format*2)
	LDI  R31,HIGH(_Hex_Format*2)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 27 TIMES, CODE SIZE REDUCTION:205 WORDS
SUBOPT_0x6:
	MOV  R30,R19
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x7:
	MOVW R30,R28
	ADIW R30,19
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_Hex_Format*2)
	LDI  R31,HIGH(_Hex_Format*2)
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R16
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_Hex_Format*2)
	LDI  R31,HIGH(_Hex_Format*2)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 27 TIMES, CODE SIZE REDUCTION:205 WORDS
SUBOPT_0x8:
	MOV  R30,R17
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x9:
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xA:
	CALL _strcat
	RJMP SUBOPT_0x9

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xB:
	LDI  R26,LOW(_STR_TWO_DOT*2)
	LDI  R27,HIGH(_STR_TWO_DOT*2)
	CALL _strcatf
	RJMP SUBOPT_0x9

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:49 WORDS
SUBOPT_0xC:
	MOVW R26,R28
	ADIW R26,24
	CALL _strcat
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:23 WORDS
SUBOPT_0xD:
	LDI  R26,LOW(_STR_20*2)
	LDI  R27,HIGH(_STR_20*2)
	JMP  _strcatf

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xE:
	LDI  R26,LOW(_STR_SLASH*2)
	LDI  R27,HIGH(_STR_SLASH*2)
	CALL _strcatf
	RJMP SUBOPT_0x9

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:23 WORDS
SUBOPT_0xF:
	CALL _strcat
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 43 TIMES, CODE SIZE REDUCTION:123 WORDS
SUBOPT_0x10:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(0)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x11:
	MOV  R30,R18
	LDI  R31,0
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x12:
	__POINTW2FN _0x40000,0
	CALL _lcd_putsf
	RJMP SUBOPT_0x10

;OPTIMIZER ADDED SUBROUTINE, CALLED 87 TIMES, CODE SIZE REDUCTION:255 WORDS
SUBOPT_0x13:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(1)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 20 TIMES, CODE SIZE REDUCTION:73 WORDS
SUBOPT_0x14:
	__POINTW2FN _0x60000,0
	CALL _lcd_putsf
	RJMP SUBOPT_0x13

;OPTIMIZER ADDED SUBROUTINE, CALLED 21 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0x15:
	CALL _lcd_putsf
	RJMP SUBOPT_0x13

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x16:
	__POINTW2FN _0x60000,16
	JMP  _lcd_putsf

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x17:
	LDI  R26,LOW(50)
	LDI  R27,0
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x18:
	LDI  R30,LOW(0)
	ST   Y,R30
	LDI  R30,LOW(1)
	STD  Y+1,R30
	CALL __SAVELOCR6
	LDI  R17,0
	LDI  R16,0
	LDI  R19,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x19:
	LDI  R30,LOW(0)
	STD  Y+8,R30
	RJMP SUBOPT_0x10

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:49 WORDS
SUBOPT_0x1A:
	__POINTW2FN _0xA0000,0
	CALL _lcd_putsf
	RJMP SUBOPT_0x10

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:29 WORDS
SUBOPT_0x1B:
	MOVW R30,R28
	ADIW R30,28
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_DEC_Format*2)
	LDI  R31,HIGH(_DEC_Format*2)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:101 WORDS
SUBOPT_0x1C:
	MOVW R30,R28
	ADIW R30,24
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_DEC_Format*2)
	LDI  R31,HIGH(_DEC_Format*2)
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R16
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	MOVW R30,R28
	ADIW R30,20
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_DEC_Format*2)
	LDI  R31,HIGH(_DEC_Format*2)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 385 TIMES, CODE SIZE REDUCTION:765 WORDS
SUBOPT_0x1D:
	MOVW R30,R28
	ADIW R30,8
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 49 TIMES, CODE SIZE REDUCTION:189 WORDS
SUBOPT_0x1E:
	LDI  R26,LOW(_STR_ONE_SHIFT*2)
	LDI  R27,HIGH(_STR_ONE_SHIFT*2)
	CALL _strcatf
	RJMP SUBOPT_0x1D

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:45 WORDS
SUBOPT_0x1F:
	MOVW R26,R28
	ADIW R26,22
	CALL _strcat
	RJMP SUBOPT_0x1D

;OPTIMIZER ADDED SUBROUTINE, CALLED 64 TIMES, CODE SIZE REDUCTION:249 WORDS
SUBOPT_0x20:
	LDI  R26,LOW(_STR_TWO_DOT*2)
	LDI  R27,HIGH(_STR_TWO_DOT*2)
	CALL _strcatf
	RJMP SUBOPT_0x1D

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:45 WORDS
SUBOPT_0x21:
	MOVW R26,R28
	ADIW R26,26
	CALL _strcat
	RJMP SUBOPT_0x1D

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x22:
	MOVW R26,R28
	ADIW R26,30
	RJMP SUBOPT_0xF

;OPTIMIZER ADDED SUBROUTINE, CALLED 53 TIMES, CODE SIZE REDUCTION:101 WORDS
SUBOPT_0x23:
	MOVW R26,R28
	ADIW R26,8
	JMP  _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x24:
	LDI  R26,LOW(250)
	LDI  R27,0
	CALL _delay_ms
	CALL _Keyboard_Get_Key
	MOV  R18,R30
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x25:
	MOVW R26,R20
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
	LDD  R30,Y+6
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x26:
	LDI  R30,LOW(0)
	STD  Y+8,R30
	LDD  R30,Y+6
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 28 TIMES, CODE SIZE REDUCTION:105 WORDS
SUBOPT_0x27:
	LDI  R26,LOW(_STR_SPACE*2)
	LDI  R27,HIGH(_STR_SPACE*2)
	CALL _strcatf
	RJMP SUBOPT_0x1D

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x28:
	MOVW R26,R20
	LD   R30,X
	SUBI R30,LOW(1)
	ST   X,R30
	LDD  R30,Y+6
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x29:
	LDI  R30,LOW(0)
	STD  Y+8,R30
	LDD  R30,Y+6
	SUBI R30,-LOW(1)
	STD  Y+6,R30
	LDD  R26,Y+6
	CPI  R26,LOW(0x3)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x2A:
	LDI  R30,LOW(0)
	STD  Y+8,R30
	LDD  R30,Y+6
	SUBI R30,LOW(1)
	STD  Y+6,R30
	LDD  R26,Y+6
	CPI  R26,LOW(0x3)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x2B:
	__POINTW2FN _0xA0000,0
	RJMP SUBOPT_0x15

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x2C:
	CALL _lcd_putsf
	LDI  R26,LOW(1000)
	LDI  R27,HIGH(1000)
	CALL _delay_ms
	RJMP SUBOPT_0x13

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2D:
	__POINTW2FN _0xA0000,16
	CALL _lcd_putsf
	LDI  R30,LOW(0)
	STD  Y+7,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:29 WORDS
SUBOPT_0x2E:
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_DEC_Format*2)
	LDI  R31,HIGH(_DEC_Format*2)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:101 WORDS
SUBOPT_0x2F:
	MOVW R30,R28
	ADIW R30,26
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_DEC_Format*2)
	LDI  R31,HIGH(_DEC_Format*2)
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R16
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	MOVW R30,R28
	ADIW R30,30
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_DEC_Format*2)
	LDI  R31,HIGH(_DEC_Format*2)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:45 WORDS
SUBOPT_0x30:
	MOVW R26,R28
	ADIW R26,32
	CALL _strcat
	RJMP SUBOPT_0x1D

;OPTIMIZER ADDED SUBROUTINE, CALLED 18 TIMES, CODE SIZE REDUCTION:65 WORDS
SUBOPT_0x31:
	LDI  R26,LOW(_STR_SLASH*2)
	LDI  R27,HIGH(_STR_SLASH*2)
	CALL _strcatf
	RJMP SUBOPT_0x1D

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:45 WORDS
SUBOPT_0x32:
	MOVW R26,R28
	ADIW R26,28
	CALL _strcat
	RJMP SUBOPT_0x1D

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x33:
	LDI  R26,LOW(20)
	MUL  R17,R26
	MOVW R30,R0
	SUBI R30,LOW(-_Week_Days*2)
	SBCI R31,HIGH(-_Week_Days*2)
	MOVW R26,R30
	JMP  _lcd_putsf

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x34:
	LDI  R26,LOW(250)
	LDI  R27,0
	CALL _delay_ms
	JMP  _Keyboard_Get_Key

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:20 WORDS
SUBOPT_0x35:
	__POINTW2FN _0xA0000,81
	CALL _lcd_putsf
	MOVW R30,R28
	ADIW R30,42
	ST   -Y,R31
	ST   -Y,R30
	MOV  R26,R21
	CALL _Alarm_Read
	LDD  R18,Y+42
	LDD  R19,Y+43
	LDD  R16,Y+44
	LDD  R17,Y+45
	MOVW R30,R28
	ADIW R30,36
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_DEC_Format*2)
	LDI  R31,HIGH(_DEC_Format*2)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:361 WORDS
SUBOPT_0x36:
	MOVW R30,R28
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_DEC_Format*2)
	LDI  R31,HIGH(_DEC_Format*2)
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R16
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	MOVW R30,R28
	ADIW R30,28
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_DEC_Format*2)
	LDI  R31,HIGH(_DEC_Format*2)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x37:
	LDI  R30,LOW(0)
	STD  Y+8,R30
	RJMP SUBOPT_0x1D

;OPTIMIZER ADDED SUBROUTINE, CALLED 27 TIMES, CODE SIZE REDUCTION:101 WORDS
SUBOPT_0x38:
	MOVW R26,R28
	ADIW R26,30
	CALL _strcat
	RJMP SUBOPT_0x1D

;OPTIMIZER ADDED SUBROUTINE, CALLED 27 TIMES, CODE SIZE REDUCTION:101 WORDS
SUBOPT_0x39:
	MOVW R26,R28
	ADIW R26,34
	CALL _strcat
	RJMP SUBOPT_0x1D

;OPTIMIZER ADDED SUBROUTINE, CALLED 27 TIMES, CODE SIZE REDUCTION:75 WORDS
SUBOPT_0x3A:
	MOVW R26,R28
	ADIW R26,38
	CALL _strcat
	CPI  R18,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 23 TIMES, CODE SIZE REDUCTION:41 WORDS
SUBOPT_0x3B:
	LDI  R26,LOW(_STR_0_OFF*2)
	LDI  R27,HIGH(_STR_0_OFF*2)
	JMP  _strcatf

;OPTIMIZER ADDED SUBROUTINE, CALLED 23 TIMES, CODE SIZE REDUCTION:41 WORDS
SUBOPT_0x3C:
	LDI  R26,LOW(_STR_0_ON*2)
	LDI  R27,HIGH(_STR_0_ON*2)
	JMP  _strcatf

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3D:
	LDD  R26,Y+40
	LDD  R27,Y+40+1
	LD   R26,X
	CPI  R26,LOW(0x3C)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:93 WORDS
SUBOPT_0x3E:
	MOVW R30,R28
	ADIW R30,36
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_DEC_Format*2)
	LDI  R31,HIGH(_DEC_Format*2)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3F:
	LDI  R26,LOW(_STR_1_OFF*2)
	LDI  R27,HIGH(_STR_1_OFF*2)
	JMP  _strcatf

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x40:
	LDI  R26,LOW(_STR_1_ON*2)
	LDI  R27,HIGH(_STR_1_ON*2)
	JMP  _strcatf

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x41:
	LDD  R26,Y+40
	LDD  R27,Y+40+1
	LDI  R30,LOW(0)
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x42:
	LDI  R30,LOW(19)
	LDI  R31,HIGH(19)
	STD  Y+40,R30
	STD  Y+40+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:101 WORDS
SUBOPT_0x43:
	CALL _lcd_putsf
	MOVW R30,R28
	ADIW R30,42
	ST   -Y,R31
	ST   -Y,R30
	MOV  R26,R21
	CALL _Alarm_Read
	LDD  R18,Y+42
	LDD  R19,Y+43
	LDD  R16,Y+44
	LDD  R17,Y+45
	RJMP SUBOPT_0x3E

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x44:
	ST   -Y,R18
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x45:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x46:
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x47:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x48:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x49:
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4A:
	CALL __lcd_write_data
	LDI  R26,LOW(3)
	LDI  R27,0
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x4B:
	LDI  R26,LOW(48)
	CALL __lcd_write_nibble_G102
	__DELAY_USW 200
	RET


	.CSEG
_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__MANDW12:
	CLT
	SBRS R31,7
	RJMP __MANDW121
	RCALL __ANEGW1
	SET
__MANDW121:
	AND  R30,R26
	AND  R31,R27
	BRTC __MANDW122
	RCALL __ANEGW1
__MANDW122:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD  R26,R28
	ADC  R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
